package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Application extends Viewport {

public final static byte ExitTypeNow = 0;
public final static byte ExitTypeSoon = 1;

public final static byte TimeFormat12H = 0;
public final static byte TimeFormat24H = 1;

public void destruct() {

	FrameworkGlobals.GetInstance().mFlPowerManager = null;

	
		FrameworkGlobals.GetInstance().mFlBrowser = null;
	FrameworkGlobals.GetInstance().mFlGameTimer = null;
	FrameworkGlobals.GetInstance().mFlEventQueue = null;
	FrameworkGlobals.GetInstance().mFlPenManager = null;
	FrameworkGlobals.GetInstance().mFlAccelerometer = null;
	mComponentWithFocus = null;

	





}


public final static byte StateActive = 0;
public final static byte StateSystemInterruption = 1;
public final static byte StateLostFocus = 2;
public final static byte StateInactive = 3;
public final static byte StateCount = 4;

public final static byte gameOrientationCurrent = 0x00;
public final static byte gameOrientation0 = 0x01;
public final static byte gameOrientation90 = 0x02;
public final static byte gameOrientation180 = 0x04;
public final static byte gameOrientation270 = 0x08;
public final static byte gameOrientationSystem = 0x10;

public final static byte softKeyPositionError = 0x00;
public final static byte softKeyPositionLeft = 0x01;
public final static byte softKeyPositionRight = 0x02;
public final static byte softKeyPositionBottom = 0x10;
public final static byte softKeyPositionTop = 0x20;
public final static byte softKeyPositionBottomLeft = 0x11;
public final static byte softKeyPositionBottomRight = 0x12;
public final static byte softKeyPositionTopLeft = 0x21;
public final static byte softKeyPositionTopRight = 0x22;

public final static byte defaultGamingKeyPrimary = 0;
public final static byte defaultGamingKeySecondary = 1;

public final static byte playViewDefault = 0;
public final static byte playViewDeck = 1;
public final static byte playViewGames = 2;
public final static byte playViewProfile = 3;
public final static byte playViewFriends = 4;
public final static byte playViewShowRoom = 5;
public final static byte playViewArena = 6;

public void FocusLost () {

	if(!GetIsSuspended())
	{
		Invalidate();
		SetIsSuspended(true);
		SetState(StateLostFocus);


		mAccelerometerWasEnabled = FlAccelerometer.Get().IsEnabled();
		FlAccelerometer.Get().Disable();
}

}


public void FocusGained () {

	if(GetIsSuspended())
	{

		ResetLastUserInputTime();
Invalidate();
		SetIsSuspended(false);
		SetState(StateActive);


		FlPenManager.Get().Reset();
if(mAccelerometerWasEnabled)
		{
			FlAccelerometer.Get().Enable();
		}
}

}


public boolean QuitRequest() {
 return  true; 
}


public void SaveGame() {
 
}


public void Suspend() {
 
}


public void Resume() {
 
}


public void MainThreadCallback() {
 
}


public void OnScreenSizeChange() {
 
}


public void OnMasterVolumeChange(short a13) {
 
}


public static Application GetInstance () {

	return FrameworkGlobals.GetInstance().application;

}


public static String GetJamdatBuildString () {

	
	 String hardcodedVersionString = new String(GetVersionString());


	














return  hardcodedVersionString;

	
}


public static void Kill () {

	
}


public static boolean MemoryCardWasRemoved () {

		return  false;
	
}


public static void Exit () {



ProcessExit();






{
		OSExit();
	}

}


public static void ProcessExit () {

	 Application application = Application.GetInstance();



if(!application.mExitProcessed)
	{


 Scene currentScene = application.mCurrentScene;

		if(currentScene != null)
		{
			currentScene.SendMsg(currentScene, quitTransitionMsg, -1);
		}

		application.mExitProcessed = true;
	}

}


public static boolean HasExited () {

	return  Application.GetInstance().mExitProcessed;

}


public static String GetTitle () {

		return  new String();
	
}


public static String GetDir () {

		return  new String();
	
}


public static String GetDataDir () {

		
			return  StringUtils.CreateString(FlAndroidApp.instance.getFilesDir().getAbsolutePath());
		


}


public static byte GetMajorVersion () {

	
		return  Constants.kApplicationMajorVersion;
	


}


public static byte GetMinorVersion () {

	
		return  Constants.kApplicationMinorVersion;
	


}


public static short GetBuildVersion () {

	
		return  Constants.kApplicationBuildVersion;
	


}


public static String GetVersionString () {

	 String pointString = new String(StringUtils.CreateString("."));

	 String version = new String(GetMajorVersion());

	version.AddAssign(pointString);
	version.AddAssign(new String(GetMinorVersion()));
	version.AddAssign(pointString);
	version.AddAssign(new String(GetBuildVersion()));
	return  version;

}


public static byte GetDemoFlag () {

	
		return  Constants.kApplicationDemoFlag;
	


}


public static byte GetLanguageFlag () {

	
		return  Constants.kApplicationLanguageFlag;
	


}


public static byte GetUserFlag () {

	
		return  Constants.kApplicationUserFlag;
	


}


public static String GetDeviceID () {

	return  GetPropertyValue(StringUtils.CreateString("DeviceID"));

}


public static String GetCarrierID () {

	return  GetPropertyValue(StringUtils.CreateString("CarrierID"));

}


public static String GetPlatformID () {

	return  StringUtils.CreateString("0");

}


public static String GetHardwareKeyString () {

	 String separator = new String(StringUtils.CreateString(","));

	 String carrierID = new String(GetCarrierID());


	if(carrierID.Equals(StringUtils.CreateString("9999"))) 
	{
		
		return  StringUtils.CreateString("1,2,390");
	}

	return  carrierID.Add(separator).Add(GetPlatformID()).Add(separator).Add(GetDeviceID());

}


public static short GetTCPPort () {

	return  (short)GetPropertyValue(StringUtils.CreateString("TCPPort")).ToLong();

}


public static String GetServerAddr () {

	return  GetPropertyValue(StringUtils.CreateString("ServerAddr"));

}


public static String GetPropertyValue ( String propertyName) {

	






		java.lang.String valueJavaStr = "NULL";
		java.util.Properties prop = new java.util.Properties();
		java.io.InputStream assetInputStream = null;

		try
		{
        	assetInputStream = FlAndroidApp.instance.getAssets().open("config.txt");
        	prop.load(assetInputStream);
        	valueJavaStr = prop.getProperty(StringUtils.CreateJavaString(propertyName));
        }
        catch (Exception e)
        {
        	;
        }

        if (valueJavaStr == null)
		{
			valueJavaStr = "NULL";
		}
		

		return  StringUtils.CreateString(valueJavaStr);

	



















































































}


public void SetOSWaitCursorVisible (boolean visible) {


	
}


public void SetDpadDisable (boolean active) {


	
}


public void SetDirty(boolean dirty) {
 mDirty = dirty; 
}


public boolean IsDirty() {
 return  mDirty; 
}


public void SendQuitRequestMsg () {

	SendMsg(this, quitRequestMsg, ExitTypeNow);

}


public void SetIsSuspended (boolean parIsSuspended) {

	if(isSuspended != parIsSuspended)
	{
		isSuspended = parIsSuspended;
		if(parIsSuspended)
		{
			OnSuspendFromOS();
		}
		else
		{
			OnResumeFromOS();
		}
	}

}


public boolean GetIsSuspended() {
 return  isSuspended; 
}


public void SetState (byte newState) {

	mState = newState;

}


public byte GetState() {
 return  mState; 
}


public boolean KeyIsDown (int translatedKey) {

	
		return  GetTranslatedKey((int)mKeyGroupState[mKeyMap[translatedKey]]) == translatedKey;
	


}


public void MapKey (int sourceKey, int translatedKeyOrGroup) {

	














ResetDownKeys();
	mKeyMap[sourceKey] = (short)translatedKeyOrGroup;

}


public void ResetDownKeys () {

	
		Memory.Set(mKeyGroupState, Key.UNDEFINED, Key.COUNT);
	mLastKeyDown = Key.UNDEFINED;
	


}


public int GetTranslatedKey (int physicalKey) {

	if(mKeyMap[physicalKey] != (short)Key.UNDEFINED)
	{
		physicalKey = (int)mKeyMap[physicalKey];
	}
	return  physicalKey;

}


public void UpdateSoftKey (int softKey, String label) {



	


}


public int GetDefaultGamingKey (byte actionKey, byte orientation) {




		return  Key.UNDEFINED;
	
}


public byte GetSoftKeyPosition (int softKey, byte orientation) {




		return  softKeyPositionError;
	
}


public boolean GetKeyAltMode () {

		

return  mGameAltLock || mFlightAltLock;
		
}


public boolean GetKeyShiftMode () {

		

return  mShiftModeActivated;
		
}


public boolean GetKeySymMode () {

		return  mSymModeActivated;
	
}


public boolean GetGameKeyAltMode() {
 return  mGameAltLock; 
}


public void SetGameKeyAltMode(boolean active) {
 mGameAltLock = active; 
}


public void ReturnToOSGameMenu () {

	


	
}


public int AsciiToFlightKey (int ascii) {

			switch(ascii)
			{
				case 8 : return  Key.BACKSPACE;           
				case 9 : return  Key.SPACE;               
				case (int)' ' : return  Key.SPACE;               
				case (int)'!' : return  Key.EXCLAMATION_MARK;    
				case (int)'"' : return  Key.DOUBLE_QUOTE;        
				case (int)'#' : return  Key.POUND;               
				case (int)'$' : return  Key.DOLLAR_SIGN;         
				case (int)'%' : return  Key.PERCENT_SIGN;        
				case (int)'&' : return  Key.AMPERSAND;           
				case (int)'\'' :return  Key.QUOTE;               
				case (int)'(' : return  Key.PARENTHESE_OPEN;     
				case (int)')' : return  Key.PARENTHESE_CLOSE;    
				case (int)'*' : return  Key.STAR;                
				case (int)'+' : return  Key.PLUS;                
				case (int)',' : return  Key.COMMA;               
				case (int)'-' : return  Key.MINUS;               
				case (int)'.' : return  Key.PERIOD;              
				case (int)'/' : return  Key.SLASH;               
				case (int)'0' : return  Key.DIGIT0;              
				case (int)'1' : return  Key.DIGIT1;              
				case (int)'2' : return  Key.DIGIT2;              
				case (int)'3' : return  Key.DIGIT3;              
				case (int)'4' : return  Key.DIGIT4;              
				case (int)'5' : return  Key.DIGIT5;              
				case (int)'6' : return  Key.DIGIT6;              
				case (int)'7' : return  Key.DIGIT7;              
				case (int)'8' : return  Key.DIGIT8;              
				case (int)'9' : return  Key.DIGIT9;              
				case (int)':' : return  Key.COLON;               
				case (int)';' : return  Key.SEMICOLON;           
				case (int)'<' : return  Key.LESSER;              
				case (int)'=' : return  Key.EQUAL;               
				case (int)'>' : return  Key.GREATER;             
				case (int)'?' : return  Key.QUESTION_MARK;       
				case (int)'@' : return  Key.AT_SIGN;             
				case (int)'A' : return  Key.UP_A;                
				case (int)'B' : return  Key.UP_B;                
				case (int)'C' : return  Key.UP_C;                
				case (int)'D' : return  Key.UP_D;                
				case (int)'E' : return  Key.UP_E;                
				case (int)'F' : return  Key.UP_F;                
				case (int)'G' : return  Key.UP_G;                
				case (int)'H' : return  Key.UP_H;                
				case (int)'I' : return  Key.UP_I;                
				case (int)'J' : return  Key.UP_J;                
				case (int)'K' : return  Key.UP_K;                
				case (int)'L' : return  Key.UP_L;                
				case (int)'M' : return  Key.UP_M;                
				case (int)'N' : return  Key.UP_N;                
				case (int)'O' : return  Key.UP_O;                
				case (int)'P' : return  Key.UP_P;                
				case (int)'Q' : return  Key.UP_Q;                
				case (int)'R' : return  Key.UP_R;                
				case (int)'S' : return  Key.UP_S;                
				case (int)'T' : return  Key.UP_T;                
				case (int)'U' : return  Key.UP_U;                
				case (int)'V' : return  Key.UP_V;                
				case (int)'W' : return  Key.UP_W;                
				case (int)'X' : return  Key.UP_X;                
				case (int)'Y' : return  Key.UP_Y;                
				case (int)'Z' : return  Key.UP_Z;                
				case (int)'[' : return  Key.BRACKET_OPEN;        
				case (int)'\\' :return  Key.BACKSLASH;           
				case (int)']' : return  Key.BRACKET_CLOSE;       
				case (int)'^' : return  Key.CARET;               
				case (int)'_' : return  Key.UNDERSCORE;          
				
				case (int)'a' : return  Key.A;                   
				case (int)'b' : return  Key.B;                   
				case (int)'c' : return  Key.C;                   
				case (int)'d' : return  Key.D;                   
				case (int)'e' : return  Key.E;                   
				case (int)'f' : return  Key.F;                   
				case (int)'g' : return  Key.G;                   
				case (int)'h' : return  Key.H;                   
				case (int)'i' : return  Key.I;                   
				case (int)'j' : return  Key.J;                   
				case (int)'k' : return  Key.K;                   
				case (int)'l' : return  Key.L;                   
				case (int)'m' : return  Key.M;                   
				case (int)'n' : return  Key.N;                   
				case (int)'o' : return  Key.O;                   
				case (int)'p' : return  Key.P;                   
				case (int)'q' : return  Key.Q;                   
				case (int)'r' : return  Key.R;                   
				case (int)'s' : return  Key.S;                   
				case (int)'t' : return  Key.T;                   
				case (int)'u' : return  Key.U;                   
				case (int)'v' : return  Key.V;                   
				case (int)'w' : return  Key.W;                   
				case (int)'x' : return  Key.X;                   
				case (int)'y' : return  Key.Y;                   
				case (int)'z' : return  Key.Z;                   
				case (int)'{' : return  Key.BRACE_OPEN;          
				case (int)'|' : return  Key.VERTICAL_BAR;        
				case (int)'}' : return  Key.BRACE_CLOSE;         
				case (int)'~' : return  Key.TILDE;               
				default : return  Key.UNDEFINED;
			}
		
}


public int ToFlightKey (int keyCode) {


			 int flightKey = KeyLayoutToFlightKey(keyCode);


			
			if(GetKeyShiftMode())
			{
				return  FlightKeyToUpper(flightKey);
			}
			else
			{
				return  flightKey;
			}
		
}


public void SetSingleKeyPress () {

	ResetDownKeys();
	for(short i = Key.UNDEFINED;i < Key.COUNT;i ++)
	{
		if(mKeyMap[i] == i)
		{
			mKeyMap[i] = Key.UNDEFINED;
		}
	}

}


public void SetMultiKeyPress () {

	ResetDownKeys();
	for(short i = Key.UNDEFINED;i < Key.COUNT;i ++)
	{
		if(mKeyMap[i] == Key.UNDEFINED)
		{
			mKeyMap[i] = i;
		}
	}

}


public boolean OnKeyFromOS (int physicalKey, boolean up) {

	

if(physicalKey == Key.UNDEFINED)
	{
		return  false;
	}

	
	if(physicalKey == Key.VOLUME_UP)
	{
		if(!up)
		{
			SoundManager.IncMasterVolume();
		}
		return  true;
	}
	else if(physicalKey == Key.VOLUME_DOWN)
	{
		if(!up)
		{
			SoundManager.DecMasterVolume();
		}
		return  true;
	}
	
	
		

		





switch(physicalKey)
		{
			case Key.ALT :
				

if(!up) ToggleKeyAltMode();
				return  false;

			case Key.SHIFT :
				

if(!up) ToggleKeyShiftMode();
				return  false;

			case Key.SYM :
				

if(!up) ToggleKeySymMode();
				return  false;
		}
	ResetLastUserInputTime();
	 int translatedKey = GetTranslatedKey(physicalKey);



	 int downMsg = keyDownMsg;

	 int upMsg = keyUpMsg;

	 int downOrRepeatMsg = keyDownOrRepeatMsg;


	
		 int exclusionGroup = (int)mKeyMap[translatedKey];

		 int lastKeyDown = (int)mKeyGroupState[exclusionGroup];

	















 Component componentWithFocus = mComponentWithFocus;

	if(up)
	{
	

















if(lastKeyDown == physicalKey)
		{
		
			mKeyGroupState[exclusionGroup] = Key.UNDEFINED;

			if(mLastKeyDown == physicalKey)
			{
				mLastKeyDown = Key.UNDEFINED;
			}
		






{

			componentWithFocus.SendMsg(componentWithFocus, upMsg, translatedKey);
			}

			


}
		else if(mIgnoreSecondKeyDown)
		{

			OnKeyFromOS(lastKeyDown, true);
		}
	}
	else if(lastKeyDown != Key.UNDEFINED) 
	{
		
		
		
		if((exclusionGroup == Key.UNDEFINED) || (GetTranslatedKey(lastKeyDown) != translatedKey))
		{


			OnKeyFromOS(lastKeyDown, true);

			if(!mIgnoreSecondKeyDown)
			{
				OnKeyFromOS(physicalKey, false);
			}
		}
	}
	else 
	{
		
			mKeyGroupState[exclusionGroup] = (short)physicalKey;
		mLastKeyDown = physicalKey;
			mKeyRepeatTime = 0x7FFFFFFF;
			
		{

			componentWithFocus.SendMsg(componentWithFocus, downMsg, translatedKey);
		}

		
		if(mComponentWithFocus == componentWithFocus)
		{
			

{

			componentWithFocus.SendMsg(componentWithFocus, downOrRepeatMsg, translatedKey);
			}

			


}
	}

	return  true;

}


public void SendKeyUpToLastKeyDown () {

	

		for(int i = Key.UNDEFINED;i < Key.COUNT;i ++)
		{
			OnKeyFromOS((int)mKeyGroupState[i], true);
		}

	





}


public void SetIgnoreSecondKeyDown(boolean ignoreSecondKeyDown) {
 mIgnoreSecondKeyDown = ignoreSecondKeyDown; 
}


public boolean IsNativeResolution (int width, int height) {

	 Vector2_short screenSize = new Vector2_short(GetSize());






return  screenSize.GetX() == width && screenSize.GetY() == height;

}


public void OnScreenSizeChangedFromOS (int newWidth, int newHeight, boolean forwardToApplication, boolean windowSizeChanged) {



	 Vector2_short curScreenSize = new Vector2_short(GetSize());

	if(newWidth == curScreenSize.GetX() && newHeight == curScreenSize.GetY())
	{
		return ;
	}

	
	 VideoMode vm = DisplayManager.GetMainDisplayContext().GetVideoMode();
	 VideoMode currentResVideoMode = new VideoMode(newWidth, newHeight, vm.GetBpp());


	
	 VideoMode currentWindowVideoMode = new VideoMode(DisplayManager.GetInstance().GetWindowVideoMode());

	if(windowSizeChanged)
	{
		currentWindowVideoMode.SetWidth(newWidth);
		currentWindowVideoMode.SetHeight(newHeight);
	}

	
	DisplayManager.GetInstance().Initialize(currentWindowVideoMode, currentResVideoMode, true);

	
    SetSize((short)newWidth, (short)newHeight);

	

FlAndroidApp.instance.mScene.UpdateDisplayContext(newWidth, newHeight);
		

if(forwardToApplication && !GetIsSuspended())
	{

		OnScreenSizeChange();	
	}

	


}


public int GetAllowedOrientations () {


		return  gameOrientationCurrent;
	
}


public int GetAllowedNativeOrientations () {


		return  gameOrientationCurrent;
	
}


public byte GetCurrentGameOrientation () {

		

return  gameOrientationCurrent;
		
}


public boolean SetGameOrientation (byte gameOrientation) {

		





































		return  true;
	
}


public boolean GetIsSystemSelectedOrientation () {


	    return  true;
	
}


public void StartUpCheck () {


	
}


public boolean IsStartUpCheckCompleted () {


		return  true;
	
}


public void SetEnableIGN (boolean val) {



	
}


public boolean IsIGNActive () {


		return  false;
	
}


public void HideIGN () {


	
}


public void SwitchToPlay (byte playView) {



	
}


public void RequestMainThreadCallback () {

	


MainThreadCallback();
	
}


public void SetCurrentFocus (Component newFocus) {




	newFocus = newFocus.ForwardFocus();
	 Component oldFocus = mComponentWithFocus;
	mComponentWithFocus = newFocus;

	MoveFocusForNotifications(oldFocus, newFocus, newFocus.GetDepth() - oldFocus.GetDepth());

}


public Component GetCurrentFocus () {

	return  mComponentWithFocus;

}


public void OnSuspendFromOS () {



	

ReleaseAllInput();

	mSuspendedResolution.Assign(GetSize());

	

Suspend();

}


public void OnResumeFromOS () {



	

{
		




if(!IsNativeResolution(mSuspendedResolution.GetX(), mSuspendedResolution.GetY()))
			{

				
				OnScreenSizeChange();
			}
			Resume();
		}
	
}


public void ReleaseAllInput () {

	

		SendKeyUpToLastKeyDown();

	







FrameworkGlobals.GetInstance().penTracker.ReleasePen();
	
}


public void ResetLastUserInputTime() {
 mLastUserInputTime = GetRealTime(); 
}


public int GetDeltaTimeSinceLastUserInput() {
 return  GetRealTime() - mLastUserInputTime;	
}


public byte GetTimeFormat () {

	return  TimeFormat24H;

}


public int GetUserCount () {

	return  0;

}


public String GetUserName (int index) {


	return  StringUtils.CreateString("");

}


public boolean DeleteUser (int index) {


	return  true;

}


public boolean RenameUser (int index, String username) {



	return  true;

}


public int AddUser (String username) {


	return  0;

}


public TimeData GetUserCreationDate (int index) {


	TimeData creationDate = new TimeData();

	return  creationDate;

}


public int GetUserId (int index) {


	return  0;

}


public int GetUserIndex (int userId) {


	return  0;

}


public boolean IsUserValid (int userId) {


	return  true;

}


public void OnTime (int a18, int a17) {













}


public static TimeSystem GetGlobalTimeSystem() {
 return  GetInstance().mApplicationTimeSystem;
	
}


public static int GetRealTime () {

	
		
		























return (int) System.currentTimeMillis();
		
	


}


public void Iteration (int totalTime, int delta) {



	

 int lastKeyDown = mLastKeyDown;

	 int keyRepeatTime = mKeyRepeatTime;


	if(lastKeyDown != Key.UNDEFINED)
	{
		if(keyRepeatTime == 0x7FFFFFFF)
		{
			keyRepeatTime = -(500- 150);
		}
		else
		{
			keyRepeatTime += delta;
			if(keyRepeatTime > 150)
			{

				mComponentWithFocus.SendMsg(mComponentWithFocus, keyDownOrRepeatMsg, GetTranslatedKey(lastKeyDown));
				keyRepeatTime = 0;
			}
		}
	}

	mKeyRepeatTime = keyRepeatTime;

	






















{
		mApplicationTimeSystem.OnTime(totalTime, delta);
	}


	



}


public boolean IsOnScreenKeyboardEnabled () {


	return  false;



}


public void EnableOnScreenKeyboard (boolean enable) {


	
}


public long GetCycleNumber() {
 return  0;
	
}


public String[] GetCommandLineArgs() {
 return  null; 
}


public int GetCommandLineArgsCount() {
 return  0; 
}


public  Application () {
mState = (StateActive);
mDirty = (true);
mLastKeyDown = (Key.UNDEFINED);
mIgnoreSecondKeyDown = (true);
mCurrentTransitionType = ((byte)Scene.noTransition);
mLastUserInputTime = (GetRealTime());
mGameAltLock = (true);
mSuspendedResolution = new Vector2_short();
mApplicationTimeSystem = new TimeSystem();


	




	FrameworkGlobals.GetInstance().application = this;

	mComponentWithFocus = this;
	 FlRect screenRect = DisplayManager.GetVideoModeRect();
	SetRect(screenRect.GetLeft(), screenRect.GetTop(), screenRect.GetWidth(), screenRect.GetHeight());

	
		FrameworkGlobals.GetInstance().penTracker = this;
	MapKey(Key.BACK, Key.CLEAR);
	MapKey(Key.BACKSPACE, Key.CLEAR);
	
		MapKey(Key.ENTER, Key.SELECT);
	MapKey(Key.FIRE, Key.SELECT);
		MapKey(Key.SOFT_SELECT, Key.SELECT);
		MapKey(Key.SOFT_CLEAR, Key.CLEAR);
	
}


public Scene GetCurrentScene() {
 return  mCurrentScene; 
}


public boolean IsInSceneTransition () {

	return  mCurrentTransitionType != Scene.noTransition;

}


public static void OSExit () {

		

FlAndroidApp.instance.Exit();
		


}


public static void MoveFocusForNotifications (Component oldFocus, Component newFocus, int newDepthMinusOldDepth) {

	if(oldFocus == newFocus) return ;

	 int newDepthDifference = newDepthMinusOldDepth;

	 Component enteringComponent = null;

	if(newDepthMinusOldDepth <= 0)
	{
		oldFocus.OnFocusChange(false);
		oldFocus = oldFocus.GetViewport();
		newDepthDifference++;

		if(oldFocus == newFocus)
		{
			newFocus.OnFocusChange(true);
		}
	}
	if(newDepthMinusOldDepth >= 0)
	{
		enteringComponent = newFocus; 
		newFocus = newFocus.GetViewport();
		newDepthDifference--;
	}
	MoveFocusForNotifications(oldFocus, newFocus, newDepthDifference);
	if(enteringComponent != null) enteringComponent.OnFocusChange(true);

}


public boolean isSuspended;
public byte mState;
public Vector2_short mSuspendedResolution;
public boolean mDirty;
public boolean mExitProcessed;
public TimeSystem mApplicationTimeSystem;
public int mLastKeyDown;
public short[] mKeyMap = new short[Key.COUNT];

public int mKeyRepeatTime;
public boolean mIgnoreSecondKeyDown;
public int FlightKeyToUpper (int flightKey) {

			switch(flightKey)
			{
				case Key.A : return  Key.UP_A;
				case Key.B : return  Key.UP_B;
				case Key.C : return  Key.UP_C;
				case Key.D : return  Key.UP_D;
				case Key.E : return  Key.UP_E;
				case Key.F : return  Key.UP_F;
				case Key.G : return  Key.UP_G;
				case Key.H : return  Key.UP_H;
				case Key.I : return  Key.UP_I;
				case Key.J : return  Key.UP_J;
				case Key.K : return  Key.UP_K;
				case Key.L : return  Key.UP_L;
				case Key.M : return  Key.UP_M;
				case Key.N : return  Key.UP_N;
				case Key.O : return  Key.UP_O;
				case Key.P : return  Key.UP_P;
				case Key.Q : return  Key.UP_Q;
				case Key.R : return  Key.UP_R;
				case Key.S : return  Key.UP_S;
				case Key.T : return  Key.UP_T;
				case Key.U : return  Key.UP_U;
				case Key.V : return  Key.UP_V;
				case Key.W : return  Key.UP_W;
				case Key.X : return  Key.UP_X;
				case Key.Y : return  Key.UP_Y;
				case Key.Z : return  Key.UP_Z;

				













default : return  flightKey;
			}
		
}


public int KeyLayoutToFlightKey (int keyCode) {

			
			if(GetKeyAltMode())
			{
				
				 int lowercaseKey = keyCode;

				if((lowercaseKey >= (int)'A') && (lowercaseKey <= (int)'Z'))
				{
					lowercaseKey = lowercaseKey - (int)'A' + (int)'a';
				}

				switch(lowercaseKey)
				{
					






























}
			}

			if(GetKeySymMode())
			{
				switch(keyCode)
				{
					





}
			}

			if(keyCode == SpecConstants.KeyCodeEnter)	return  Key.ENTER;
			else if(keyCode == SpecConstants.KeyCodeAlt)		return  Key.ALT;
			else if(keyCode == SpecConstants.KeyCodeCaps)		return  Key.SHIFT;
			else if(keyCode == SpecConstants.KeyCodeShift)	return  Key.SHIFT;
			else if(keyCode == SpecConstants.KeyCodeMenu)		return  Key.MENU;

			
			switch(keyCode)
			{
				









































}

			
			 int flightKeyFromAscii = AsciiToFlightKey(keyCode);

			if(flightKeyFromAscii != Key.UNDEFINED)
			{
				return  flightKeyFromAscii;
			}

			

































return  Key.UNDEFINED;
		
}


public void ToggleKeyShiftMode() {
 mShiftModeActivated = !mShiftModeActivated; 
}


public void ToggleKeyAltMode() {
 mFlightAltLock = !mFlightAltLock; 
}


public void ToggleKeySymMode() {
 mSymModeActivated = !mSymModeActivated; 
}


public short[] mKeyGroupState = new short[Key.COUNT];

public Component mComponentWithFocus;
public Scene mCurrentScene;
public byte mCurrentTransitionType;
public int mLastUserInputTime;
public boolean mGameAltLock;
public boolean mFlightAltLock;
public boolean mSymModeActivated;
public boolean mShiftModeActivated;
public boolean mAccelerometerWasEnabled;
public int GetDefaultGamingKey(byte actionKey)
{
	return GetDefaultGamingKey(actionKey, gameOrientationCurrent);
}
public byte GetSoftKeyPosition(int softKey)
{
	return GetSoftKeyPosition(softKey, gameOrientationCurrent);
}
public void OnScreenSizeChangedFromOS(int newWidth, int newHeigth)
{
	OnScreenSizeChangedFromOS(newWidth, newHeigth, true);
}
public void OnScreenSizeChangedFromOS(int newWidth, int newHeigth, boolean forwardToApplication)
{
	OnScreenSizeChangedFromOS(newWidth, newHeigth, forwardToApplication, true);
}

/* One dimension array */
public static Application[] InstArrayApplication(int size) {
	Application[] newArray = new Application[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Application();
	return newArray; }

/* Two dimension array */
public static Application[][] InstArrayApplication(int size1, int size2) {
	Application[][] newArray = new Application[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Application[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Application(); }
	return newArray; }

/* Three dimension array */
public static Application[][][] InstArrayApplication(int size1, int size2, int size3) {
	Application[][][] newArray = new Application[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Application[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Application[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Application(); } }
	return newArray; }



}

