package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 1


public class Array_int {

public static Array_int Cast(Object o, Array_int _) {
 return  (Array_int)o; 
}


 final public static byte typeNumber = TypeIDOfType_Array_int.v;
 final public static byte typeID = TypeIDOfType_Array_int.w;
 public static final boolean supportsDynamicSerialization = false; public  Array_int () {
mDelta = (32);


	


}


public  Array_int (int inCapacity, int inDelta) {
mDelta = (inDelta);


	if(inCapacity != 0)
	{
		mElements = new int[inCapacity];
	}

	


}


public  Array_int ( Array_int array) {
mDelta = (32);


	 Array_int me = this;
	me.Assign(array);

}


public void destruct() {

	mElements = null;

    mElementCount = 0;




}


public Array_int Assign ( Array_int array) {

	mElementCount = 0;



mDelta = array.mDelta;

	mElements = null;

	if(array.GetCapacity() > 0)
	{
		mElements = new int[array.GetCapacity()];
	}

	for(int i = 0;i < array.End();++i)
	{
		mElements[i] = array.GetAt(i);
		mElementCount++;
	}

	return this;

}


public void Clear () {

	mElementCount = 0;

}


public int Find ( int c) {

	int i;


	for(i = 0;i < mElementCount;++i)
	{
		if(mElements[i] == c)
		{
			return  i;
		}
	}

	return  -1;

}


public int Start () {

	return  0;

}


public int End () {

	return  mElementCount;

}


public int Size () {

	return  End() - Start();

}


public boolean IsEmpty () {

	return  (mElementCount == 0);

}


public void SetAt ( int element, int p) {


	mElements[p] = element;

}


public int GetAt(int p) {

		return  mElements[p];
	
}


public int Insert ( int element) {

	 int elementCount = mElementCount;

	 int newElementCount = elementCount + 1;

	EnsureCapacity(newElementCount);
	mElements[elementCount] = element;
	mElementCount = newElementCount;
	return  elementCount;

}


public void InsertAt ( int element, int p) {

	if(p < 0|| p > mElementCount)
	{
		return ;
	}

	EnsureCapacity(mElementCount + 1);

	for(int i = mElementCount;i > p;--i)
	{
		mElements[i] = mElements[i - 1];
	}

	++mElementCount;

	mElements[p] = element;

}


public void Remove ( int element) {

	 int pos = Find(element);


	if(pos >= 0)
	{
		RemoveAt(pos);
	}

}


public void RemoveAt (int p) {

	if(p < 0|| p >= mElementCount)
	{
		return ;
	}

	if(mElementCount > 0)
	{
		--mElementCount;
	}

	int i;


	for(i = p;i < mElementCount;++i)
	{
		mElements[i] = mElements[i + 1];
	}

}


public boolean MoveToEnd ( int element) {

	int i;

	int tmp;

	 int pos = Find(element);


	if(pos < 0)
	{
		return  false; 
	}
	tmp = mElements[pos];

	for(i = pos;i <(mElementCount - 1);++i)
	{
		mElements[i] = mElements[i + 1];
	}

	mElements[mElementCount-1] = tmp;
	return  true;

}


public void SetSize (int inNewSize) {

	EnsureCapacity(inNewSize);
	mElementCount = inNewSize;

}


public void EnsureCapacity (int inNewSize) {

	 int currentCapacity = GetCapacity();

	if(currentCapacity >= inNewSize)
	{
		return ;
	}


	
	if(inNewSize - currentCapacity < mDelta)
	{
		inNewSize = currentCapacity + mDelta; 
	}

	 int[] newElements = new int[inNewSize];

	for(int i = 0;i < mElementCount;++i)
	{
		newElements[i] = mElements[i];
	}

	mElements = newElements;;	




}


public int GetCapacity () {


	
	return mElements == null ? 0 : mElements.length;
	



}


public void OnSerializeIntrinsics (Package _package) {
	
	
	
	//#if INST_FROM_PRIMITIVE == 1
	
	{
		(mElementCount)= (_package).SerializeIntrinsic(mElementCount);		


(mElements)= (_package).SerializeIntrinsics(mElements, mElementCount);


}
	






	//#endif
	
	
}


public void OnSerializeObjects (Package _package) {

	
	
	//#if INST_FROM_PRIMITIVE == 0
	
	{
		 int count = 0;

		(count)= (_package).SerializeIntrinsic(count);

		Clear();
		EnsureCapacity(count);

		for(short i = 0;i < count;++i)
		{
			 int data = int();

			(data).OnSerialize(_package);
			Insert(data);
		}










	}
	











	//#endif
	
	
}


public void OnSerialize(Package _package) {
 
		//#if INST_FROM_PRIMITIVE == 1
		
		OnSerializeIntrinsics(_package);
		
		//#else
		
		OnSerializeObjects(_package);
		
		//#endif
		
		



}


public int[] GetData() {

		return  mElements;
	
}


public int[] mElements = null;
public int mElementCount;
public int mDelta;

/* One dimension array */
public static Array_int[] InstArrayArray_int(int size) {
	Array_int[] newArray = new Array_int[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Array_int();
	return newArray; }

/* Two dimension array */
public static Array_int[][] InstArrayArray_int(int size1, int size2) {
	Array_int[][] newArray = new Array_int[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Array_int[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Array_int(); }
	return newArray; }

/* Three dimension array */
public static Array_int[][][] InstArrayArray_int(int size1, int size2, int size3) {
	Array_int[][][] newArray = new Array_int[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Array_int[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Array_int[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Array_int(); } }
	return newArray; }



}

