package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class Box1t_F32 {

public F32 minCorner;
public F32 maxCorner;
public Box1t_F32 () {
minCorner = new F32();
maxCorner = new F32();


}


public  Box1t_F32 ( Box1t_F32 other) {
minCorner = new F32(other.minCorner);
maxCorner = new F32(other.maxCorner);



}


public  Box1t_F32 (F32 parMin, F32 parMax) {
minCorner = new F32(parMin);
maxCorner = new F32(parMax);



}


public F32 Size () {

	return  maxCorner.Sub(minCorner);

}


public void Scale (F32 scaleFactor) {

	minCorner = minCorner.Mul(scaleFactor, 16);
	maxCorner = maxCorner.Mul(scaleFactor, 16);

}


public boolean Contains (F32 point) {

	return  point.GreaterOrEqual(minCorner) && point.LessThan(maxCorner);

}


public boolean Contains ( Box1t_F32 box1) {

	return  box1.minCorner.GreaterOrEqual(minCorner) && box1.maxCorner.LessOrEqual(maxCorner);

}


public Box1t_F32 Add (F32 shift) {

	return  new Box1t_F32(minCorner.Add(shift), maxCorner.Add(shift));

}


public Box1t_F32 Sub (F32 shift) {

	return  new Box1t_F32(minCorner.Sub(shift), maxCorner.Sub(shift));

}


public Box1t_F32 AddAssign (F32 shift) {

	minCorner = minCorner.Add(shift);
	maxCorner = maxCorner.Add(shift);
	return this;

}


public Box1t_F32 SubAssign (F32 shift) {

	minCorner = minCorner.Sub(shift);
	maxCorner = maxCorner.Sub(shift);
	return this;

}


public boolean Empty () {

	return  (minCorner.GreaterOrEqual(maxCorner));

}


public void ExpandToInclude ( Box1t_F32 boxToInclude) {

	if(boxToInclude.maxCorner.GreaterThan(maxCorner)) maxCorner = boxToInclude.maxCorner;
	if(boxToInclude.minCorner.LessThan(minCorner)) minCorner = boxToInclude.minCorner;

}


public void ClipOn ( Box1t_F32 boxToClipOn) {

	if(boxToClipOn.maxCorner.LessThan(maxCorner)) maxCorner = boxToClipOn.maxCorner;
	if(boxToClipOn.minCorner.GreaterThan(minCorner)) minCorner = boxToClipOn.minCorner;

}


public Box1t_F32 ClippedOn ( Box1t_F32 boxToClipOn) {

	 Box1t_F32 returnedBox = new Box1t_F32(this);

	returnedBox.ClipOn(boxToClipOn);
	return  returnedBox;

}


public Box1t_F32 LessBorder (F32 borderToRemoveOnEachSide) {

	return  new Box1t_F32(minCorner.Add(borderToRemoveOnEachSide), maxCorner.Sub(borderToRemoveOnEachSide));

}


public static Box1t_F32 Round ( Box1t_F32 box) {

	return  new Box1t_F32(box.minCorner.Round(16), box.maxCorner.Round(16));

}


public static Box1t_F32 Float ( Box1t_F32 box) {

	return  new Box1t_F32(box.minCorner, box.maxCorner);

}



/* One dimension array */
public static Box1t_F32[] InstArrayBox1t_F32(int size) {
	Box1t_F32[] newArray = new Box1t_F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Box1t_F32();
	return newArray; }

/* Two dimension array */
public static Box1t_F32[][] InstArrayBox1t_F32(int size1, int size2) {
	Box1t_F32[][] newArray = new Box1t_F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Box1t_F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Box1t_F32(); }
	return newArray; }

/* Three dimension array */
public static Box1t_F32[][][] InstArrayBox1t_F32(int size1, int size2, int size3) {
	Box1t_F32[][][] newArray = new Box1t_F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Box1t_F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Box1t_F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Box1t_F32(); } }
	return newArray; }



}

