package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class Box2t_F32 {

public FVec2T_F32 minCorner;
public FVec2T_F32 maxCorner;
public Box2t_F32 () {
minCorner = new FVec2T_F32();
maxCorner = new FVec2T_F32();


}


public  Box2t_F32 ( Box2t_F32 other) {
minCorner = new FVec2T_F32(other.minCorner);
maxCorner = new FVec2T_F32(other.maxCorner);



}


public  Box2t_F32 ( FVec2T_F32 parMin, FVec2T_F32 parMax) {
minCorner = new FVec2T_F32(parMin);
maxCorner = new FVec2T_F32(parMax);



}


public FVec2T_F32 Size () {

	return  maxCorner.Sub(minCorner);

}


public F32 XSize () {

	return  maxCorner.x.Sub(minCorner.x);

}


public F32 YSize () {

	return  maxCorner.y.Sub(minCorner.y);

}


public Box1t_F32 BoxInX () {

  return  new Box1t_F32(minCorner.x, maxCorner.x);

}


public Box1t_F32 BoxInY () {

  return  new Box1t_F32(minCorner.y, maxCorner.y);

}


public void ScaleX (F32 scaleFactor) {

	minCorner.x = minCorner.x.Mul(scaleFactor, 16);
	maxCorner.x = maxCorner.x.Mul(scaleFactor, 16);

}


public void ScaleY (F32 scaleFactor) {

	minCorner.y = minCorner.y.Mul(scaleFactor, 16);
	maxCorner.y = maxCorner.y.Mul(scaleFactor, 16);

}


public boolean Contains ( FVec2T_F32 point) {

	return  point.x.GreaterOrEqual(minCorner.x) && point.x.LessThan(maxCorner.x) && point.y.GreaterOrEqual(minCorner.y) && point.y.LessThan(maxCorner.y);

}


public boolean Contains ( Box2t_F32 box2) {

	return  box2.minCorner.x.GreaterOrEqual(minCorner.x) && box2.maxCorner.x.LessOrEqual(maxCorner.x) && box2.minCorner.y.GreaterOrEqual(minCorner.y) && box2.maxCorner.y.LessOrEqual(maxCorner.y);

}


public boolean Equals ( Box2t_F32 box2) {

	return  (minCorner.Equals(box2.minCorner) && maxCorner.Equals(box2.maxCorner));

}


public Box2t_F32 Add ( FVec2T_F32 shift) {

	return  new Box2t_F32(minCorner.Add(shift), maxCorner.Add(shift));

}


public Box2t_F32 Sub ( FVec2T_F32 shift) {

	return  new Box2t_F32(minCorner.Sub(shift), maxCorner.Sub(shift));

}


public Box2t_F32 AddAssign ( FVec2T_F32 shift) {

	minCorner.AddAssign(shift);
	maxCorner.AddAssign(shift);
	return this;

}


public Box2t_F32 SubAssign ( FVec2T_F32 shift) {

	minCorner.SubAssign(shift);
	maxCorner.SubAssign(shift);
	return this;

}


public boolean Empty () {

	return  (minCorner.x.GreaterOrEqual(maxCorner.x)) || (minCorner.y.GreaterOrEqual(maxCorner.y));

}


public void ExpandToInclude ( Box2t_F32 boxToInclude) {

	if(boxToInclude.maxCorner.x.GreaterThan(maxCorner.x)) maxCorner.x = boxToInclude.maxCorner.x;
	if(boxToInclude.maxCorner.y.GreaterThan(maxCorner.y)) maxCorner.y = boxToInclude.maxCorner.y;
	if(boxToInclude.minCorner.x.LessThan(minCorner.x)) minCorner.x = boxToInclude.minCorner.x;
	if(boxToInclude.minCorner.y.LessThan(minCorner.y)) minCorner.y = boxToInclude.minCorner.y;

}


public void ClipOn ( Box2t_F32 boxToClipOn) {

	if(boxToClipOn.maxCorner.x.LessThan(maxCorner.x)) maxCorner.x = boxToClipOn.maxCorner.x;
	if(boxToClipOn.maxCorner.y.LessThan(maxCorner.y)) maxCorner.y = boxToClipOn.maxCorner.y;
	if(boxToClipOn.minCorner.x.GreaterThan(minCorner.x)) minCorner.x = boxToClipOn.minCorner.x;
	if(boxToClipOn.minCorner.y.GreaterThan(minCorner.y)) minCorner.y = boxToClipOn.minCorner.y;

}


public Box2t_F32 ClippedOn ( Box2t_F32 boxToClipOn) {

	 Box2t_F32 returnedBox = new Box2t_F32(this);

	returnedBox.ClipOn(boxToClipOn);
	return  returnedBox;

}


public Box2t_F32 LessBorder ( FVec2T_F32 borderToRemoveOnEachSide) {

	return  new Box2t_F32(minCorner.Add(borderToRemoveOnEachSide), maxCorner.Sub(borderToRemoveOnEachSide));

}


public static Box2t_F32 Round ( Box2t_F32 box) {

	return  new Box2t_F32(FVec2T_F32.Round(box.minCorner, 16), FVec2T_F32.Round(box.maxCorner, 16));

}


public static Box2t_F32 Float ( Box2t_F32 box) {

	return  new Box2t_F32(box.minCorner, box.maxCorner);

}


public  Box2t_F32 Assign ( Box2t_F32 other) {

	minCorner.Assign(other.minCorner);
	maxCorner.Assign(other.maxCorner);
	return this;

}



/* One dimension array */
public static Box2t_F32[] InstArrayBox2t_F32(int size) {
	Box2t_F32[] newArray = new Box2t_F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Box2t_F32();
	return newArray; }

/* Two dimension array */
public static Box2t_F32[][] InstArrayBox2t_F32(int size1, int size2) {
	Box2t_F32[][] newArray = new Box2t_F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Box2t_F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Box2t_F32(); }
	return newArray; }

/* Three dimension array */
public static Box2t_F32[][][] InstArrayBox2t_F32(int size1, int size2, int size3) {
	Box2t_F32[][][] newArray = new Box2t_F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Box2t_F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Box2t_F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Box2t_F32(); } }
	return newArray; }



}

