package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Box3 {

public static Box3 Cast(Object o, Box3 _) {
 return  (Box3)o; 
}


public void OnSerialize(Package p) {

}


public FVec3T_F32 minCorner;
public FVec3T_F32 maxCorner;
public Box3 () {
minCorner = new FVec3T_F32();
maxCorner = new FVec3T_F32();


}


public  Box3 ( Box3 other) {
minCorner = new FVec3T_F32(other.minCorner);
maxCorner = new FVec3T_F32(other.maxCorner);



}


public  Box3 ( FVec3T_F32 parMinCorner, FVec3T_F32 parMaxCorner) {
minCorner = new FVec3T_F32(parMinCorner);
maxCorner = new FVec3T_F32(parMaxCorner);



}


public FVec3T_F32 Center () {
return  (minCorner.Add(maxCorner)).Mul(F32.Half(16), 16);
}


public void Union ( Box3 box) {

	if(box.minCorner.x.LessThan(minCorner.x))		minCorner.x = box.minCorner.x;
	if(box.minCorner.y.LessThan(minCorner.y))		minCorner.y = box.minCorner.y;
	if(box.minCorner.z.LessThan(minCorner.z))		minCorner.z = box.minCorner.z;
	if(box.maxCorner.x.GreaterThan(maxCorner.x))	maxCorner.x = box.maxCorner.x;
	if(box.maxCorner.y.GreaterThan(maxCorner.y))	maxCorner.y = box.maxCorner.y;
	if(box.maxCorner.z.GreaterThan(maxCorner.z))	maxCorner.z = box.maxCorner.z;

}


public void Union ( FVec3T_F32 vec3) {

	if(vec3.x.LessThan(minCorner.x))		minCorner.x = vec3.x;
	if(vec3.y.LessThan(minCorner.y))		minCorner.y = vec3.y;
	if(vec3.z.LessThan(minCorner.z))		minCorner.z = vec3.z;
	if(vec3.x.GreaterThan(maxCorner.x))	maxCorner.x = vec3.x;
	if(vec3.y.GreaterThan(maxCorner.y))	maxCorner.y = vec3.y;
	if(vec3.z.GreaterThan(maxCorner.z))	maxCorner.z = vec3.z;

}


public Box3 GetUnion ( Box3 box2) {

	 Box3 temp = new Box3(this);
 
	temp.Union(box2);
	return  temp;

}


public boolean Contains ( FVec3T_F32 point) {

	return  point.x.GreaterOrEqual(minCorner.x) && point.x.LessOrEqual(maxCorner.x) && point.y.GreaterOrEqual(minCorner.y) && point.y.LessOrEqual(maxCorner.y) && point.z.GreaterOrEqual(minCorner.z) && point.z.LessOrEqual(maxCorner.z);

}


public boolean Intersects ( Box3 box) {
return  IntersectsInX(box) && IntersectsInY(box) && IntersectsInZ(box);
}


public boolean IntersectsInX ( Box3 box) {
return  (minCorner.x.LessOrEqual(box.maxCorner.x)) && (maxCorner.x.GreaterOrEqual(box.minCorner.x));
}


public boolean IntersectsInY ( Box3 box) {
return  (minCorner.y.LessOrEqual(box.maxCorner.y)) && (maxCorner.y.GreaterOrEqual(box.minCorner.y));
}


public boolean IntersectsInZ ( Box3 box) {
return  (minCorner.z.LessOrEqual(box.maxCorner.z)) && (maxCorner.z.GreaterOrEqual(box.minCorner.z));
}


public boolean Contains ( Box3 box) {
return  ContainsInX(box) && ContainsInY(box) && ContainsInZ(box);
}


public boolean ContainsInX ( Box3 box) {
return  (minCorner.x.LessOrEqual(box.minCorner.x)) && (maxCorner.x.GreaterOrEqual(box.maxCorner.x));
}


public boolean ContainsInY ( Box3 box) {
return  (minCorner.y.LessOrEqual(box.minCorner.y)) && (maxCorner.y.GreaterOrEqual(box.maxCorner.y));
}


public boolean ContainsInZ ( Box3 box) {
return  (minCorner.z.LessOrEqual(box.minCorner.z)) && (maxCorner.z.GreaterOrEqual(box.maxCorner.z));
}


public boolean Intersects ( Sphere sphere) {
return  sphere.Intersects(this);
}


public boolean Contains ( Sphere sphere) {
return  ContainsInX(sphere) && ContainsInY(sphere) && ContainsInZ(sphere);
}


public boolean ContainsInX ( Sphere sphere) {
return  (minCorner.x.LessOrEqual(sphere.GetCenter().x.Sub(sphere.GetRadius()))) && (maxCorner.x.GreaterOrEqual(sphere.GetCenter().x.Add(sphere.GetRadius())));
}


public boolean ContainsInY ( Sphere sphere) {
return  (minCorner.y.LessOrEqual(sphere.GetCenter().y.Sub(sphere.GetRadius()))) && (maxCorner.y.GreaterOrEqual(sphere.GetCenter().y.Add(sphere.GetRadius())));
}


public boolean ContainsInZ ( Sphere sphere) {
return  (minCorner.z.LessOrEqual(sphere.GetCenter().z.Sub(sphere.GetRadius()))) && (maxCorner.z.GreaterOrEqual(sphere.GetCenter().z.Add(sphere.GetRadius())));
}


public  Box3 Assign ( Box3 other) {

	minCorner.Assign(other.minCorner);
	maxCorner.Assign(other.maxCorner);
	return this;

}



/* One dimension array */
public static Box3[] InstArrayBox3(int size) {
	Box3[] newArray = new Box3[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Box3();
	return newArray; }

/* Two dimension array */
public static Box3[][] InstArrayBox3(int size1, int size2) {
	Box3[][] newArray = new Box3[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Box3[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Box3(); }
	return newArray; }

/* Three dimension array */
public static Box3[][][] InstArrayBox3(int size1, int size2, int size3) {
	Box3[][][] newArray = new Box3[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Box3[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Box3[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Box3(); } }
	return newArray; }



}

