package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public abstract class Controller extends TimeControlled {

public static Controller Cast(Object o, Controller _) {
 return  (Controller)o; 
}


 final public static byte typeNumber = TypeIDOfType_Controller.v;
 final public static byte typeID = TypeIDOfType_Controller.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  Controller () {


	
	





}


public void destruct() {

	
	mControllee = null;

}


public final static byte ValueTypeNone = 0;
public final static byte ValueTypeBool = 1;
public final static byte ValueTypeInt = 2;
public final static byte ValueTypeFloat = 3;
public final static byte ValueTypeCoord2 = 4;
public final static byte ValueTypeRect = 5;
public final static byte ValueTypeColor = 6;
public final static byte ValueTypeVec3 = 7;
public final static byte ValueTypeQuaternion = 8;

public Vector2_short GetCoord2Value () {

	return  new Vector2_short(GetCoord2ValueX(), GetCoord2ValueY());

}


public short GetCoord2ValueX () {

	 int[] valueBuffer = mValueBuffer;	

	if(mAbsolute != absolute)
	{
		return  (short)(valueBuffer[0] + valueBuffer[4]);
	}
	else
	{
		return  (short)(valueBuffer[0]);
	}

}


public short GetCoord2ValueY () {

	 int[] valueBuffer = mValueBuffer;

	if(mAbsolute != absolute)
	{
		return  (short)(valueBuffer[1] + valueBuffer[4+1]);
	}
	else
	{
		return  (short)valueBuffer[1];
	}

}


public int GetLongValue () {

	 int[] valueBuffer = mValueBuffer;

	if(mAbsolute != absolute)
	{		
		return  valueBuffer[0] + valueBuffer[4];
	}
	else
	{
		return  valueBuffer[0];
	}

}


public boolean GetBoolValue () {

	return  (GetLongValue() & 1) != 0;

}


public FlRect GetRectValue () {

	 int[] valueBuffer = mValueBuffer;

	if(mAbsolute != absolute)
	{
		return  new FlRect((short)(valueBuffer[0] + valueBuffer[4]), (short)(valueBuffer[1] + valueBuffer[4 + 1]), (short)(valueBuffer[2] + valueBuffer[4 + 2]), (short)(valueBuffer[3] + valueBuffer[4 + 3]));
	}

	return  new FlRect((short)valueBuffer[0], (short)valueBuffer[1], (short)valueBuffer[2], (short)valueBuffer[3]);

}


public Color888 GetColorValue () {

	 int[] valueBuffer = mValueBuffer;

	Color888 rgb = new Color888();

	if(mAbsolute != absolute)
	{		
		rgb.SetRed(Memory.MakeUnsignedByte((byte)(valueBuffer[0] + valueBuffer[4])));
		rgb.SetGreen(Memory.MakeUnsignedByte((byte)(valueBuffer[1] + valueBuffer[4+1])));
		rgb.SetBlue(Memory.MakeUnsignedByte((byte)(valueBuffer[2] + valueBuffer[4+2])));		
	}
	else
	{
		rgb.SetRed(Memory.MakeUnsignedByte((byte)valueBuffer[0]));
		rgb.SetGreen(Memory.MakeUnsignedByte((byte)valueBuffer[1]));
		rgb.SetBlue(Memory.MakeUnsignedByte((byte)valueBuffer[2]));
	}
	return  rgb;

}


public FVec3T_F32 GetFVec3Value () {

	 int[] valueBuffer = mValueBuffer;

	if(mAbsolute != absolute)
	{		
		return  new FVec3T_F32(new F32((int)(valueBuffer[0] + valueBuffer[4]), 16), new F32((int)(valueBuffer[1] + valueBuffer[4+1]), 16), new F32((int)(valueBuffer[2] + valueBuffer[4+2]), 16));
	}
	else
	{
		return  new FVec3T_F32(new F32((int)valueBuffer[0], 16), new F32((int)valueBuffer[1], 16), new F32((int)valueBuffer[2], 16));
	}

}


public FQuaternionT_F32 GetFQuaternionValue () {

	 int[] valueBuffer = mValueBuffer;
	 F32 s = new F32(valueBuffer[0], FQuaternionT_F32.QUATERNION_FP);

	 FQuaternionT_F32 rot = new FQuaternionT_F32(s, new FVec3T_F32(new F32(valueBuffer[1], FQuaternionT_F32.QUATERNION_FP), new F32(valueBuffer[2], FQuaternionT_F32.QUATERNION_FP), new F32(valueBuffer[3], FQuaternionT_F32.QUATERNION_FP)));

	
	if(mAbsolute != absolute)
	{
		s = new F32(valueBuffer[4], FQuaternionT_F32.QUATERNION_FP);
		 FQuaternionT_F32 rot2 = new FQuaternionT_F32(s, new FVec3T_F32(new F32(valueBuffer[4+1], FQuaternionT_F32.QUATERNION_FP), new F32(valueBuffer[4+2], FQuaternionT_F32.QUATERNION_FP), new F32(valueBuffer[4+3], FQuaternionT_F32.QUATERNION_FP)));

		rot.Assign(rot2.Mul(rot));
	}

	return  rot;

}


public F32 GetF32Value () {

	 int[] valueBuffer = mValueBuffer;

	if(mAbsolute != absolute)
	{		
		return  new F32(valueBuffer[0] + valueBuffer[4], 16);
	}

	return  new F32(valueBuffer[0], 16);

}


public void SetValue (short valX, short valY) {

	mValueBuffer[4 + 0] = valX;
	mValueBuffer[4 + 1] = valY;

}


public void SetValue (short val_left, short val_top, short val_width, short val_height) {

	 int[] valueBuffer = mValueBuffer;

	valueBuffer[4 + 0] = val_left;
	valueBuffer[4 + 1] = val_top;
	valueBuffer[4 + 2] = val_width;
	valueBuffer[4 + 3] = val_height;

}


public void SetValue ( Color888 rgb) {

	 int[] valueBuffer = mValueBuffer;

	valueBuffer[4 + 0] = rgb.GetRed();
	valueBuffer[4 + 1] = rgb.GetGreen();
	valueBuffer[4 + 2] = rgb.GetBlue();

}


public void SetValue (boolean val) {

	mValueBuffer[4 + 0] = val ? 1 : 0;

}


public void SetValue (int val) {

	mValueBuffer[4 + 0] = val;

}


public void SetValue ( FVec3T_F32 val) {

	 int[] valueBuffer = mValueBuffer;

	valueBuffer[4 + 0] = val.x.ToFixedPoint(16);
	valueBuffer[4 + 1] = val.y.ToFixedPoint(16);
	valueBuffer[4 + 2] = val.z.ToFixedPoint(16);

}


public void SetValue ( FQuaternionT_F32 val) {

	 int[] valueBuffer = mValueBuffer;

	valueBuffer[4 + 0] = val.GetS().ToFixedPoint(FQuaternionT_F32.QUATERNION_FP);
	valueBuffer[4 + 1] = val.GetVx().ToFixedPoint(FQuaternionT_F32.QUATERNION_FP);
	valueBuffer[4 + 2] = val.GetVy().ToFixedPoint(FQuaternionT_F32.QUATERNION_FP);
	valueBuffer[4 + 3] = val.GetVz().ToFixedPoint(FQuaternionT_F32.QUATERNION_FP);

}


public void SetValue ( F32 val) {

	mValueBuffer[4 + 0] = val.ToFixedPoint(16);

}


public void GetControlledValue (int[] value, int size) {

	for(int i = 0;i < size;i ++)
	{
		value[i] = mValueBuffer[i];

		
		
		if(mAbsolute != 0)
		{
			value[i] += mValueBuffer[4+i];
		}
	}

}


public void SetRequestedValue ( int[] value, int size) {

	for(int i = 0;i < size;i ++)
	{
		mValueBuffer[4 + i] = value[i];
	}

}


public void Restore () {

	if(mStartState != uninitialized)
	{
		CopyValue(0, 4);
		
		 byte cacheAbs = mAbsolute;


		mAbsolute = absolute;

		mControllee.ControlValue(mControlledValueCode, true, this);

		mAbsolute = cacheAbs;
	}

	Refresh();

}


public void Refresh () {

	
		mCacheState = uninitialized;
	
}


public abstract void OnTime(int a18, int a17);



public void SetControlParameters (TimeControlled controllee, int valueCode) {

	mControllee = controllee;
	mControlledValueCode = valueCode;
	mStartState = uninitialized;

	mCacheState = uninitialized;

}


public void SetControllee(TimeControlled controllee) {
 SetControlParameters(controllee, mControlledValueCode); 
}


public void SetControlledValueCode(int valueCode) {
 SetControlParameters(mControllee, valueCode); 
}


public TimeControlled GetControllee() {
 return  mControllee; 
}


public boolean IsAbsolute() {
 return  mAbsolute == absolute; 
}


public void SetIsAbsolute (boolean val) {

	if(val != (mAbsolute == absolute))
	{
		mAbsolute = (val ? absolute : relative);
		mStartState = uninitialized;
	}

}


public void ResetControllee() {
 mStartState = uninitialized; 
}


public void OnSerialize (Package p) {

	(mControllee)= mControllee.Cast((p).SerializePointer((mControllee).typeNumber, (mControllee).supportsDynamicSerialization, false), null);
	(mControlledValueCode)= (p).SerializeIntrinsic(mControlledValueCode);

	 boolean absolute = IsAbsolute();


	(absolute)= (p).SerializeIntrinsic(absolute);

	

{
		SetIsAbsolute(absolute);
	}

}


public final static byte absolute = 0;
public final static byte relative = 1;

public final static byte uninitialized = 0;
public final static byte initialized = 1;

public void DefaultOnTime (int totalTime, int deltaTime) {




	if(mControllee == null)
	{
		return ;
	}
	
	if(mStartState == uninitialized)
	{
		GetCurrentValue();
		mStartState = initialized;
	}
	

	if(NeedsUpdate())
	{
		mControllee.ControlValue(mControlledValueCode, true, this);
		UpdateCache();
	}



































}


public void GetCurrentValue () {

	mControllee.ControlValue(mControlledValueCode, false, this);

}


public boolean NeedsUpdate () {

	if(mCacheState == uninitialized)
	{
		return  true;
	}

	for(int i = 0;i < 4;i ++)
	{
		if(mValueBuffer[(4 << 1)+i] != mValueBuffer[i])
		{
			return  true;
		}
	}
	return  false;

}


public void UpdateCache () {

	CopyValue(4* 2, 0);
	mCacheState = initialized;

}


public void CopyValue (int firstIndex, int secondIndex) {

	for(int i = 0;i < 4;i ++)
	{
		mValueBuffer[firstIndex+i] = mValueBuffer[secondIndex+i];
	}

}


public TimeControlled mControllee;
public int mControlledValueCode;
public byte mAbsolute;
public byte mCacheState;
public byte mStartState;
public int[] mValueBuffer = new int[4 * 3];




}

