package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 1


public class F32 {

public F32 () {

	ForceInline.v();

	


}


public F32 (float fValue, int pointPosition) {

	ForceInline.v();

	
	
		value = (int)(fValue * (1<< pointPosition));
	







		


}


public F32 (int fpValue, int pointPosition) {

	ForceInline.v();

	
		value = fpValue;
		



}


public F32 ( F32 other) {

	ForceInline.v();

	value = other.value;
	


}


public F32 Mul ( F32 f, int n) {

	ForceInline.v();

	
		

long val;

		val = ((long)(value)) * ((long)(f.value));
	
		


return  new F32(((int)((val >> n))), n);
		
}


public F32 Div ( F32 f, int n) {

	ForceInline.v();

	
		

 long val = ((long)(value)) << n;

		val /= ((long)(f.value));
		

return  new F32(((int)(val)), n);
		
}


public F32 MulLP ( F32 f, int n) {

	ForceInline.v();

	
		

return  new F32((int)((value >> n /2) * (f.value >> n /2)), n);
		
}


public F32 DivLP ( F32 f, int n) {

	ForceInline.v();

	
		

return  new F32((int)(value << n /4) / (f.value >> ((n - n /4))), n);
		
}


public F32 MulPower2 (int power) {

	ForceInline.v();



	


return  new F32(value << power, 0);
	
}


public F32 DivPower2 (int power) {

	ForceInline.v();

	
	
		

return  new F32(value >> power, 0);
		
}


public F32 Inverse (int n) {

	ForceInline.v();

	
		

 long val = ((long)(1)) << 62;
 
		val /= ((long)(value)); 
		val = val >> (62- (2* n)); 
	
		

return  new F32(((int)(val)), n);
		
}


public F32 Square (int n) {

	ForceInline.v();

	return  this.Mul(this, n);

}


public F32 Round (int pointPos) {

	ForceInline.v();

	return  Add(Half(pointPos)).Floor(pointPos);

}


public F32 Floor (int pointPos) {

	ForceInline.v();

	 F32 result = new F32(this);

	
		result.value = (value >> pointPos) << pointPos;
	

return  result;

}


public F32 Ceiling (int pointPos) {

	ForceInline.v();

	 F32 result = new F32(this);

	
		result.value = -((-value >> pointPos) << pointPos);
	

return  result;

}


public F32 Abs () {

	ForceInline.v();

	
		if(value < 0)
			return  Neg();
	


return this;

}


public F32 Sqrt (int n) {





	

 int root = 0;


	









 long lroot = 0;

			 long remHi = 0;

			 long remLo = value;

			 long count = 30- (30- n) / 2;

			long testDiv;

			 int shiftHi = (4 * 8) - 2;

	
			do
			{
				remHi = ((remHi << 2) | (remLo >> shiftHi)) & 0x00000000FFFFFFFFl;
				remLo = (remLo << 2) & 0x00000000FFFFFFFFl; 
				lroot = (lroot << 1) & 0x00000000FFFFFFFFl; 
				testDiv = ((lroot << 1) + 1) & 0x00000000FFFFFFFFl; 
	
				if(remHi >= testDiv)
				{
					remHi -= testDiv;
					lroot++;
				}
			}
			while(count -- != 0);
	
			root = (int)lroot;
		























return  new F32(root, n);
		
}


public F32 InvSqrt (int n) {

	return  Sqrt(n).Inverse(n);

}


public F32 Sin (int point) {

	
		

 F32 pi = new F32(Pi(point));

		 F32 halfPi = new F32(PiOver2(point));

	
		 F32 copy = new F32(this);

	
		 F32 pi_2 = new F32(TwoPi(point));

	
		if(copy.value < 0)
		{
			do
			{
				copy = copy.Add(pi_2);
			}
			while(copy.value < 0);
		}
		else if(copy.GreaterThan(pi_2))
		{
			do
			{
				copy = copy.Sub(pi_2);
			}
			while(copy.GreaterThan(pi_2));
		}
	
		 int sign = 1;

		if(copy.value > pi.value)
		{
			if(copy.value > (pi.value + halfPi.value))
			{
				copy.value = (pi.value << 1) - copy.value;
				sign = -1;
			}
			else
			{
				copy.value = copy.value - pi.value;
				sign = -1;
			}
		}
		else if(copy.value > halfPi.value)
		{
			copy.value = pi.value - copy.value;
		}
	
		 F32 sqr = new F32(copy.Square(point));

		 F32 result = new F32(ConvertConstant16(498, point));

		result = result.Mul(sqr, point);
		result = result.Sub(ConvertConstant16(10882, point));
		result = result.Mul(sqr, point);
		result.value += (1<<point);
		result = result.Mul(copy, point);
		result.value *= sign;
	
		

return  result;
	
	








}


public F32 Cos (int point) {

	
		

 F32 pi = new F32(Pi(point));

		 F32 halfPi = new F32(PiOver2(point));

		 F32 copy = new F32(this);

		 F32 pi_2 = new F32(TwoPi(point));

	
		if(copy.value < 0)
		{
			do
			{
				copy = copy.Add(pi_2);
			}
			while(copy.value < 0);
		}
		else if(copy.GreaterThan(pi_2))
		{
			do
			{
				copy = copy.Sub(pi_2);
			}
			while(copy.GreaterThan(pi_2));
		}
	
		 int sign = 1;

		if(copy.value > pi.value)
		{
			if(copy.value > (pi.value + halfPi.value))
			{
				copy.value = (pi.value << 1) - copy.value;
			}
			else
			{
				copy.value = copy.value - pi.value;
				sign = -1;
			}
		}
		else if(copy.value > halfPi.value)
		{
			copy.value = pi.value - copy.value;
			sign = -1;
		}
	
		 F32 sqr = new F32(copy.Square(point));

		 F32 result = new F32(ConvertConstant16(2428, point).Mul(sqr, point));

		result = result.Sub(ConvertConstant16(32551, point));
		result = result.Mul(sqr, point);
		result.value += (1<<point);
		result.value *= sign;
	
		

return  result;
	
	








}


public F32 Tan (int point) {

	
		

 F32 copy = new F32(this);

		 F32 pi_2 = new F32(TwoPi(point));

	
		while(copy.GreaterThan(pi_2))
		{
			copy = copy.Sub(pi_2);
		}
		while(copy.value < 0)
		{
			copy = copy.Add(pi_2);
		}
	
		 F32 sqr = new F32(copy.Square(point));

		 F32 result = new F32(ConvertConstant16(13323, point));

		result = result.Mul(sqr, point);
		result = result.Add(ConvertConstant16(20810, point));
		result = result.Mul(sqr, point);
		result = result.Add(One(point));
		result = copy.Mul(result, point);
	
		

return  result;
	
	








}


public F32 ArcSin (int point) {

	
		

		if(IsNegative())
		{
			return  this.Neg().ArcSin(point).Neg();
		}
		 F32 fRoot = new F32((One(point).Sub(this)).Sqrt(point));

		 F32 result = new F32(ConvertConstant16(-1228, point));

		result = Mul(result, point);
		result = result.Add(ConvertConstant16(4866, point));
		result = Mul(result, point);
		result = result.Sub(ConvertConstant16(13901, point));
		result = Mul(result, point);
		result = result.Add(ConvertConstant16(102939, point));
		result = PiOver2(point).Sub((result.Mul(fRoot, point)));
	
		

return  result;
	
	








}


public F32 ArcCos (int point) {

	
		

		if(IsNegative())
		{
			return  this.Neg().ArcCos(point).Sub(Pi(point)).Neg();
		}
		if(GreaterOrEqual(One(point)))
		{
			return  F32.Zero(point);
		}

		 F32 fRoot = new F32((One(point).Sub(this)).Sqrt(point));

		 F32 result = new F32(ConvertConstant16(-1228, point));

		result = Mul(result, point);
		result = result.Add(ConvertConstant16(4866, point));
		result = Mul(result, point);
		result = result.Sub(ConvertConstant16(13901, point));
		result = Mul(result, point);
		result = result.Add(ConvertConstant16(102939, point));
		result = result.Mul(fRoot, point);
		

return  result;
	
	








}


public F32 ArcTan (int point) {

	if(Abs().GreaterThan(One(point)))
	{
		if(IsPositive())
		{
			return  PiOver2(point).Sub(Inverse(point).ArcTan(point));
		}
		return  PiOver2(point).Neg().Sub(Inverse(point).ArcTan(point));
	}

	
		 F32 sqr = new F32(this.Square(point));

		 F32 result = new F32(ConvertConstant16(1365, point));

		result = result.Mul(sqr, point);
		result = result.Sub(ConvertConstant16(5579, point));
		result = result.Mul(sqr, point);
		result = result.Add(ConvertConstant16(11805, point));
		result = result.Mul(sqr, point);
		result = result.Sub(ConvertConstant16(21646, point));
		result = result.Mul(sqr, point);
		result = result.Add(ConvertConstant16(65527, point));
		result = Mul(result, point);
	
		

return  result;
	
	








}


public static F32 ArcTan2 ( F32 x, F32 y, int point) {

	ForceInline.v();

	if(x.Abs().LessThan(Epsilon(point)))
	{
		if(y.Abs().LessThan(Epsilon(point)))
		{
			return  F32.Zero(point);
		}

		if(y.IsPositive())
		{
			return  F32.PiOver2(point);
		}
		else
		{
			return  F32.PiOver2(point).Neg();
		}
	}

	 F32 t = new F32(y.Div(x, point));


	if(x.IsNegative())
	{
		 F32 res = new F32(t.Abs().ArcTan(point));

		res = F32.Pi(point).Sub(res);

		if(y.IsNegative())
		{
			return  res.Neg();
		}
		return  res;
	}

	return  t.ArcTan(point);

}


public F32 SqrtApproximation7 (int n) {

	ForceInline.v();

	
	

	
		

 F32 x = new F32(One(n));

		x = x.Add(Div(x, n)).DivPower2(1);
		x = x.Add(Div(x, n)).DivPower2(1);
		x = x.Add(Div(x, n)).DivPower2(1);
		x = x.Add(Div(x, n)).DivPower2(1);
		x = x.Add(Div(x, n)).DivPower2(1);
		x = x.Add(Div(x, n)).DivPower2(1);
	
		

return  x;
		
}


public F32 SqrtApproximation3 (int n) {

	ForceInline.v();

	
	

	
		

 F32 num = new F32(One(n).Add(Mul(Add(FromInt(6, n)), n)));

		 F32 denom = new F32((Add(One(n))).MulPower2(2));

		 F32 x = new F32(num.Div(denom, n));

		
		

return  x;
		
}


public F32 SqrtInvApproximation3 (int n) {

	ForceInline.v();

	
	

	
		

 F32 num = new F32((Add(One(n))).MulPower2(2));

			 F32 denom = new F32(One(n).Add(Mul(Add(FromInt(6, n)), n)));

			 F32 x = new F32(num.Div(denom, n));

			
		

return  x;
		
}


public F32 ArcCos5 (int point) {

	

	
		F32 result = new F32();

		F32 x = new F32();

		 boolean smallValue = LessThan(Half(point));

	
		if(smallValue) x = this;
		else x = One(point).Sub(Square(point)).Sqrt(point);
	
		 F32 x3 = new F32(x.Mul(x, point).Mul(x, point));

		 F32 x5 = new F32(x3.Mul(x, point).Mul(x, point));

		 F32 x7 = new F32(x5.Mul(x, point).Mul(x, point));

		 F32 x9 = new F32(x7.Mul(x, point).Mul(x, point));

	
		 F32 t1 = new F32(x);

		 F32 t2 = new F32(x3.Div(6));

		 F32 t3 = new F32(x5.Mul(3).Div(40));

		 F32 t4 = new F32(x7.Mul(15).Div(336));

		 F32 t5 = new F32(x9.Mul(105).Div(3024));

	
		if(smallValue)
		{
			 F32 asin = new F32(t1.Add(t2).Add(t3).Add(t4).Add(t5));

			result = PiOver2(point).Sub(asin);
		}
		else
		{
			result = t1.Add(t2).Add(t3).Add(t4).Add(t5);
		}
	
		

return  result;
	
	








}


public F32 DecreasePrecision (int deltaPoint) {

	ForceInline.v();

	 F32 result = new F32(this);


	
		


result.value = value >> deltaPoint;
	return  result;

}


public F32 IncreasePrecision (int deltaPoint) {

	ForceInline.v();

	 F32 result = new F32(this);


	
		


result.value = value << deltaPoint;
	return  result;

}


public F32 Add ( F32 other) {

	ForceInline.v();

	 F32 retVal = new F32(value + other.value);


	












return  retVal;

}


public F32 Sub ( F32 other) {

	ForceInline.v();

	 F32 retVal = new F32(value - other.value);


	











return  retVal;

}


public F32 Mul ( int scalar) {

	ForceInline.v();

	

return  new F32((int)(value * scalar), 0);
	
}


public F32 Div ( int scalar) {

	ForceInline.v();

	

return  new F32((int)(value / scalar), 0);
	
}


public F32 Neg () {

	ForceInline.v();

	

return  new F32(-value, 0);
	
}


public boolean LessThan ( F32 other) {

	ForceInline.v();

	

return  value < other.value;

}


public boolean LessOrEqual ( F32 other) {

	ForceInline.v();

	

return  value <= other.value;

}


public boolean GreaterThan ( F32 other) {

	ForceInline.v();

	

return  value > other.value;

}


public boolean GreaterOrEqual ( F32 other) {

	ForceInline.v();

	

return  value >= other.value;

}


public boolean Equals ( F32 other) {

	ForceInline.v();

	

return  value == other.value;

}


public F32 NotAllowed ( F32 other) {

	ForceInline.v();

	value = other.value;
	

return this;

}


public boolean IsNegative () {

	ForceInline.v();

	return  value < 0;

}


public boolean IsPositive () {

	ForceInline.v();

	return  !IsNegative();

}


public int ToInt (int n) {

	ForceInline.v();

	
		return  value >> n;
	


}


public static F32 FromInt (int intValue, int n) {

	ForceInline.v();
	return  new F32((int)intValue << n, n);

}


public F32 DegreeToRadian (int point) {

	return  this.Div(Number180OverPi(point), point);

}


public F32 RadianToDegree (int point) {

	return  this.Mul(Number180OverPi(point), point);

}


public static F32 Pi (int point) {

	ForceInline.v();
	return  ConvertConstant16(205887, point);

}


public static F32 TwoPi (int point) {

	ForceInline.v();
	return  Pi(point).MulPower2(1); 

}


public static F32 PiOver2 (int point) {

	ForceInline.v();
	return  Pi(point).DivPower2(1); 

}


public static F32 PiOver4 (int point) {

	ForceInline.v();
	return  Pi(point).DivPower2(2); 

}


public static F32 Number180OverPi (int point) {

	ForceInline.v();
	return  F32.FromInt(180, point).Div(Pi(point), point);

}


public static F32 Epsilon (int point) {

	ForceInline.v();
	return  new F32((int)10, point);

}


public static F32 One (int point) {

	ForceInline.v();
	return  new F32((int)1<< (point), point);

}


public static F32 Zero (int point) {

	ForceInline.v();
	return  new F32((int)0, point);

}


public static F32 Half (int point) {

	ForceInline.v();

	return  new F32((int)1<< (point -1), point);

}


public static F32 Quarter (int point) {

	ForceInline.v();

	return  new F32((int)1<< (point -2), point);

}


public static F32 ThreeQuarter (int point) {

	ForceInline.v();


	return  new F32((int)((1<< (point -1)) |(1<< (point -2))), point);

}


public static F32 OneHundredth (int point) {

	ForceInline.v();


	return  FromInt(100, point).Inverse(point);

}


public static F32 MaxValue (int point) {

	ForceInline.v();
	




	 int max = (((((int)1<< (8* 4 - 2)) - 1) << 1) + 1);

	return  new F32(max, point);

}


public static F32 MinValue (int point) {

	ForceInline.v();
	return  MaxValue(point).Neg();

}


public int GetInternalRep(int pt) {
 ForceInline.v();



return  value;
	
}


public float ToFloat(int point) {
 ForceInline.v();
		
			return  (float)value /(float)(1<< point);
		


}


public double ToDouble(int point) {
 ForceInline.v();
		
			return  (double)value / (double)(1<< point);
		


}


public int ToFixedPoint(int a5) {
 ForceInline.v();
			return  value;
		
}


public static int FromFixedPoint(int fp, int a6) {
 ForceInline.v();
				return  fp;
		
}


public static void ConvertArrayToBaseType(int [] output, F32 [] input, int length, int point) {
 ForceInline.v();
		for(int i = 0;i < length;++i)
		{
			output[i] = input[i].ToFixedPoint(point);
		}
	
}


public static long GetRightMask (int nbits) {

	



 long res = 0;

	
		for(int i = 0;i < nbits;++i)
		{
			res = res << 1;
			res = res | 1;
		}
	
		return  res;
	
}


public static long GetLeftMask (int nbits) {

	ForceInline.v();
	return  ~(GetRightMask(64- nbits));

}


public static F32 ConvertConstant16 (int constant, int point) {

	ForceInline.v();

	if(point == 16)
	{
		return  new F32(constant, 16);
	}
	else if(point < 16)
	{
		return  new F32(constant >> (16- point), point);
	}
	else
	{
		return  new F32(constant << (point - 16), point);
	}

}


public F32 (int val) {

	ForceInline.v();

	value = val;

}


public int value;

/* One dimension array */
public static F32[] InstArrayF32(int size) {
	F32[] newArray = new F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new F32();
	return newArray; }

/* Two dimension array */
public static F32[][] InstArrayF32(int size1, int size2) {
	F32[][] newArray = new F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new F32(); }
	return newArray; }

/* Three dimension array */
public static F32[][][] InstArrayF32(int size1, int size2, int size3) {
	F32[][][] newArray = new F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new F32(); } }
	return newArray; }



}

