package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;

//#define INST_FROM_PRIMITIVE 0


public class FMat44T_F32 {

public FMat44T_F32 () {
m11 = new F32();
m21 = new F32();
m31 = new F32();
m41 = new F32();
m12 = new F32();
m22 = new F32();
m32 = new F32();
m42 = new F32();
m13 = new F32();
m23 = new F32();
m33 = new F32();
m43 = new F32();
m14 = new F32();
m24 = new F32();
m34 = new F32();
m44 = new F32();

}


public FMat44T_F32 (int point) {
m11 = new F32();
m21 = new F32();
m31 = new F32();
m41 = new F32();
m12 = new F32();
m22 = new F32();
m32 = new F32();
m42 = new F32();
m13 = new F32();
m23 = new F32();
m33 = new F32();
m43 = new F32();
m14 = new F32();
m24 = new F32();
m34 = new F32();
m44 = new F32();

	SetIdentity(point);

}


public  FMat44T_F32 ( F32 M11, F32 M12, F32 M13, F32 M14, F32 M21, F32 M22, F32 M23, F32 M24, F32 M31, F32 M32, F32 M33, F32 M34, F32 M41, F32 M42, F32 M43, F32 M44, int a9) {
m11 = new F32(M11);
m21 = new F32(M21);
m31 = new F32(M31);
m41 = new F32(M41);
m12 = new F32(M12);
m22 = new F32(M22);
m32 = new F32(M32);
m42 = new F32(M42);
m13 = new F32(M13);
m23 = new F32(M23);
m33 = new F32(M33);
m43 = new F32(M43);
m14 = new F32(M14);
m24 = new F32(M24);
m34 = new F32(M34);
m44 = new F32(M44);




}


public  FMat44T_F32 ( FMat44T_F32 o) {
m11 = new F32(o.m11);
m21 = new F32(o.m21);
m31 = new F32(o.m31);
m41 = new F32(o.m41);
m12 = new F32(o.m12);
m22 = new F32(o.m22);
m32 = new F32(o.m32);
m42 = new F32(o.m42);
m13 = new F32(o.m13);
m23 = new F32(o.m23);
m33 = new F32(o.m33);
m43 = new F32(o.m43);
m14 = new F32(o.m14);
m24 = new F32(o.m24);
m34 = new F32(o.m34);
m44 = new F32(o.m44);




}


public void SetIdentity (int point) {

	m11 = F32.One(point);
	m22 = F32.One(point);
	m33 = F32.One(point);
	m44 = F32.One(point);
	m21 = F32.Zero(point);
	m31 = F32.Zero(point);
	m41 = F32.Zero(point);
	m12 = F32.Zero(point);
	m32 = F32.Zero(point);
	m42 = F32.Zero(point);
	m13 = F32.Zero(point);
	m23 = F32.Zero(point);
	m43 = F32.Zero(point);
	m14 = F32.Zero(point);
	m24 = F32.Zero(point);
	m34 = F32.Zero(point);

}


public void SetTranslation ( FVec3T_F32 trans, int point) {

	SetIdentity(point);
	m14 = trans.x;
	m24 = trans.y;
	m34 = trans.z;

}


public void SetRotationX ( F32 angle, int point) {

	SetIdentity(point);
	m22 = angle.Cos(point);
	m33 = angle.Cos(point);
	m23 = angle.Sin(point).Neg();
	m32 = angle.Sin(point);

}


public void SetRotationY ( F32 angle, int point) {

	SetIdentity(point);
	m11 = angle.Cos(point);
	m33 = angle.Cos(point);
	m13 = angle.Sin(point);
	m31 = angle.Sin(point).Neg();

}


public void SetRotationZ ( F32 angle, int point) {

	SetIdentity(point);
	m11 = angle.Cos(point);
	m22 = angle.Cos(point);
	m12 = angle.Sin(point).Neg();
	m21 = angle.Sin(point);

}


public void SetShearXY ( F32 shx, F32 shy, int point) {

	SetIdentity(point);
	m13 = shx;
	m23 = shy;

}


public void SetScale ( F32 uniformScale, int point) {

	SetIdentity(point);
	m11 = uniformScale;
	m22 = uniformScale;
	m33 = uniformScale;

}


public void SetScale ( FVec3T_F32 scaleFactors, int point) {

	SetIdentity(point);
	m11 = scaleFactors.x;
	m22 = scaleFactors.y;
	m33 = scaleFactors.z;

}


public void GetUnitTransforms (FVec3T_F32 translation, FQuaternionT_F32 rotation, FVec3T_F32 scale, int point) {

	 FMat44T_F32 transform = new FMat44T_F32(this);


	

	translation.x = m14;
	translation.y = m24;
	translation.z = m34;

	

	 F32 det = new F32((m11.Mul(m22, point).Mul(m33, point)).Add(m12.Mul(m23, point).Mul(m31, point)).Add(m13.Mul(m21, point).Mul(m32, point)).Sub(m11.Mul(m23, point).Mul(m32, point)).Sub(m12.Mul(m21, point).Mul(m33, point)).Sub(m13.Mul(m22, point).Mul(m31, point)));




	

	scale.x = (m11.Square(point).Add(m12.Square(point)).Add(m13.Square(point))).Sqrt(point);
	scale.y = (m21.Square(point).Add(m22.Square(point)).Add(m23.Square(point))).Sqrt(point);
	scale.z = (m31.Square(point).Add(m32.Square(point)).Add(m33.Square(point))).Sqrt(point);

	if(det.LessThan(F32.Zero(point)))
	{
		scale.Assign(scale.Neg()); 
	}

	FMat44T_F32 scaleInverseMatrix = new FMat44T_F32();

	scaleInverseMatrix.SetScale(scale.Inverse(point), point);

	transform.Assign(scaleInverseMatrix.Mul(transform, point)); 
	
	

	 F32 t = new F32(F32.One(point).Add(transform.m11).Add(transform.m22).Add(transform.m33));

	F32 s = new F32();

	FVec3T_F32 qv = new FVec3T_F32();

	F32 w = new F32();


	

	if(t.GreaterThan(F32.Epsilon(point)))
	{
		s = t.Sqrt(point).MulPower2(1);
		qv.x = (transform.m32.Sub(transform.m23)).Div(s, point);
		qv.y = (transform.m13.Sub(transform.m31)).Div(s, point);
		qv.z = (transform.m21.Sub(transform.m12)).Div(s, point);
		w = s.DivPower2(2);
	}
	else if(transform.m11.GreaterThan(transform.m22) && transform.m11.GreaterThan(transform.m33))
	{
		s = (F32.One(point).Add(transform.m11).Sub(transform.m22).Sub(transform.m33)).Sqrt(point).MulPower2(1);
		qv.x = s.DivPower2(2);
		qv.y = (transform.m21.Add(transform.m12)).Div(s, point);
		qv.z = (transform.m13.Add(transform.m31)).Div(s, point);
		w = (transform.m32.Sub(transform.m23)).Div(s, point);
	}
	else if(transform.m22.GreaterThan(transform.m33))
	{
		s = (F32.One(point).Sub(transform.m11).Add(transform.m22).Sub(transform.m33)).Sqrt(point).MulPower2(1);
		qv.x = (transform.m21.Add(transform.m12)).Div(s, point);
		qv.y = s.DivPower2(2);
		qv.z = (transform.m32.Add(transform.m23)).Div(s, point);
		w = (transform.m13.Sub(transform.m31)).Div(s, point);
	}
	else
	{
		s = (F32.One(point).Sub(transform.m11).Sub(transform.m22).Add(transform.m33)).Sqrt(point).MulPower2(1);
		qv.x = (transform.m13.Add(transform.m31)).Div(s, point);
		qv.y = (transform.m32.Add(transform.m23)).Div(s, point);
		qv.z = s.DivPower2(2);
		w = (transform.m21.Sub(transform.m12)).Div(s, point);
	}

	rotation.Assign(new FQuaternionT_F32(w, qv, point).GetNormalized());

}


public FMat44T_F32 Inverse (int point) {

	 FMat44T_F32 Inv = FMat44T_F32.Get(point);;
	Inverse(point, Inv);
	return  Inv;

}


public void Inverse (int point, FMat44T_F32 result) {

	FastInverse(point, result);

}


public FMat44T_F32 FastInverse (int point) {

	 FMat44T_F32 Inv = FMat44T_F32.Get(point);;
	FastInverse(point, Inv);
	return  Inv;

}


public void FastInverse (int point, FMat44T_F32 out) {

   
     F32 scale = new F32(m11.Square(point).Add(m12.Square(point)).Add(m13.Square(point)));





scale = scale.Inverse(point);

    
	out.m11 = scale.Mul(m11, point);
	out.m21 = scale.Mul(m12, point);
	out.m31 = scale.Mul(m13, point);

	out.m12 = scale.Mul(m21, point);
	out.m22 = scale.Mul(m22, point);
	out.m32 = scale.Mul(m23, point);

	out.m13 = scale.Mul(m31, point);
	out.m23 = scale.Mul(m32, point);
	out.m33 = scale.Mul(m33, point);

    
	out.m14 = out.m11.Mul(m14, point).Add(out.m12.Mul(m24, point)).Add(out.m13.Mul(m34, point)).Neg();
	out.m24 = out.m21.Mul(m14, point).Add(out.m22.Mul(m24, point)).Add(out.m23.Mul(m34, point)).Neg();
	out.m34 = out.m31.Mul(m14, point).Add(out.m32.Mul(m24, point)).Add(out.m33.Mul(m34, point)).Neg();

	out.m41 = F32.Zero(point);
	out.m42 = F32.Zero(point);
	out.m43 = F32.Zero(point);
	out.m44 = F32.One(point);

}


public FMat44T_F32 Mul ( FMat44T_F32 other, int point) {

	 FMat44T_F32 result = FMat44T_F32.Get(point);;
	Mul(result, other, point);
	return  result;

}


public void Mul (FMat44T_F32 result, FMat44T_F32 other, int point) {




result.m11 = m11.Mul(other.m11, point).Add(m12.Mul(other.m21, point)).Add(m13.Mul(other.m31, point));
	result.m21 = m21.Mul(other.m11, point).Add(m22.Mul(other.m21, point)).Add(m23.Mul(other.m31, point));
	result.m31 = m31.Mul(other.m11, point).Add(m32.Mul(other.m21, point)).Add(m33.Mul(other.m31, point));

	result.m12 = m11.Mul(other.m12, point).Add(m12.Mul(other.m22, point)).Add(m13.Mul(other.m32, point));
	result.m22 = m21.Mul(other.m12, point).Add(m22.Mul(other.m22, point)).Add(m23.Mul(other.m32, point));
	result.m32 = m31.Mul(other.m12, point).Add(m32.Mul(other.m22, point)).Add(m33.Mul(other.m32, point));

	result.m13 = m11.Mul(other.m13, point).Add(m12.Mul(other.m23, point)).Add(m13.Mul(other.m33, point));
	result.m23 = m21.Mul(other.m13, point).Add(m22.Mul(other.m23, point)).Add(m23.Mul(other.m33, point));
	result.m33 = m31.Mul(other.m13, point).Add(m32.Mul(other.m23, point)).Add(m33.Mul(other.m33, point));

	result.m14 = m11.Mul(other.m14, point).Add(m12.Mul(other.m24, point)).Add(m13.Mul(other.m34, point)).Add(m14);
	result.m24 = m21.Mul(other.m14, point).Add(m22.Mul(other.m24, point)).Add(m23.Mul(other.m34, point)).Add(m24);
	result.m34 = m31.Mul(other.m14, point).Add(m32.Mul(other.m24, point)).Add(m33.Mul(other.m34, point)).Add(m34);

	result.m41 = F32.Zero(point);
	result.m42 = F32.Zero(point);
	result.m43 = F32.Zero(point);
	result.m44 = F32.One(point);

}


public FMat44T_F32 CompleteMul ( FMat44T_F32 other, int point) {

	 FMat44T_F32 result = FMat44T_F32.Get(point);;
	CompleteMul(other, point, result);
	return  result;

}


public void CompleteMul ( FMat44T_F32 other, int point, FMat44T_F32 result) {

	result.m11 = m11.Mul(other.m11, point).Add(m12.Mul(other.m21, point)).Add(m13.Mul(other.m31, point)).Add(m14.Mul(other.m41, point));
	result.m21 = m21.Mul(other.m11, point).Add(m22.Mul(other.m21, point)).Add(m23.Mul(other.m31, point)).Add(m24.Mul(other.m41, point));
	result.m31 = m31.Mul(other.m11, point).Add(m32.Mul(other.m21, point)).Add(m33.Mul(other.m31, point)).Add(m34.Mul(other.m41, point));
	result.m41 = m41.Mul(other.m11, point).Add(m42.Mul(other.m21, point)).Add(m43.Mul(other.m31, point)).Add(m44.Mul(other.m41, point));

	result.m12 = m11.Mul(other.m12, point).Add(m12.Mul(other.m22, point)).Add(m13.Mul(other.m32, point)).Add(m14.Mul(other.m42, point));
	result.m22 = m21.Mul(other.m12, point).Add(m22.Mul(other.m22, point)).Add(m23.Mul(other.m32, point)).Add(m24.Mul(other.m42, point));
	result.m32 = m31.Mul(other.m12, point).Add(m32.Mul(other.m22, point)).Add(m33.Mul(other.m32, point)).Add(m34.Mul(other.m42, point));
	result.m42 = m41.Mul(other.m12, point).Add(m42.Mul(other.m22, point)).Add(m43.Mul(other.m32, point)).Add(m44.Mul(other.m42, point));

	result.m13 = m11.Mul(other.m13, point).Add(m12.Mul(other.m23, point)).Add(m13.Mul(other.m33, point)).Add(m14.Mul(other.m43, point));
	result.m23 = m21.Mul(other.m13, point).Add(m22.Mul(other.m23, point)).Add(m23.Mul(other.m33, point)).Add(m24.Mul(other.m43, point));
	result.m33 = m31.Mul(other.m13, point).Add(m32.Mul(other.m23, point)).Add(m33.Mul(other.m33, point)).Add(m34.Mul(other.m43, point));
	result.m43 = m41.Mul(other.m13, point).Add(m42.Mul(other.m23, point)).Add(m43.Mul(other.m33, point)).Add(m44.Mul(other.m43, point));

	result.m14 = m11.Mul(other.m14, point).Add(m12.Mul(other.m24, point)).Add(m13.Mul(other.m34, point)).Add(m14.Mul(other.m44, point));
	result.m24 = m21.Mul(other.m14, point).Add(m22.Mul(other.m24, point)).Add(m23.Mul(other.m34, point)).Add(m24.Mul(other.m44, point));
	result.m34 = m31.Mul(other.m14, point).Add(m32.Mul(other.m24, point)).Add(m33.Mul(other.m34, point)).Add(m34.Mul(other.m44, point));
	result.m44 = m41.Mul(other.m14, point).Add(m42.Mul(other.m24, point)).Add(m43.Mul(other.m34, point)).Add(m44.Mul(other.m44, point));

}


public FVec3T_F32 Transform ( FVec3T_F32 other, int point) {

	 FVec3T_F32 result = FVec3T_F32.Get();;



Transform(result, other.x, other.y, other.z, point);
	return  result;

}


public void Transform (FVec3T_F32 result, FVec3T_F32 other, int point) {

	Transform(result, other.x, other.y, other.z, point);

}


public void Transform (FVec3T_F32 result, F32 vx, F32 vy, F32 vz, int point) {

	result.x = m11.Mul(vx, point).Add(m12.Mul(vy, point)).Add(m13.Mul(vz, point)).Add(m14);
	result.y = m21.Mul(vx, point).Add(m22.Mul(vy, point)).Add(m23.Mul(vz, point)).Add(m24);
	result.z = m31.Mul(vx, point).Add(m32.Mul(vy, point)).Add(m33.Mul(vz, point)).Add(m34);

}


public FVec3T_F32 TransformNormal ( FVec3T_F32 other, int point) {

	 FVec3T_F32 result = FVec3T_F32.Get();;



TransformNormal(result, other.x, other.y, other.z, point);
	return  result;

}


public void TransformNormal (FVec3T_F32 result, FVec3T_F32 other, int point) {

	TransformNormal(result, other.x, other.y, other.z, point);

}


public void TransformNormal (FVec3T_F32 result, F32 vx, F32 vy, F32 vz, int point) {

	result.x = m11.Mul(vx, point).Add(m12.Mul(vy, point)).Add(m13.Mul(vz, point));
	result.y = m21.Mul(vx, point).Add(m22.Mul(vy, point)).Add(m23.Mul(vz, point));
	result.z = m31.Mul(vx, point).Add(m32.Mul(vy, point)).Add(m33.Mul(vz, point));

}


public FVec3T_F32 GetTranslationVector () {

	 FVec3T_F32 retval = FVec3T_F32.Get(m14, m24, m34);;
	return  retval;

}


public void SetTranslationVector ( FVec3T_F32 v) {

	m14 = v.x;
	m24 = v.y;
	m34 = v.z;

}


public FMat44T_F32 GetMat33Part (int point) {

	 FMat44T_F32 result = FMat44T_F32.Get(this);;
	result.m14 = F32.Zero(point);
	result.m24 = F32.Zero(point);
	result.m34 = F32.Zero(point);

	return  result;

}


public void SetMat33Part ( FMat44T_F32 m) {

	m11 = m.m11; m12 = m.m12; m13 = m.m13;
	m21 = m.m21; m22 = m.m22; m23 = m.m23;
	m31 = m.m31; m32 = m.m32; m33 = m.m33;

}


public void PostScale ( FVec3T_F32 v, int point) {

	m11 = v.x.Mul(m11, point);
	m21 = v.x.Mul(m21, point);
	m31 = v.x.Mul(m31, point);
	m12 = v.y.Mul(m12, point);
	m22 = v.y.Mul(m22, point);
	m32 = v.y.Mul(m32, point);
	m13 = v.z.Mul(m13, point);
	m23 = v.z.Mul(m23, point);
	m33 = v.z.Mul(m33, point);

}


public FMat44T_F32 TransposeMat33Part (int point) {

	 FMat44T_F32 transposed = FMat44T_F32.Get(point);;
	TransposeMat33Part(point, transposed);
	return  transposed;

}


public void TransposeMat33Part (int a10, FMat44T_F32 result) {

	result.m11 = m11;	result.m12 = m21;	result.m13 = m31;
	result.m21 = m12;	result.m22 = m22;	result.m23 = m32;
	result.m31 = m13;	result.m32 = m23;	result.m33 = m33;

}


public FMat44T_F32 Transpose (int point) {

	 FMat44T_F32 transposed = FMat44T_F32.Get(point);;
	Transpose(point, transposed);
	return  transposed;

}


public void Transpose (int a11, FMat44T_F32 result) {

	result.m11 = m11;	result.m12 = m21;	result.m13 = m31; result.m14 = m41;
	result.m21 = m12;	result.m22 = m22;	result.m23 = m32; result.m24 = m42;
	result.m31 = m13;	result.m32 = m23;	result.m33 = m33; result.m34 = m43;
	result.m41 = m14;	result.m42 = m24;	result.m43 = m34; result.m44 = m44;

}


public F32 GetAt (int index) {


	switch(index)
	{
	case 0 :  return  m11;
	case 1 :  return  m12;
	case 2 :  return  m13;
	case 3 :  return  m14;
	case 4 :  return  m21;
	case 5 :  return  m22;
	case 6 :  return  m23;
	case 7 :  return  m24;
	case 8 :  return  m31;
	case 9 :  return  m32;
	case 10 : return  m33;
	case 11 : return  m34;
	case 12 : return  m41;
	case 13 : return  m42;
	case 14 : return  m43;
	case 15 : return  m44;
	default : ;
		break;
	}

	
	return  m44;
	



}


public F32 GetAt (int row, int column) {


	return  GetAt(row * 4+ column);



}


public boolean Equals ( FMat44T_F32 other) {

	
	return (m14.Equals(other.m14) && m24.Equals(other.m24) && m34.Equals(other.m34) && 
			m11.Equals(other.m11) && m12.Equals(other.m12) && m13.Equals(other.m13) && 
			m21.Equals(other.m21) && m22.Equals(other.m22) && m23.Equals(other.m23) &&
			m31.Equals(other.m31) && m32.Equals(other.m32) && m33.Equals(other.m33) && m44.Equals(other.m44));

}


public  FMat44T_F32 Assign ( FMat44T_F32 other) {

	m11 = other.m11;
	m21 = other.m21;
	m31 = other.m31;
	m41 = other.m41;

	m12 = other.m12;
	m22 = other.m22;
	m32 = other.m32;
	m42 = other.m42;

	m13 = other.m13;
	m23 = other.m23;
	m33 = other.m33;
	m43 = other.m43;

	m14 = other.m14;
	m24 = other.m24;
	m34 = other.m34;
	m44 = other.m44;

	return this;

}


public static FMat44T_F32 I (int point) {

	 FMat44T_F32 retval = FMat44T_F32.Get(point);;
	return  retval;

}


public static FMat44T_F32 Perspective ( F32 fovy, F32 aspect, F32 zNear, F32 zFar, int point) {

	 FMat44T_F32 result = FMat44T_F32.Get(point);;

	 F32 cotangent = new F32(F32.Zero(point));

	 F32 radians = new F32((fovy.DivPower2(1)).DegreeToRadian(point));


	 F32 deltaZ = new F32(zFar.Sub(zNear));

	 F32 sine = new F32(radians.Sin(point));


	 F32 zero = new F32(F32.Zero(point));


	if((deltaZ.Equals(zero)) || (sine.Equals(zero)) || (aspect.Equals(zero)))
	{
		return  result;
	}

	cotangent = radians.Cos(point).Div(sine, point);

	result.m11 = cotangent.Div(aspect, point);
	result.m22 = cotangent;
	result.m33 = zFar.Add(zNear).Neg().Div(deltaZ, point);
	result.m43 = F32.One(point).Neg();
	result.m34 = zNear.Mul(zFar, point).MulPower2(1).Neg().Div(deltaZ, point);
	result.m44 = F32.Zero(point);
	return  result;

}


public static FMat44T_F32 Frustum ( F32 left, F32 right, F32 bottom, F32 top, F32 zNear, F32 zFar, int point) {

	 FMat44T_F32 result = FMat44T_F32.Get(point);;

	 F32 near2 = new F32(zNear.MulPower2(1));

	 F32 rightMLeft = new F32(right.Sub(left));

	 F32 topMBottom = new F32(top.Sub(bottom));

	 F32 farMNear = new F32(zFar.Sub(zNear));


	result.m11 = near2.Div(rightMLeft, point);
	result.m22 = near2.Div(topMBottom, point);
	result.m33 = zFar.Add(zNear).Div(farMNear, point).Neg(); 
	result.m34 = zFar.Mul(near2, point).Div(farMNear, point).Neg(); 
	result.m13 = (right.Add(left)).Div(rightMLeft, point); 
	result.m23 = (top.Add(bottom)).Div(topMBottom, point); 

	result.m43 = F32.One(point).Neg();
	result.m44 = F32.Zero(point);

	return  result;

}


public F32 m11;
public F32 m21;
public F32 m31;
public F32 m41;
public F32 m12;
public F32 m22;
public F32 m32;
public F32 m42;
public F32 m13;
public F32 m23;
public F32 m33;
public F32 m43;
public F32 m14;
public F32 m24;
public F32 m34;
public F32 m44;
public static FMat44T_F32[] mPool = FMat44T_F32.InstArrayFMat44T_F32(20);

public static int mPoolIndex = -1;
public static FMat44T_F32 Get() {
 if(mPoolIndex >= 0)
		{
			 FMat44T_F32 obj = mPool[mPoolIndex--];
			return  obj;
		}
		return  new FMat44T_F32();
	
}


public static FMat44T_F32 Get(FMat44T_F32 copy) {
 if(mPoolIndex >= 0)
		{
			 FMat44T_F32 obj = mPool[mPoolIndex--];
			obj.Assign(copy);
			return  obj;
		}
		return  new FMat44T_F32(copy);
	
}


public static FMat44T_F32 Get(int point) {
 if(mPoolIndex >= 0)
		{
			 FMat44T_F32 obj = mPool[mPoolIndex--];
			obj.SetIdentity(point);
			return  obj;
		}
		return  new FMat44T_F32(point);
	
}



/* One dimension array */
public static FMat44T_F32[] InstArrayFMat44T_F32(int size) {
	FMat44T_F32[] newArray = new FMat44T_F32[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FMat44T_F32();
	return newArray; }

/* Two dimension array */
public static FMat44T_F32[][] InstArrayFMat44T_F32(int size1, int size2) {
	FMat44T_F32[][] newArray = new FMat44T_F32[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FMat44T_F32[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FMat44T_F32(); }
	return newArray; }

/* Three dimension array */
public static FMat44T_F32[][][] InstArrayFMat44T_F32(int size1, int size2, int size3) {
	FMat44T_F32[][][] newArray = new FMat44T_F32[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FMat44T_F32[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FMat44T_F32[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FMat44T_F32(); } }
	return newArray; }



}

