package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FileStream extends Stream {

public final static byte fileModeRead = 0;
public final static byte fileModeWrite = 1;
public final static byte fileModeAppend = 2;

public final static byte streamSeekOriginStart = 0;
public final static byte streamSeekOriginEnd = 1;
public final static byte streamSeekOriginCurrent = 2;

public final static byte fileErrorNoError = 0;
public final static byte fileErrorNotFound = 1;
public final static byte fileErrorAlreadyExist = 2;
public final static byte fileErrorErrorSeeking = 3;
public final static byte fileErrorUnexpectedError = 4;
public final static byte fileErrorPermissionDenied = 5;
public final static byte fileErrorInActivation = 6;
public final static byte fileErrorAccessDenied = 7;
public final static byte fileErrorReadOnly = 8;
public final static byte fileErrorOutOfMemory = 9;

public final static byte licenseActionActivate = 0;
public final static byte licenseActionConsumeStart = 1;
public final static byte licenseActionConsumePause = 2;
public final static byte licenseActionConsumeStop = 3;

public final static byte licenseStateNone = 0;
public final static byte licenseStateNotAvailable = 1;
public final static byte licenseStateValid = 2;
public final static byte licenseStateExpired = 3;
public final static byte licenseStateMimeTypeNotSupported = 4;

public final static short fileBufferDefault = 512;

public static boolean FileExists ( String filename) {

	


return  JavaBasicFileStream.FileExists(filename);
	
}


public static boolean IsSpaceAvailable (int size) {

		


			return  true;
		
}


public static boolean FileDelete ( String filename) {

		return  JavaBasicFileStream.FileDelete(filename);
	
}


public  FileStream ( String filename, byte filemode, int bufferSize, boolean isCRCed) {
mFileMode = (filemode);
mNativeFileSize = (-1);
mIsCRCed = (isCRCed);





mFileName = new String(filename);





switch(mFileMode)
	{
	case fileModeRead :
		{
			
			InitReadMode(bufferSize);
		}
		break;
	case fileModeWrite :
	case fileModeAppend :
		{
			 int headerSize = GetHeaderSize();

			mBufferSize = bufferSize + headerSize;
			mBuffer = new byte[mBufferSize];
			mNativeFileSize = headerSize;
			mCurrentPos = headerSize;
			mDataEndPos = headerSize;

			mIsCRCValid = true;
		}
		break;

	default :
		break;
	}

}


public void destruct() {

	










}


public int Read (byte [] buffer, int size) {





{

		 System.arraycopy(mBuffer, mCurrentPos, buffer, 0, size); ;
		mCurrentPos += size;
	}



































































return  size;

}


public int Write ( byte [] buffer, int size) {


	


	 System.arraycopy(buffer, 0, mBuffer, mCurrentPos, size); ;

	mCurrentPos += size;
	if(mCurrentPos > mDataEndPos)
	{
		mDataEndPos = mCurrentPos;
		mNativeFileSize = mCurrentPos;
	}

	return  size;

}


public void Skip (int size) {

	SetPosition(GetPosition() + size);

}


public int GetSize () {

	return  mNativeFileSize - GetHeaderSize();

}


public int GetPosition () {

	

return  mCurrentPos - GetHeaderSize();
	
}


public void SetPosition (int offset) {



{
		mCurrentPos = GetHeaderSize() + offset;


	}
































}


public boolean IsEndOfFile () {

	

return  (mCurrentPos >= mDataEndPos);
	
}


public boolean IsValid () {

	return  mIsCRCValid;

}


public boolean IsOpen () {

	return  (mBuffer != null);

}


public byte GetFileErrorState () {
 
	 byte errorState = fileErrorNoError;









return  errorState; 

}


public byte GetLicenseState () {

	 byte licState = licenseStateNone;









return  licState;

}


public void ManageLicense (byte action) {

















}


public void Close () {

	







if(mFileMode != fileModeRead)
		{
			AssignCRC();
			

{
                JavaBasicFileStream.WriteFile(mFileName, mBuffer, mDataEndPos, mFileMode);
            }
		}
	mBuffer = null;
	mFileName = null;

}


public byte ReadByte () {

		
		return  mBuffer[mCurrentPos++];
	
}


public short ReadShort () {

		
		
		{
			short retVal = (short)( (( mBuffer[mCurrentPos] & 0xff) << 8) + (mBuffer[mCurrentPos + 1] & 0xff) );
			mCurrentPos += 2;
			return retVal;
		}
		
	
}


public int ReadLong () {

		
		
		{
			byte[] buffer = mBuffer;
			int pointer = mCurrentPos;
			int retVal = (((buffer[pointer] & 0xff) << 24) | ((buffer[pointer + 1] & 0xff) << 16) | ((buffer[pointer + 2] & 0xff) << 8) | (buffer[pointer + 3] & 0xff));
			mCurrentPos += 4;
			return retVal;
		}
		
	
}


public String ReadString () {

		 short size = ReadShort();


		 byte [] data = new byte[size + 1];

		if(size != 0)
		{
			




Read((byte [])data, size * 1);
			}

		data[size] = 0;

		 String string = new String(data);

		data = null;
		return  string;
	
}


public void WriteByte ( byte data) {


			
		{
			mTmpArray[0] = data;
			Write(mTmpArray, 1);
		}
		
	
}


public void WriteShort ( short data) {


			
		{
			mTmpArray[0] = (byte)(0xff & (data >> 8));
			mTmpArray[1] = (byte)(0xff & data);
			Write(mTmpArray, 2);
		}
		
	
}


public void WriteLong ( int data) {


		
		{
			byte[] tmpArray = mTmpArray;
			tmpArray[0] = (byte)(0xff & (data >> 24));
			tmpArray[1] = (byte)(0xff & (data >> 16));
			tmpArray[2] = (byte)(0xff & (data >> 8));
			tmpArray[3] = (byte)(0xff & data);
			Write(tmpArray, 4);
		}
		
	
}


public void WriteString ( String data) {

		data.Write(this);
	
}


public void WriteText ( String data) {

		data.Write(this, false);
	
}


public boolean CanRead() {
 return  mFileMode == fileModeRead; 
}


public boolean CanWrite() {
 return  mFileMode != fileModeRead; 
}


public String ReadLine () {

	 byte currentChar = -1;

	 byte nextChar = -1;

	byte[] buffer = new byte[2048];
	 int nbCharInLine = 0;




	currentChar = ReadByte();

	if(currentChar != (byte)'\n')
	{	
		while(!IsEndOfFile() && (nbCharInLine < (2048- 2))) 
		{
			nextChar = ReadByte();

			if(nextChar == (byte)'\n') 
			{
				if(currentChar != (byte)'\r')
				{
					buffer[nbCharInLine++] = currentChar;
				}
				buffer[nbCharInLine++] = (byte)'\0';
				return  StringUtils.CreateString((byte [])buffer);
			}

			buffer[nbCharInLine++] = currentChar;
			currentChar = nextChar;
		}

		buffer[nbCharInLine++] = currentChar;
	}

	buffer[nbCharInLine++] = (byte)'\0';
	return  StringUtils.CreateString((byte [])buffer);

}


public void InitReadMode (int bufferSize) {




{
		GetNativeFileSize();






mBufferSize = mNativeFileSize;
if(mBufferSize > 0)
		{

			mBuffer = new byte[mBufferSize];
		}
	}










{
		if((mBuffer == null) || (RefreshBuffer(0) == -1))
		{
			mIsCRCValid = false;
		}
		else
		{
			mIsCRCValid = VerifyCRC();
		}
	}

}


public boolean VerifyCRC () {

	
		if(mIsCRCed)
	{
			if(mNativeFileSize > GetHeaderSize())
			{
				 int calculatedCRC = (int)Memory.CalculateCRC(mBuffer, GetHeaderSize(), mDataEndPos - GetHeaderSize());

					
				
					mCurrentPos = 0* 4;
					 int writtenCRC = ReadLong();

					mCurrentPos = GetHeaderSize();
				

return  (calculatedCRC == writtenCRC);
			}
			return  false;
		}
	
		else
		{
			return  true;
		}
	
}


public void AssignCRC () {

	
		if(!mIsCRCed)
		{
			return ;
		}
	 int crc = (int)Memory.CalculateCRC(mBuffer, GetHeaderSize(), mDataEndPos - GetHeaderSize());

	
	
		
		mCurrentPos = 0* 4;
		WriteLong(crc);
	


}


public int RefreshBuffer (int startPositionInFile) {

	 int readSize = 0;


	


	
	mBuffer = JavaBasicFileStream.ReadFile(mFileName);

	if(mBuffer == null)
	{
		return  -1;
	}
	



	mBufferSize = mBuffer.length;
	
mNativeFileSize = mBufferSize;

	readSize = mBufferSize;





















































































mDataEndPos = readSize;
	
	

mCurrentPos = GetHeaderSize();

	return  readSize;

}


public int GetNativeFileSize () {
	











































































































{
		if(mNativeFileSize < 0)
		{
			 int nativeSize = 0;








{







{
                    nativeSize = JavaBasicFileStream.GetFileSize(mFileName);
                }
			}	

			
			if(nativeSize > 0)
				mNativeFileSize = nativeSize;
		}
	}
	return  mNativeFileSize;

}


public int GetCRCSize () {

	
		return  mIsCRCed ? 4 : 0;
	


}


public int GetHeaderSize () {

	 int size = GetCRCSize();

	







return  size;

}


public String mFileName;
public byte mFileMode;
public int mNativeFileSize;
public boolean mIsCRCed;
public boolean mIsCRCValid;
public int mBufferSize;
public byte [] mBuffer;
public int mDataEndPos;
public int mCurrentPos;
public byte[] mTmpArray = new byte[4];

public FileStream(String filename)
{
	this(filename, fileModeRead);
}
public FileStream(String filename, byte filemode)
{
	this(filename, filemode, (int)1024);
}
public FileStream(String filename, byte filemode, int bufferSize)
{
	this(filename, filemode, bufferSize, true);
}
public void InitReadMode()
{
	InitReadMode((int)1024);
}



}

