package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlAccelerometer {

public static FlAccelerometer Get () {

	
	 FrameworkGlobals frameworkGlobals = FrameworkGlobals.GetInstance();
	if(frameworkGlobals.mFlAccelerometer == null)
	{
		frameworkGlobals.mFlAccelerometer = new FlAccelerometer();
	}
	return  frameworkGlobals.mFlAccelerometer;

}


public void destruct() {
	

}


public FVec3T_F32 GetAcceleration () {


	return  mImplementor.GetAcceleration();



}


public F32 GetDeviceOrientation () {

	
	
	if(mDeviceOrientationValid)
	{
		return  mDeviceOrientation;
	}

	
	
	mDeviceOrientation = GetDeviceOrientationFromAcceleration(mAcceleration);
	mDeviceOrientationValid = true;

	return  mDeviceOrientation;

}


public F32 GetUpdateFrequency () {

	return  mUpdateFrequency;

}


public void SetUpdateFrequency (F32 freq) {

	mUpdateFrequency = freq;
	

	mImplementor.SetUpdateFrequency(freq);



}


public void UpdateAccelerometerValues ( FVec3T_F32 newValues) {

	mAcceleration.Assign(newValues);

	
	mDeviceOrientationValid = false;

}


public void Enable () {

	if(!mEnabled)
	{
		mEnabled = true;


		mImplementor.Enable();


}

}


public void Disable () {

	if(mEnabled)
	{
		mEnabled = false;

		mImplementor.Disable();


}

}


public boolean IsEnabled() {
 return  mEnabled; 
}


public static F32 GetDeviceOrientationFromAcceleration ( FVec3T_F32 accel) {

	
	 FVec2T_F32 xyVector = new FVec2T_F32(accel.x, accel.y);


	
	if(xyVector.LengthSquared(16).LessOrEqual(F32.Epsilon(16)))
	{
		return  F32.Zero(16);
	}

	
	xyVector.DestructiveNormalize(16);
	 FVec2T_F32 zeroAxis = new FVec2T_F32(FVec2T_F32.UnitJ(16).Neg());
 
	 F32 angle = new F32(xyVector.Dot(zeroAxis, 16).ArcCos(16));


	
	if(xyVector.x.LessThan(F32.Zero(16)))
	{
		return  F32.TwoPi(16).Sub(angle);
	}
	
	return  angle;

}


public  FlAccelerometer () {
mAcceleration = new FVec3T_F32(FVec3T_F32.Zero(16));
mDeviceOrientation = new F32(F32.Zero(16));
mkAccelerationMinValue = new F32(new F32(-1.0f, 16));
mkAccelerationMaxValue = new F32(new F32(1.0f, 16));
mUpdateFrequency = new F32();
mImplementor = new FlAccelerometerImp();


	SetUpdateFrequency(new F32(10.0f, 16));
	
	
	UpdateAccelerometerValues(new FVec3T_F32(F32.Zero(16), mkAccelerationMinValue, F32.Zero(16)));
	Enable();

}


public FVec3T_F32 mAcceleration;
public F32 mUpdateFrequency;
public F32 mDeviceOrientation;
public boolean mDeviceOrientationValid;
public F32 mkAccelerationMinValue;
public F32 mkAccelerationMaxValue;
public boolean mEnabled;
public FlAccelerometerImp mImplementor;

/* One dimension array */
public static FlAccelerometer[] InstArrayFlAccelerometer(int size) {
	FlAccelerometer[] newArray = new FlAccelerometer[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlAccelerometer();
	return newArray; }

/* Two dimension array */
public static FlAccelerometer[][] InstArrayFlAccelerometer(int size1, int size2) {
	FlAccelerometer[][] newArray = new FlAccelerometer[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlAccelerometer[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlAccelerometer(); }
	return newArray; }

/* Three dimension array */
public static FlAccelerometer[][][] InstArrayFlAccelerometer(int size1, int size2, int size3) {
	FlAccelerometer[][][] newArray = new FlAccelerometer[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlAccelerometer[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlAccelerometer[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlAccelerometer(); } }
	return newArray; }



}

