package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


	import android.graphics.Color;
	import android.graphics.Canvas;
	import android.graphics.Paint;
	import android.graphics.Paint.Style;
	import android.graphics.Rect;
	import android.graphics.RectF;
	
public class FlAndroidDisplayContextImp extends DisplayContext {

public Canvas mCanvas;
public Paint mPaint;
public FlAndroidDisplayContextImp(VideoMode mode) {
super(mode);
mCanvas = new Canvas();
mPaint = new Paint();

mPaint = new android.graphics.Paint();
		mPaint.setAntiAlias(true);
	
}




	private void setClip(int x, int y, int width, int height)
	{
		
			Rect rect = new Rect(x, y, (x + width), (y + height));
			mCanvas.clipRect(rect, android.graphics.Region.Op.REPLACE);
		}
	
	
	public void Clear(Color888 color)
	{
		setClip(mClipRect_left, mClipRect_top, mClipRect_width, mClipRect_height);
		mCanvas.drawColor(color.ToRGB888());
	}


	public void ClearFullscreen(Color888 color)
	{
		short fullscrRect_left = DisplayManager.GetVideoModeRect().GetLeft(); short fullscrRect_top = DisplayManager.GetVideoModeRect().GetTop(); short fullscrRect_width = DisplayManager.GetVideoModeRect().GetWidth(); short fullscrRect_height = DisplayManager.GetVideoModeRect().GetHeight();;
		setClip(fullscrRect_left, fullscrRect_top, fullscrRect_width, fullscrRect_height);
		mCanvas.drawColor(color.ToRGB888());
	}


	public void ResetClip()
	{
		
		setClip(mClipRect_left, mClipRect_top, mClipRect_width, mClipRect_height);
	}


	public void DrawAbsoluteBitmapBypassClipping(Bitmap bitmap, int desLeft, int desTop)
	{
		mCanvas.drawBitmap(bitmap.getImage(), desLeft, desTop, mPaint);
	}
	
	
	public void DrawAbsoluteBitmapSection(Bitmap bitmap, int desLeft, int desTop, int srcLeft, int srcTop,
					int width, int height, byte transform, short opacity)
	{
		mPaint.setAlpha(opacity);
		DrawAbsoluteBitmapSection(bitmap, desLeft, desTop, srcLeft, srcTop, width, height, transform);
	}


	public void DrawAbsoluteBitmapSection(Bitmap bitmap, int desLeft, int desTop, int srcLeft, int srcTop,
				int width, int height, byte transform)
	{
		setClip(desLeft, desTop, width, height);
		Rect srcRect = new Rect(srcLeft, srcTop, (srcLeft + width), (srcTop + height));
		Rect destRect = new Rect(desLeft, desTop, (desLeft + width), (desTop + height));
		
		if (transform == 0)
		{
			mCanvas.drawBitmap(bitmap.getImage(), srcRect, destRect, mPaint);
		}
		else
		{
			mCanvas.save();
			mCanvas.scale(
				((transform & BitmapTransform.FlipX) != 0 ? -1.0f : 1.0f),
				((transform & BitmapTransform.FlipY) != 0 ? -1.0f : 1.0f),
				desLeft + width / 2, 
				desTop + height / 2);

			mCanvas.drawBitmap(bitmap.getImage(), srcRect, destRect, mPaint);
			mCanvas.restore();
		}
	}


	public void DrawArc(Vector2_short center, short radius, short startAngleDegree, short endAngleDegree)
	{
		int centerX = center.GetX() + mCumulativeOffsetX;
		int centerY = center.GetY() + mCumulativeOffsetY;
		
		int X1 = centerX - radius;
		int Y1 = centerY - radius;
		int X2 = centerX + radius;
		int Y2 = centerY + radius;
		
		setClip(X1, Y1, X2, Y2); 
		mCanvas.drawArc(new RectF(X1, Y1, X2, Y2), startAngleDegree, endAngleDegree, false, mPaint);
	}

	
	public void DrawCircle(Vector2_short center, short radius, boolean solid, Color888 fillColor, Color888 outlineColor)
	{				
		int centerX = center.GetX() + mCumulativeOffsetX;
		int centerY = center.GetY() + mCumulativeOffsetY;
		int X1 = centerX - radius;
		int Y1 = centerY - radius;
		int diameter = 2*radius;

		setClip(X1, Y1, diameter, diameter);
		
		mPaint.setStyle(solid?Style.FILL:Style.STROKE);
		mPaint.setARGB(255, fillColor.GetRed(), fillColor.GetGreen(), fillColor.GetBlue());
		mCanvas.drawCircle(centerX, centerY, radius, mPaint);
	}


	public void DrawFrame(short rect_left, short rect_top, short rect_width, short rect_height, Color888 color, short opacity)
	{
		mPaint.setARGB(opacity, color.GetRed(), color.GetGreen(), color.GetBlue());
		mPaint.setStyle(Style.STROKE);

		Rect rect = new Rect(rect_left, rect_top, rect_left+rect_width, rect_top+rect_height);
		mCanvas.drawRect(rect, mPaint);
	}


	public void DrawLine(short startX, short startY, short endX, short endY, Color888 color, short opacity)
	{
		int x1 = startX + mCumulativeOffsetX;
		int y1 = startY + mCumulativeOffsetY;
		int x2 = endX + mCumulativeOffsetX;
		int y2 = endY + mCumulativeOffsetY;

		setClip(mClipRect_left, mClipRect_top, mClipRect_width, mClipRect_height);
		mPaint.setARGB(opacity, color.GetRed(), color.GetGreen(), color.GetBlue());
		mCanvas.drawLine(x1, y1, x2, y2, mPaint);
	}


	public void DrawPixel(short ptX, short ptY, Color888 color)
	{
		int x1 = ptX + mCumulativeOffsetX;
		int y1 = ptY + mCumulativeOffsetY;
		
		setClip(mClipRect_left, mClipRect_top, mClipRect_width, mClipRect_height);
		mPaint.setARGB(255, color.GetRed(), color.GetGreen(), color.GetBlue());
		mCanvas.drawLine(x1, y1, x1, y1, mPaint);
	}


	public void DrawAbsoluteSolidRectangle(short rect_left, short rect_top, short rect_width, short rect_height, int colorRed, int colorGreen, int colorBlue, short opacity)
	{
		mPaint.setARGB(opacity, colorRed, colorGreen, colorBlue);
		mPaint.setStyle(Style.FILL);
		Rect rect = new Rect(rect_left, rect_top, (rect_left + rect_width), (rect_top + rect_height));
		mCanvas.drawRect(rect, mPaint);
	}


	public void DrawRectangle(short rect_left, short rect_top, short rect_width, short rect_height, boolean solid, int colorRed, int colorGreen, int colorBlue, short opacity)
	{
		mPaint.setARGB(opacity, colorRed, colorGreen, colorBlue);

		rect_left += mCumulativeOffsetX;
		rect_top += mCumulativeOffsetY;

		if (!solid)
		{
			
			if (mClipRect_top <= rect_top)
			FillRectangle(rect_left, rect_top, rect_width, (short)1);
				
			
			if (mClipRect_left <= rect_left)
			FillRectangle(rect_left, rect_top, (short)1, rect_height);
				
			
			if (mClipRect_top + mClipRect_height >= rect_top + rect_height)
			FillRectangle(rect_left, (short)(rect_top + rect_height - 1), rect_width, (short)1);
				
			
			if (mClipRect_left + mClipRect_width >= rect_left + rect_width)
			FillRectangle((short)(rect_left + rect_width - 1), rect_top, (short)1, rect_height);
		}
		else
		{
			FillRectangle(rect_left, rect_top, rect_width, rect_height);
		}
	}


	public void FillRectangle(short clippedRect_left, short clippedRect_top, short clippedRect_width, short clippedRect_height)
	{
		{ int clipperRight = (mClipRect_left + mClipRect_width); int clippedRight = (clippedRect_left + clippedRect_width); int clipperBottom = (mClipRect_top + mClipRect_height); int clippedBottom = (clippedRect_top + clippedRect_height); if (mClipRect_left > clippedRect_left) clippedRect_left = mClipRect_left; if (mClipRect_top > clippedRect_top) clippedRect_top = mClipRect_top; if (clipperRight < clippedRight) clippedRight = clipperRight; if (clipperBottom < clippedBottom) clippedBottom = clipperBottom; clippedRect_width = (short) (clippedRight - clippedRect_left); clippedRect_height = (short) (clippedBottom - clippedRect_top); };
		
		if ((clippedRect_width <= 0 || clippedRect_height <= 0))
		{
			return;
		}
		
		setClip(clippedRect_left, clippedRect_top, clippedRect_width, clippedRect_height);	
		mPaint.setStyle(Style.FILL);
		Rect rect = new Rect(clippedRect_left, clippedRect_top, (clippedRect_left + clippedRect_width), (clippedRect_top + clippedRect_height));
		mCanvas.drawRect(rect, mPaint);
	}


	public byte GetDisplayAPI()
	{
		return 0x0;
	}
	




}

