package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class FlLang {

public final static short uninitialized = 0;
public final static short undefined = 1;
public final static short menu = 2;
public final static short Cs = 3;
public final static short Czech = Cs;
public final static short Da = Cs+1;
public final static short Danish = Da;
public final static short De = Da+1;
public final static short German = De;
public final static short En = De+1;
public final static short English = En;
public final static short Es = En+1;
public final static short Spanish = Es;
public final static short Fi = Es+1;
public final static short Finnish = Fi;
public final static short Fr = Fi+1;
public final static short French = Fr;
public final static short Id = Fr+1;
public final static short Indonesian = Id;
public final static short It = Id+1;
public final static short Italian = It;
public final static short Ja = It+1;
public final static short Japanese = Ja;
public final static short Ko = Ja+1;
public final static short Korean = Ko;
public final static short Ml = Ko+1;
public final static short Malaysian = Ml;
public final static short Nl = Ml+1;
public final static short Dutch = Nl;
public final static short No = Nl+1;
public final static short Norwegian = No;
public final static short Pl = No+1;
public final static short Polish = Pl;
public final static short Pt = Pl+1;
public final static short Portuguese = Pt;
public final static short Ro = Pt+1;
public final static short Romanian = Ro;
public final static short Ru = Ro+1;
public final static short Russian = Ru;
public final static short Sv = Ru+1;
public final static short Swedish = Sv;
public final static short Th = Sv+1;
public final static short Thai = Th;
public final static short Tr = Th+1;
public final static short Turkish = Tr;
public final static short Vi = Tr+1;
public final static short Vietnamese = Vi;
public final static short Zh = Vi+1;
public final static short Chinese = Zh;
public final static short EnGb = En | 0x1000;
public final static short EnglishGb = EnGb;
public final static short EnUs = En | 0x2000;
public final static short EnglishUs = EnUs;
public final static short ZhCn = Zh | 0x1000;
public final static short SimplifiedChinese = ZhCn;
public final static short ZhHk = Zh | 0x2000;
public final static short TraditionalChinese = ZhHk		;

public static short GetBestLang () {

	
		if(mBestLangCache != FlLang.uninitialized)
		{
			return  mBestLangCache;
		}
	

 String fileLangStr = new String(Application.GetInstance().GetPropertyValue(StringUtils.CreateString("Force-Locale")));

	mBestLangCache = StrToFlLang(fileLangStr);

	if(mBestLangCache == FlLang.menu)
	{

		return  mBestLangCache;
	}
	else if(mBestLangCache == FlLang.undefined)
	{
		mBestLangCache = GetOSLang();
	}
	
	
	mBestLangCache = Localize(mBestLangCache);
	if(mBestLangCache == FlLang.undefined)
	{
		if(fileLangStr.Substring(0, 5).Equals(StringUtils.CreateString("auto-")))
		{
			mBestLangCache = Localize(StrToFlLang(fileLangStr.Substring(5, -1)));
		}
	}

	if(mBestLangCache == FlLang.undefined)
	{
		mBestLangCache = FlLang.menu;
	}


	return  mBestLangCache;

}


public static short GetOSLang () {

	 short toReturn = FlLang.undefined;


	
	






	return  toReturn;

}


public static short GetHWManagerLangID (short lang) {

	switch(lang & 0x0FFF)
	{
		case FlLang.Fr : return  2;
		case FlLang.Es : return  3;
		case FlLang.De : return  4;
		case FlLang.It : return  5;
		case FlLang.En :
		default :         return  1;  
	}

}


public static short GetNbSupportedLang() {
 return  00+ 00+ 01+ 01+ 01+ 00+ 01+ 00+ 01+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00+ 00; 
}


public static short[] mSupportedLang = {FlLang.De, FlLang.En, FlLang.Es, FlLang.Fr, FlLang.It, FlLang.undefined};

public static short StrToFlLang (String langStr) {

	
	if(langStr.GetLength() < 2)
	{
		return  FlLang.undefined;
	}

	
	langStr.ToLower();
	 int NB_CHAR = 3;

	byte[] toRemove = {' ', '_', '-'};

	for(int i =0;i < NB_CHAR;i ++)
	{
		 int charIdx = langStr.FindChar(toRemove[i]);

		if(charIdx != -1)
		{
			langStr.RemoveCharAt(charIdx, 1);
		}
	}

	
	if(langStr.Equals(StringUtils.CreateString("menu"))) return  FlLang.menu;
	
	
		else if(langStr.Equals(StringUtils.CreateString("engb"))) return  FlLang.EnGb;
		else if(langStr.Equals(StringUtils.CreateString("enus"))) return  FlLang.EnUs;
	langStr.Assign(langStr.Substring(0, 2));

	

if(langStr.Equals(StringUtils.CreateString("de"))) return  FlLang.De;
	if(langStr.Equals(StringUtils.CreateString("en"))) return  FlLang.En;
	
		if(langStr.Equals(StringUtils.CreateString("es"))) return  FlLang.Es;
	if(langStr.Equals(StringUtils.CreateString("fr"))) return  FlLang.Fr;
	if(langStr.Equals(StringUtils.CreateString("it"))) return  FlLang.It;
	return  FlLang.undefined;

}


public static short Localize (short lang) {

	 short langIgnoreLocale = FlLang.undefined;

		
	for(int i =0;i < GetNbSupportedLang();i ++)
	{
		
		if(lang == mSupportedLang[i])
		{
			return  mSupportedLang[i];
		}

		
		if((lang & 0x0FFF) == (mSupportedLang[i] & 0x0FFF))
		{
			langIgnoreLocale = mSupportedLang[i];
		}
	}
	
	return  langIgnoreLocale;

}


public static short mBestLangCache = FlLang.uninitialized;

/* One dimension array */
public static FlLang[] InstArrayFlLang(int size) {
	FlLang[] newArray = new FlLang[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new FlLang();
	return newArray; }

/* Two dimension array */
public static FlLang[][] InstArrayFlLang(int size1, int size2) {
	FlLang[][] newArray = new FlLang[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlLang[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new FlLang(); }
	return newArray; }

/* Three dimension array */
public static FlLang[][][] InstArrayFlLang(int size1, int size2, int size3) {
	FlLang[][][] newArray = new FlLang[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new FlLang[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new FlLang[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new FlLang(); } }
	return newArray; }

public FlLang () { 
}




}

