package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class HalfSpace {

public static HalfSpace Cast(Object o, HalfSpace _) {
 return  (HalfSpace)o; 
}


public void OnSerialize(Package p) {

}


public FVec3T_F32 outwardNormal;
public F32 pointOnPlaneDotOutwardNormal;
public HalfSpace () {
outwardNormal = new FVec3T_F32();
pointOnPlaneDotOutwardNormal = new F32();


}


public  HalfSpace ( FVec3T_F32 parPointOnPlane, FVec3T_F32 parOutwardNormal) {
outwardNormal = new FVec3T_F32(parOutwardNormal);
pointOnPlaneDotOutwardNormal = new F32();


  pointOnPlaneDotOutwardNormal = parPointOnPlane.Dot(outwardNormal, 16);

}


public void Init ( FVec3T_F32 parPointOnPlane, FVec3T_F32 parOutwardNormal) {

	outwardNormal.Assign(parOutwardNormal);
	pointOnPlaneDotOutwardNormal = parPointOnPlane.Dot(outwardNormal, 16);

}


public byte WhichSideOfPlane ( Box3 box) {

  
  if(Intersects(box)) {
    if(Contains(box)) return  BoundsSide.Inside;
	else return  BoundsSide.BothSides;
  }
  else return  BoundsSide.Outside;

}


public byte WhichSideOfPlane ( Box3 box, F32 radiusAddedToBox) {

  FVec3T_F32 innermostCorner = new FVec3T_F32();

  FVec3T_F32 outermostCorner = new FVec3T_F32();

	if(outwardNormal.x.GreaterOrEqual(F32.Zero(16))) {innermostCorner.x = box.minCorner.x; outermostCorner.x = box.maxCorner.x;}
	else                      {innermostCorner.x = box.maxCorner.x; outermostCorner.x = box.minCorner.x;}
	if(outwardNormal.y.GreaterOrEqual(F32.Zero(16))) {innermostCorner.y = box.minCorner.y; outermostCorner.y = box.maxCorner.y;}
	else                      {innermostCorner.y = box.maxCorner.y; outermostCorner.y = box.minCorner.y;}
	if(outwardNormal.z.GreaterOrEqual(F32.Zero(16))) {innermostCorner.z = box.minCorner.z; outermostCorner.z = box.maxCorner.z;}
	else                      {innermostCorner.z = box.maxCorner.z; outermostCorner.z = box.minCorner.z;}
   F32 innermostPointProjection = new F32(innermostCorner.Dot(outwardNormal, 16).Sub(radiusAddedToBox));

  if(innermostPointProjection.LessOrEqual(pointOnPlaneDotOutwardNormal)) {
	   F32 outermostPointProjection = new F32(outermostCorner.Dot(outwardNormal, 16).Add(radiusAddedToBox));

    if(outermostPointProjection.LessOrEqual(pointOnPlaneDotOutwardNormal)) return  BoundsSide.Inside;
    else return  BoundsSide.BothSides;
  }
  else return  BoundsSide.Outside;

}


public F32 DistanceToPlane ( FVec3T_F32 point) {

	return  point.Dot(outwardNormal, 16).Sub(pointOnPlaneDotOutwardNormal).Abs();

}


public boolean PlaneContains ( FVec3T_F32 point) {

	return  point.Dot(outwardNormal, 16).Equals(pointOnPlaneDotOutwardNormal);

}


public boolean GetIntersection_LineWithPlane ( FVec3T_F32 lineEndPoint1, FVec3T_F32 lineEndPoint2, FVec3T_F32 outIntersectionPt) {

	










	outIntersectionPt.Assign(lineEndPoint1);
	if(lineEndPoint1.Equals(lineEndPoint2)) return  PlaneContains(lineEndPoint1) ? true : false;

	 F32 zero = new F32(F32.Zero(16));

	 F32 one = new F32(F32.One(16));


	 FVec3T_F32 A = new FVec3T_F32(lineEndPoint2.Sub(lineEndPoint1));

	 FVec3T_F32 B = new FVec3T_F32(lineEndPoint1);

	 FVec3T_F32 N = new FVec3T_F32(outwardNormal);

	 F32 D = new F32(pointOnPlaneDotOutwardNormal.Neg());


	 F32 denom = new F32(N.x.Mul(A.x, 16).Add(N.y.Mul(A.y, 16)).Add(N.z.Mul(A.z, 16)));

	if(denom.Equals(zero)) return  false; 

	 F32 num = new F32((N.x.Mul(B.x, 16).Add(N.y.Mul(B.y, 16)).Add(N.z.Mul(B.z, 16)).Add(D)).Neg());

	
	 F32 t = new F32(num.Div(denom, 16));

	if(t.LessThan(zero) || t.GreaterThan(one)) return  false; 

	outIntersectionPt.Assign(A.Mul(t, 16).Add(B));

	return  true;

}


public boolean Contains ( FVec3T_F32 point) {

  return  point.Dot(outwardNormal, 16).LessOrEqual(pointOnPlaneDotOutwardNormal);

}


public boolean Intersects ( Box3 box) {


   boolean a = (outwardNormal.x.GreaterOrEqual(F32.Zero(16)));

   boolean b = (outwardNormal.y.GreaterOrEqual(F32.Zero(16)));

   boolean c = (outwardNormal.z.GreaterOrEqual(F32.Zero(16)));

  
   F32 f32x = new F32(a ? box.minCorner.x : box.maxCorner.x);

   F32 f32y = new F32(b ? box.minCorner.y : box.maxCorner.y);

   F32 f32z = new F32(c ? box.minCorner.z : box.maxCorner.z);


   FVec3T_F32 innermostCorner = new FVec3T_F32(f32x, f32y, f32z);


  return  Contains(innermostCorner);

}


public boolean Contains ( Box3 box) {


   boolean a = (outwardNormal.x.GreaterOrEqual(F32.Zero(16)));

   boolean b = (outwardNormal.y.GreaterOrEqual(F32.Zero(16)));

   boolean c = (outwardNormal.z.GreaterOrEqual(F32.Zero(16)));


   FVec3T_F32 outermostCorner = new FVec3T_F32(a ? box.maxCorner.x : box.minCorner.x, b ? box.maxCorner.y : box.minCorner.y, c ? box.maxCorner.z : box.minCorner.z);

  return  Contains(outermostCorner);

}


public byte WhichSideOfPlane ( Sphere sphere) {

	






	 F32 commonExpression = new F32(sphere.GetCenter().Dot(outwardNormal, 16).Sub(pointOnPlaneDotOutwardNormal));

	if(commonExpression.LessOrEqual(sphere.GetRadius()))
	{
		if(commonExpression.LessOrEqual(sphere.GetRadius().Neg()))
		{
			return  BoundsSide.Inside;
		}
		else
		{
			return  BoundsSide.BothSides;
		}
	}
	else
	{
		return  BoundsSide.Outside;
	}

}


public boolean Intersects ( Sphere sphere) {

  return  sphere.GetCenter().Dot(outwardNormal, 16).Sub(sphere.GetRadius()).LessOrEqual(pointOnPlaneDotOutwardNormal);  

}


public boolean Contains ( Sphere sphere) {

  return  sphere.GetCenter().Dot(outwardNormal, 16).Add(sphere.GetRadius()).LessOrEqual(pointOnPlaneDotOutwardNormal);  

}


public  HalfSpace Assign ( HalfSpace other) {

	outwardNormal.Assign(other.outwardNormal);
	pointOnPlaneDotOutwardNormal = other.pointOnPlaneDotOutwardNormal;
	return this;

}



/* One dimension array */
public static HalfSpace[] InstArrayHalfSpace(int size) {
	HalfSpace[] newArray = new HalfSpace[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new HalfSpace();
	return newArray; }

/* Two dimension array */
public static HalfSpace[][] InstArrayHalfSpace(int size1, int size2) {
	HalfSpace[][] newArray = new HalfSpace[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new HalfSpace[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new HalfSpace(); }
	return newArray; }

/* Three dimension array */
public static HalfSpace[][][] InstArrayHalfSpace(int size1, int size2, int size3) {
	HalfSpace[][][] newArray = new HalfSpace[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new HalfSpace[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new HalfSpace[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new HalfSpace(); } }
	return newArray; }



}

