package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class InactivityManager extends TimeControlled {

public  InactivityManager (Application pApp) {
mApp = pApp;
mInactivityTimeoutMs = (60* 1000);



}


public int GetInactivityTimeoutMs () {

	return  mInactivityTimeoutMs;

}


public void SetInactivityTimeoutMs (int milliseconds) {

	mInactivityTimeoutMs = milliseconds;

}


public boolean IsEnabled () {

	return  mEnabled;

}


public void SetEnabled (boolean enable) {

	if((mEnabled && !enable) && (mApp.GetGlobalTimeSystem().IsRegistered(this)))
	{
		mApp.GetGlobalTimeSystem().UnRegister(this);
	}
	else if((!mEnabled && enable) && (! mApp.GetGlobalTimeSystem().IsRegistered(this)))
	{
		mTotalElapsedTime = 0;
		mApp.GetGlobalTimeSystem().Register(this);
	}
	
	mEnabled = enable;	

}


public void NotifyActivity () {

	if(IsEnabled())
	{
		mTotalElapsedTime = 0;

		if(!mApp.GetGlobalTimeSystem().IsRegistered(this))
		{
			mApp.OnResumeFromOS();
			mApp.SetState(Application.StateActive);

			mApp.GetGlobalTimeSystem().Register(this);
		}
	}

}


public Application mApp;
public int mInactivityTimeoutMs;
public int mTotalElapsedTime;
public boolean mEnabled;
public void OnTime (int totalTimeMs, int deltaTimeMs) {


	
	mTotalElapsedTime += deltaTimeMs;

	if(mTotalElapsedTime > GetInactivityTimeoutMs())
	{
		mApp.GetGlobalTimeSystem().UnRegister(this);

		mApp.SetState(Application.StateInactive);
		mApp.OnSuspendFromOS();
	}

}





}

