package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class IndexedSprite extends Sprite {

public static IndexedSprite Cast(Object o, IndexedSprite _) {
 return  (IndexedSprite)o; 
}


 final public static byte typeNumber = TypeIDOfType_IndexedSprite.v;
 final public static byte typeID = TypeIDOfType_IndexedSprite.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  IndexedSprite () {



}


public void destruct() {

	if(mBmpGrp != null)
	{
		mBmpGrp = null;
	}

}


public void OnDraw (DisplayContext displayContext) {



if(mBmpGrp == null)
	{
		return ;
	}

	mBmpGrp.DrawElementAt(mCurrentFrame, displayContext, mRect_left, mRect_top, mRect_width, mRect_height, mOpacity, mTileInX, mTileInY);




}


public void SetBitmapGroup (BitmapGroup inBitmapGrp) {

	mBmpGrp = inBitmapGrp;
	SetCurrentFrame(mCurrentFrame);

}


public void SizeToBitmap () {


	 int frame = (int)mCurrentFrame;

	 short sizeWidth = mBmpGrp.GetPublicSizeXAt(frame);

	 short sizeHeight = mBmpGrp.GetPublicSizeYAt(frame);

	SetSize(sizeWidth, sizeHeight);	

}


public void SetCurrentFrame (int frame) {

	 BitmapGroup bmpGrp = mBmpGrp;

	if(bmpGrp != null)
	{


		frame %= bmpGrp.GetBitmapCount();
		mCurrentFrame = frame;

		 short sizeWidth = bmpGrp.GetPublicSizeXAt(frame);

		 short sizeHeight = bmpGrp.GetPublicSizeYAt(frame);



        if(mTileInX)
		{
			sizeWidth = GetRectWidth();
		}

		if(mTileInY)
		{
			sizeHeight = GetRectHeight();
		}
SetSize(sizeWidth, sizeHeight);
	}

}


public int GetCurrentFrame() {
 return  mCurrentFrame; 
}


public BitmapGroup GetBitmapGroup() {
 return  mBmpGrp; 
}


public void ControlValue (int valueCode, boolean setValue, Controller controller) {

	if(valueCode == indexedSpriteFrame)
	{
		if(setValue)
		{			
			
				 int[] value = mValue;
			

controller.GetControlledValue(value, 1); 

			
				SetCurrentFrame(value[0]);
			

}
		else
		{	
			
				int[] value = new int[1]; value[0] = GetCurrentFrame();
			

controller.SetRequestedValue(value, 1); 
		}
	}
	else
	{
		super.ControlValue(valueCode, setValue, controller);
	}

}


public void OnSerialize (Package _package) {

	mBitmap = null;
	super.OnSerialize(_package);

	(mBmpGrp)= mBmpGrp.Cast((_package).SerializePointer((mBmpGrp).typeNumber, (mBmpGrp).supportsDynamicSerialization, false), null);
	(mCurrentFrame)= (_package).SerializeIntrinsic(mCurrentFrame);


{
		SetCurrentFrame(mCurrentFrame);
	}

}


public BitmapGroup mBmpGrp;
public int mCurrentFrame;
public int[] mValue = new int[1];


/* One dimension array */
public static IndexedSprite[] InstArrayIndexedSprite(int size) {
	IndexedSprite[] newArray = new IndexedSprite[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new IndexedSprite();
	return newArray; }

/* Two dimension array */
public static IndexedSprite[][] InstArrayIndexedSprite(int size1, int size2) {
	IndexedSprite[][] newArray = new IndexedSprite[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new IndexedSprite[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new IndexedSprite(); }
	return newArray; }

/* Three dimension array */
public static IndexedSprite[][][] InstArrayIndexedSprite(int size1, int size2, int size3) {
	IndexedSprite[][][] newArray = new IndexedSprite[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new IndexedSprite[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new IndexedSprite[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new IndexedSprite(); } }
	return newArray; }



}

