package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Interpolator {

public final static byte STEP = 0;
public final static byte LINEAR = 1;
public final static byte SPLINE = 2;
public final static byte SLERP = 3;
public final static byte SQUAD = 4;

public static F32 InterpolateLinear ( F32 valueA, F32 valueB, F32 ratio) {

	


	
	
	 long left = ((long)(valueA.value)) * ((1<< 16) - ((long)(ratio.value)));

	 long right = ((long)(valueB.value)) * ((long)(ratio.value));

	


return  new F32((int)((left + right) >> 16), 16);
	
}



/* One dimension array */
public static Interpolator[] InstArrayInterpolator(int size) {
	Interpolator[] newArray = new Interpolator[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Interpolator();
	return newArray; }

/* Two dimension array */
public static Interpolator[][] InstArrayInterpolator(int size1, int size2) {
	Interpolator[][] newArray = new Interpolator[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Interpolator[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Interpolator(); }
	return newArray; }

/* Three dimension array */
public static Interpolator[][][] InstArrayInterpolator(int size1, int size2, int size3) {
	Interpolator[][][] newArray = new Interpolator[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Interpolator[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Interpolator[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Interpolator(); } }
	return newArray; }

public Interpolator () { 
}




}

