package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Memory {

public static long CalculateCRC (byte [] data, int startPos, int size) {

	
	 long[] crc_table = new long[256];

	long c;


	int n;

	int k;


	for(n = 0;n < 256;n ++)
	{
		c = (long)n;
		for(k = 0;k < 8;k ++)
		{
			if((c & 1) != 0)
				c = 0xedb88320L ^ (c >> 1);
			else
				c = c >> 1;
		}
		crc_table[n] = c;
	}
	c = 0xffffffffL;

	for(n = startPos;n < size + startPos;n ++)
	{
		c = crc_table[(int)(c ^ data[n]) & 0xff] ^ (c >> 8);
	}

	 long crc = c ^ 0xffffffffL;


	crc_table = null;

	
	return  crc;

}


public static String CalculateMD5 (byte [] data, int startPos, int size) {

	return  StringUtils.CreateString("N/A");

}


public static long CalculateCRC (int [] data, int startPos, int size) {

	
	 long[] crc_table = new long[256];

	long c;


	int n;

	int k;


	for(n = 0;n < 256;n ++)
	{
		c = (long)n;
		for(k = 0;k < 8;k ++)
		{
			if((c & 1) != 0)
				c = 0xedb88320L ^ (c >> 1);
			else
				c = c >> 1;
		}
		crc_table[n] = c;
	}
	c = 0xffffffffL;

	for(n = startPos;n < size + startPos;n ++)
	{
		 int currInt = data[n];

		for(int i = 0;i < 4;i ++)
		{
			 byte currByte = (byte)(currInt >> (i * 8) & 0xff);

			c = crc_table[(int)(c ^ currByte) & 0xff] ^ (c >> 8);
		}
	}

	 long crc = c ^ 0xffffffffL;


	crc_table = null;

	
	return  crc;

}


public static void WriteIntToByte (int data, byte [] result, int index) {

	for(int i = 1;i < index + 1;i ++)
	{
		result[result.length-i] = (byte)((data >> 24- (i * 8)));
	}

}


public static int WriteIntToByteArray (int data, byte [] result, int index) {

	result[index++] = (byte)(data >> 24);
	result[index++] = (byte)(data >> 16);
	result[index++] = (byte)(data >> 8);
	result[index++] = (byte)(data);
	return  index;

}


public static long ReadLong64FromArray (byte [] data, int index) {

	 byte b0 = (byte)(((data[index	] & 0xff)));

	 byte b1 = (byte)(((data[index + 1] & 0xff)));

	 byte b2 = (byte)(((data[index + 2] & 0xff)));

	 byte b3 = (byte)(((data[index + 3] & 0xff)));

	 byte b4 = (byte)(((data[index + 4] & 0xff)));

	 byte b5 = (byte)(((data[index + 5] & 0xff)));

	 byte b6 = (byte)(((data[index + 6] & 0xff)));

	 byte b7 = (byte)(((data[index + 7] & 0xff)));


	 long hw = ((((short)b0 & 0xFF) << 24) | (((short)b1 & 0xFF) << 16) | (((short)b2 & 0xFF) << 8) | (short)b3 & 0xFF);

	 long lw = ((((short)b4 & 0xFF) << 24) | (((short)b5 & 0xFF) << 16) | (((short)b6 & 0xFF) << 8) | (short)b7 & 0xFF);

	 long p = (hw << 32) | (lw & 0xFFFFFFFFL);

	
	return  p;

}


public static void WriteLong64ToByteArray (byte [] data, long toWrite, int index) {


	 byte b0 = (byte)((toWrite >> 56) & 0xFF);

	 byte b1 = (byte)((toWrite >> 48) & 0xFF);

	 byte b2 = (byte)((toWrite >> 40) & 0xFF);

	 byte b3 = (byte)((toWrite >> 32) & 0xFF);

	 byte b4 = (byte)((toWrite >> 24) & 0xFF);

	 byte b5 = (byte)((toWrite >> 16) & 0xFF);

	 byte b6 = (byte)((toWrite >> 8) & 0xFF);

	 byte b7 = (byte)((toWrite >> 0) & 0xFF);




	Memory.WriteByte(data, b0, index);
	Memory.WriteByte(data, b1, index + 1);
	Memory.WriteByte(data, b2, index + 2);
	Memory.WriteByte(data, b3, index + 3);
	Memory.WriteByte(data, b4, index + 4);
	Memory.WriteByte(data, b5, index + 5);
	Memory.WriteByte(data, b6, index + 6);
	Memory.WriteByte(data, b7, index + 7);


}


public static byte ReadByte (byte [] data, int index) {

	return  data[ index ];

}


public static void WriteByte (byte [] data, byte toWrite, int index) {


	data[index] = toWrite;

}


public static byte MakeByte(int b) {

				return  (byte)b;
			
}


public static int MakeUnsignedByte(byte b) {
 return  (b & 0xFF);
			
}


public static void Set(byte[] inDest, int value, int size) {
 for(int i = 0;i < size;++i)
				{
					inDest[i] = (byte)value;
				}
			
}


public static void Zero(byte[] inDest, int size) {
 Set(inDest, (byte)0, size);
			
}


public static void Set(int[] inDest, int value, int size) {
 for(int i = 0;i < size;++i)
				{
					inDest[i] = (int)value;
				}
			
}


public static void Zero(int[] inDest, int size) {
 Set(inDest, (int)0, size);
			
}


public static void Set(short[] inDest, int value, int size) {
 for(int i = 0;i < size;++i)
				{
					inDest[i] = (short)value;
				}
			
}


public static void Zero(short[] inDest, int size) {
 Set(inDest, (short)0, size);
			
}


public static void Copy (Object inDest, Object inSource, int size) {

	 
		System.arraycopy(inSource, 0, inDest, 0, size);
	

}


public static void Copy (byte [] inDest, int destOffset, byte [] inSource, int srcOffset, int size) {

	 
		System.arraycopy(inSource, srcOffset, inDest, destOffset, size);
	

}



/* One dimension array */
public static Memory[] InstArrayMemory(int size) {
	Memory[] newArray = new Memory[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Memory();
	return newArray; }

/* Two dimension array */
public static Memory[][] InstArrayMemory(int size1, int size2) {
	Memory[][] newArray = new Memory[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Memory[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Memory(); }
	return newArray; }

/* Three dimension array */
public static Memory[][][] InstArrayMemory(int size1, int size2, int size3) {
	Memory[][][] newArray = new Memory[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Memory[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Memory[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Memory(); } }
	return newArray; }

public Memory () { 
}




}

