package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class MemoryStream extends Stream {

public MemoryStream () {

	mData = null;
	mPosition = 0;

}


public MemoryStream (byte [] inStream) {

	SetMemoryStream(inStream);

}


public void destruct() {

	mData = null; 

}


public void SetMemoryStream (byte [] inStream) {

	mData = inStream;
	mPosition = 0;

}


public void Skip (int size) {

	mPosition += size;

}


public int Read (byte [] buffer, int size) {

	Memory.Copy(buffer, 0, mData, mPosition, size);
	Skip(size);

	return  0;

}


public int Write ( byte [] buffer, int size) {

	Memory.Copy(mData, mPosition, buffer, 0, size);
	Skip(size);

	return  0;

}


public int GetPosition () {

	return  mPosition;

}


public void SetPosition (int offset) {

	mPosition = offset;

}


public byte ReadByte () {

	
	return  mData[mPosition++];

}


public short ReadShort () {

	
	
	{
		short retVal = (short)( (( mData[mPosition] & 0xff) << 8) + (mData[mPosition + 1] & 0xff) );
		mPosition += 2;
		return retVal;
	}
	

}


public int ReadLong () {

	
	
	{
		byte[] buffer = mData;
		int pointer = mPosition;
		int retVal = (((buffer[pointer] & 0xff) << 24) | ((buffer[pointer + 1] & 0xff) << 16) | ((buffer[pointer + 2] & 0xff) << 8) | (buffer[pointer + 3] & 0xff));
		mPosition += 4;
		return retVal;
	}
	

}


public String ReadString () {

	 short size = ReadShort();


	 byte [] data = new byte[size + 1];

	if(size != 0)
	{





Read((byte [])data, size * 1);
}

	data[size] = 0;

	 String string = new String(data);

	data = null;
	return  string;

}


public void WriteByte ( byte data) {


	
	{
		mTmpArray[0] = data;
		Write(mTmpArray, 1);
	}
	

}


public void WriteShort ( short data) {


		
	{
		mTmpArray[0] = (byte)(0xff & (data >> 8));
		mTmpArray[1] = (byte)(0xff & data);
		Write(mTmpArray, 2);
	}
	

}


public void WriteLong ( int data) {


	
	{
		byte[] tmpArray = mTmpArray;
		tmpArray[0] = (byte)(0xff & (data >> 24));
		tmpArray[1] = (byte)(0xff & (data >> 16));
		tmpArray[2] = (byte)(0xff & (data >> 8));
		tmpArray[3] = (byte)(0xff & data);
		Write(tmpArray, 4);
	}
	

}


public void WriteString ( String data) {

	data.Write(this);

}


public void WriteText ( String data) {

	data.Write(this, false);

}


public byte [] mData;
public int mPosition;
public byte[] mTmpArray = new byte[4];


/* One dimension array */
public static MemoryStream[] InstArrayMemoryStream(int size) {
	MemoryStream[] newArray = new MemoryStream[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new MemoryStream();
	return newArray; }

/* Two dimension array */
public static MemoryStream[][] InstArrayMemoryStream(int size1, int size2) {
	MemoryStream[][] newArray = new MemoryStream[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MemoryStream[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new MemoryStream(); }
	return newArray; }

/* Three dimension array */
public static MemoryStream[][][] InstArrayMemoryStream(int size1, int size2, int size3) {
	MemoryStream[][][] newArray = new MemoryStream[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MemoryStream[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new MemoryStream[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new MemoryStream(); } }
	return newArray; }



}

