package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Scene extends Viewport {

public final static byte noTransition = 0;
public final static byte dismiss = 1;
public final static byte launch = 2;
public final static byte launchPopUp = 3;

public final static byte transitionIsLaunch = -2;
public final static byte lastDismissParam = -3;

public  Scene () {



}


public void destruct() {

}


public static void Launch (Scene nextScene) {


	StartTransition(launch, nextScene, transitionIsLaunch);

}


public static void LaunchPopUp (Scene nextScene) {


	StartTransition(launchPopUp, nextScene, transitionIsLaunch);

}


public static void Dismiss (int param) {



	 Application application = Application.GetInstance();


	 Scene currentScene = application.mCurrentScene;


	 Scene previousScene = currentScene.mReturnScene;

	if(previousScene != null)
	{
		StartTransition(dismiss, previousScene, param);
	}
	else
	{
		application.TakeFocus();

		FlPenManager.Get().Deactivate();
application.mCurrentScene = null;
		currentScene.SetViewport(null);

		currentScene.OnDelete();
	}

}


public void CompleteTransition () {

	 Application application = Application.GetInstance();
	 byte transitionType = application.mCurrentTransitionType;

	 Scene transitionSource = transitionType == dismiss ? application.mCurrentScene : mReturnScene;
	 Viewport parent = null;

	if(transitionSource != null)
	{
		if(GetViewport() == null)
		{
			parent = transitionSource.GetViewport();
		}

		if(transitionType == dismiss)
		{
			SendMsg(transitionSource, completedTransitionMsg, -1);
			application.mCurrentScene = this;
		}
		else if(transitionType == launch)
		{
			transitionSource.SetViewport(null);
		}

		if(parent != null)
		{
			SetViewport(parent);
		}
	}

	application.ResetDownKeys();
	TakeFocus();

	FlPenManager.Get().Activate();
application.mCurrentTransitionType = noTransition;

}


public void DetachAndSkip (Component sourceScene, int msg, int param) {
	  		



	SetViewport(null);	  		
	mReturnScene.SendMsg(sourceScene, msg, param);

}


public void OnDelete () {




}


public boolean OnDefaultMsg (Component source, int msg, int param) {

	switch(msg)
	{
	case startTransitionMsg :
		CompleteTransition();	
		return  true;

	case returnedFromSceneMsg :

		source.SetViewport(null);
		((Scene)source).OnDelete();
		return  true;

	case completedTransitionMsg :
		{
			 Scene scene = (Scene)source;
			 Scene returnScene = null;	

			while(scene != this)
			{
				returnScene = scene.mReturnScene;



				scene.mReturnScene = null;
				returnScene.SendMsg(scene, returnedFromSceneMsg, -1);
				scene = returnScene;
			};

			return  true;
		}

	case quitTransitionMsg :
		if(mReturnScene != null)
		{
			
			DetachAndSkip(source, msg, param);	  				
		}
		else
		{
			 Application application = Application.GetInstance();
			SendMsg(application.mCurrentScene, completedTransitionMsg, -1);
			application.mCurrentScene = this;
			application.mCurrentTransitionType = noTransition;
			Dismiss(lastDismissParam);
		}
		return  true;

	default :
		return  false;	  		
	}

}


public static void StartTransition (byte transitionType, Scene nextScene, int param) {

	 Application application = Application.GetInstance();

	if(param == transitionIsLaunch)
	{
		nextScene.mReturnScene = application.mCurrentScene;
		application.mCurrentScene = nextScene;
	}

	application.mCurrentTransitionType = (byte)transitionType;
	application.TakeFocus();

	FlPenManager.Get().Deactivate();
nextScene.SendMsg(application.mCurrentScene, startTransitionMsg, param);

}


public Scene mReturnScene;

/* One dimension array */
public static Scene[] InstArrayScene(int size) {
	Scene[] newArray = new Scene[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Scene();
	return newArray; }

/* Two dimension array */
public static Scene[][] InstArrayScene(int size1, int size2) {
	Scene[][] newArray = new Scene[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Scene[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Scene(); }
	return newArray; }

/* Three dimension array */
public static Scene[][][] InstArrayScene(int size1, int size2, int size3) {
	Scene[][][] newArray = new Scene[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Scene[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Scene[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Scene(); } }
	return newArray; }



}

