package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Scroller extends Viewport {

public static Scroller Cast(Object o, Scroller _) {
 return  (Scroller)o; 
}


 final public static byte typeNumber = TypeIDOfType_Scroller.v;
 final public static byte typeID = TypeIDOfType_Scroller.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte intermediateState = 0;
public final static byte finalState = 1;

public  Scroller () {
mIsVertical = (true);



}


public  Scroller (int maxNumElements) {
mMaxNumElements = (maxNumElements);
mIsVertical = (true);


	mElements = AllocComponentTable();

}


public void destruct() {

	mElements = null;

}


public void SetMaxNumElements (int maxNumElements) {

	mMaxNumElements = maxNumElements;
	 Component[] newElements = AllocComponentTable();

	 int numElementsKept = (mMaxNumElements < mNumElements ? mMaxNumElements : mNumElements);

	for(int i = 0;i < numElementsKept;i ++)
	{
		newElements[i] = mElements[i];
	}

	mElements = newElements;;

}


public void SetElementAt (int index, Component element) {



































mElements[index] = element;

}


public Component GetElementAt(int index) {

		return  mElements[index];
	
}


public void SetNumElements(int numElements) {

		mNumElements = numElements;
	
}


public int GetNumElements() {
 return  mNumElements; 
}


public void SetNextArrow(Selection nextArrow) {
 ; mNextArrow = nextArrow; 
}


public Selection GetNextArrow() {
 return  mNextArrow; 
}


public void SetPreviousArrow(Selection previousArrow) {
 ; mPreviousArrow = previousArrow; 
}


public Selection GetPreviousArrow() {
 return  mPreviousArrow; 
}


public void SetIsViewportCentered(boolean newIsViewportCentered) {
 mIsViewportCentered = newIsViewportCentered; 
}


public void SetScrollerViewport(Viewport scrollerViewport) {
 mScrollerViewport = scrollerViewport; 
}


public F32 GetScrollbarRatio () {

	 Component first = GetFirstElement();

	Vector2_short tempOffset = new Vector2_short();

	mScrollerViewport.GetRequiredOffsetChange(tempOffset, first, false);

	if(mIsVertical)
	{
		 int totalHeight = GetVerticalTotalScrollingSize();

		if(mScrollerViewport.GetRectHeight() >= totalHeight)
		{
			return  F32.Zero(16);
		}


		return  new F32((int)(-tempOffset.GetY()), 16).Div(new F32((int)(totalHeight - mScrollerViewport.GetRectHeight()), 16), 16);
	}
	else
	{
		 int totalWidth = GetHorizontalTotalScrollingSize();

		if(mScrollerViewport.GetRectWidth() >= totalWidth)
		{
			return  F32.Zero(16);
		}


		return  new F32((int)(-tempOffset.GetX()), 16).Div(new F32((int)(totalWidth - mScrollerViewport.GetRectWidth()), 16), 16);
	}

}


public short GetVisibleWindowSize () {

	if(mIsVertical)
	{
		return  mScrollerViewport.GetRectHeight();
	}
	else
	{
		return  mScrollerViewport.GetRectWidth();
	}

}


public short GetTotalScrollingSize () {

	return  mIsVertical ? GetVerticalTotalScrollingSize() : GetHorizontalTotalScrollingSize();

}


public short GetFirstElemOffset () {

	if(mIsVertical)
	{
		return  mScrollerViewport.GetOffsetY();
	}
	else
	{
		return  mScrollerViewport.GetOffsetX();
	}

}


public void SetVertical(boolean isVertical) {
 mIsVertical = isVertical; 
}


public boolean IsVertical() {
 return  mIsVertical; 
}


public void OnSerialize (Package p) {

	super.OnSerialize(p);

	(mNextArrow)= mNextArrow.Cast((p).SerializePointer((mNextArrow).typeNumber, (mNextArrow).supportsDynamicSerialization, false), null);
	(mPreviousArrow)= mPreviousArrow.Cast((p).SerializePointer((mPreviousArrow).typeNumber, (mPreviousArrow).supportsDynamicSerialization, false), null);

	(mScrollerViewport)= mScrollerViewport.Cast((p).SerializePointer((mScrollerViewport).typeNumber, (mScrollerViewport).supportsDynamicSerialization, false), null);

	(mIsVertical)= (p).SerializeIntrinsic(mIsVertical);
	(mIsViewportCentered)= (p).SerializeIntrinsic(mIsViewportCentered);

	
	(mNumElements)= (p).SerializeIntrinsic(mNumElements); 
	(mMaxNumElements)= (p).SerializeIntrinsic(mMaxNumElements);








{
		mElements = AllocComponentTable();
	}

	int i;

	for(i = 0;i < mNumElements;i ++)
	{


Component element = null;

(element)= element.Cast((p).SerializePointer((element).typeNumber, (element).supportsDynamicSerialization, false), null);
		mElements[i] = element;
	}

	if(p.IsReading())
	{
		ResetScroller();
	}

}


public boolean OnDefaultMsg (Component source, int msg, int intParam) {

	if(msg == resetAncestorScrollerMsg)
	{
		ResetScroller();
		return  true;
	}
	else if(msg == focusMsg)
	{
		FocusGained(intParam);
		return  false;
	}



























else if(msg == pushedMsg) 
	{
		 boolean fromNextArrow = (null != mNextArrow) && mNextArrow.IsSelfOrAncestorOf(source);

		 boolean fromPreviousArrow = (null != mPreviousArrow) && mPreviousArrow.IsSelfOrAncestorOf(source);


		if(((Selection.releasedState == intParam) || (Selection.canceledState == intParam)) && 
				(fromNextArrow || fromPreviousArrow))
		{
			SendMsg(this, scrollerUpdatedMsg, finalState);
		}

		else if(((Selection.pushedState == intParam) || (Selection.pushedRepeatState == intParam)) && !mArrowBehaviorCameFromScroller)
		{
			if(fromNextArrow)
			{
				OnScrollEvent(1);
			}
			else if(fromPreviousArrow)
			{
				OnScrollEvent(-1);
			}
		}
}
	else if (	(msg == Component.keyUpMsg) || 
				(msg == Component.keyDownMsg) ||
				(msg == Component.keyDownOrRepeatMsg))
	{
		 int advance = 0;

		 int key = (int)intParam;


		if(mIsVertical)
		{
			if(key == Key.UP) 
			{
				advance = -1;
			}
			else if(key == Key.DOWN)
			{
				advance = 1;
			}
		}
		else
		{
			if(key == Key.LEFT)
			{
				advance = -1;
			}
			else if(key == Key.RIGHT)
			{
				advance = 1;
			}
		}

		if(advance != 0)
		{
			if(mNumElements <= 0)
			{
				return  true;
			}


			if(mNextArrow != null)
			{
				 Selection arrow = (advance == 1) ? mNextArrow : mPreviousArrow;
				 boolean isKeyDown = Component.keyUpMsg != msg;


				mArrowBehaviorCameFromScroller = isKeyDown;
arrow.SetPushedState(isKeyDown);
			}
			else if(Component.keyUpMsg == msg)
			{
				SendMsg(this, scrollerUpdatedMsg, finalState);	
			}

			if(msg == Component.keyDownOrRepeatMsg) 
			{
				OnScrollEvent(advance);
			}

			return  true;
		}

		if(IsAppropriateHotkey(msg, key)) 
		{
			return  true;
		}
	}

	return  super.OnDefaultMsg(source, msg, intParam);

}


public void FocusGained (int entering) {
	
	if(mNextArrow != null)
	{
		 boolean isEntering = (entering != isLeaving);



		mNextArrow.SetSelectedState(isEntering);		
		mPreviousArrow.SetSelectedState(isEntering);
	}

}


public void ResetScroller () {

	if(mNumElements > 0)
	{
		 Component firstElement = GetFirstElement();
		 Component lastElement = GetLastElement();
		 Viewport scrollerViewport = mScrollerViewport;
		 boolean isScrollable = (mIsVertical ? (GetVerticalTotalScrollingSize() > scrollerViewport.GetRectHeight()) : (GetHorizontalTotalScrollingSize() > scrollerViewport.GetRectWidth()));


		 short offsetX = scrollerViewport.GetOffsetX();

		 short offsetY = scrollerViewport.GetOffsetY();


		if(mIsViewportCentered && !isScrollable)
		{
			if(mIsVertical)
			{
				offsetY = (short)(-(scrollerViewport.GetRectHeight() + firstElement.GetRectTop() - lastElement.GetBottom()) / 2);
			}
			else
			{
				offsetX = (short)(-(scrollerViewport.GetRectWidth() + firstElement.GetRectLeft() - lastElement.GetRight()) / 2);
			}
		}
		else
		{
			if(mIsVertical)
			{
				offsetY = firstElement.GetRectTop();
			}
			else
			{
				offsetX = firstElement.GetRectLeft();
			}
		}

		scrollerViewport.OffsetTo(offsetX, offsetY);
	}

	UpdateScroller();

}


public void UpdateScroller () {

	CheckIfArrowsAreNeeded();
	UpdateArrowsEnabledState();

}


public short GetScrollingPosition () {

	return  mIsVertical ? mScrollerViewport.GetOffsetY() : mScrollerViewport.GetOffsetX();

}


public void SetScrollingPosition (short pos) {

	 short scrollerOffsetX = 0;

	 short scrollerOffsetY = 0;


	if(mIsVertical)
	{
		scrollerOffsetY = pos;
	}
	else
	{
		scrollerOffsetX = pos;
	}

	mScrollerViewport.OffsetTo(scrollerOffsetX, scrollerOffsetY);

}


public Component[] AllocComponentTable () {

	 Component[] newElements = new Component[mMaxNumElements];


return  newElements;

}


public void UpdateArrowsEnabledState () {

	

	if(mNextArrow != null && mNumElements > 0)
	{
		Vector2_short tempOffset = new Vector2_short();

		mScrollerViewport.GetRequiredOffsetChange(tempOffset, GetFirstElement(), false);
		mPreviousArrow.SetEnabledState(tempOffset.GetY() < 0);
		mScrollerViewport.GetRequiredOffsetChange(tempOffset, GetLastElement(), true);
		mNextArrow.SetEnabledState(tempOffset.GetY() > 0);
	}

}


public void CheckIfArrowsAreNeeded () {



	

	if(mNextArrow != null)
	{
		 boolean arrowVisible = false;


		if(mNumElements > 0)
		{
			Vector2_short tempOffset = new Vector2_short();

			mScrollerViewport.GetRequiredOffsetChange(tempOffset, GetFirstElement(), false); 
			 boolean topXIsVisible = (tempOffset.GetX() == 0);

			 boolean topYIsVisible = (tempOffset.GetY() == 0);


			mScrollerViewport.GetRequiredOffsetChange(tempOffset, GetLastElement(), true); 
			 boolean bottomXIsVisible = (tempOffset.GetX() == 0);

			 boolean bottomYIsVisible = (tempOffset.GetY() == 0);


			arrowVisible = !(topXIsVisible && topYIsVisible && bottomXIsVisible && bottomYIsVisible);
		}
			
		

		mNextArrow.SetVisible(arrowVisible);
		mPreviousArrow.SetVisible(arrowVisible);
	}

}


public void OnScrollEvent (int advance, boolean updateSelection) {



	 int elementIndex = -1;

	Vector2_short offsetChange = new Vector2_short();


	 Component[] elements = mElements;

	
	if(advance == 1)
	{
		for(int i = 0;i < mNumElements;i ++)
		{
			mScrollerViewport.GetRequiredOffsetChange(offsetChange, elements[i], true);
			if(((mIsVertical && offsetChange.GetY() > 0) || (!mIsVertical && offsetChange.GetX() > 0)) && elements[i].IsVisible())
			{
				elementIndex = i;
				break;
			}
		}
	}
	else
	{
		for(int i = mNumElements - 1;i >= 0;i --)
		{
			mScrollerViewport.GetRequiredOffsetChange(offsetChange, elements[i], false);
			if(((mIsVertical && offsetChange.GetY() < 0) || (!mIsVertical && offsetChange.GetX() < 0)) && elements[i].IsVisible())
			{
				elementIndex = i;
				break;
			}
		}
	}

	if(elementIndex >= 0)
	{




























if ((elements[elementIndex] instanceof Text))
		{

			 short lineHeight = ((Text)elements[elementIndex]).GetLineHeight();



mScrollerViewport.OffsetBy((short)0, (short)(advance * lineHeight));
		}












else 
		{
			mScrollerViewport.ChangeOffsetToShow(elements[elementIndex], advance == 1);
		}

		UpdateArrowsEnabledState();
		SendMsg(this, scrollerUpdatedMsg, intermediateState);
	}

}


public boolean IsAppropriateHotkey(int msg, int key) {
 ; ; return  false; 
}


public Component GetFirstElement () {

	 Component[] elements = mElements;

	for(int i = 0;i < mNumElements;i ++)
	{

		if(elements[i].IsVisible() && mScrollerViewport.IsSelfOrAncestorOf(elements[i].GetViewport()))


{
			return  elements[i];
		}
	}
	
	return  elements[0];

}


public Component GetLastElement () {

	 Component[] elements = mElements;

	for(int i = mNumElements - 1;i >= 0;i --)
	{

		if(elements[i].IsVisible() && mScrollerViewport.IsSelfOrAncestorOf(elements[i].GetViewport()))


{
			return  elements[i];
		}
	}
	
	return  mElements[mNumElements - 1];

}


public short GetVerticalTotalScrollingSize () {

	 Component lastElement = GetLastElement();
	return  (short)(lastElement.GetAbsoluteTop() + lastElement.GetRectHeight() - GetFirstElement().GetAbsoluteTop());

}


public short GetHorizontalTotalScrollingSize () {

	 Component lastElement = GetLastElement();
	return  (short)(lastElement.GetAbsoluteLeft() + lastElement.GetRectWidth() - GetFirstElement().GetAbsoluteLeft());

}


public Component[] mElements;
public int mNumElements;
public int mMaxNumElements;
public Viewport mScrollerViewport;
public Selection mNextArrow;
public Selection mPreviousArrow;
public boolean mIsVertical;
public boolean mIsViewportCentered;
public boolean mArrowBehaviorCameFromScroller;
public void OnScrollEvent(int advance)
{
	OnScrollEvent(advance, true);
}

/* One dimension array */
public static Scroller[] InstArrayScroller(int size) {
	Scroller[] newArray = new Scroller[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Scroller();
	return newArray; }

/* Two dimension array */
public static Scroller[][] InstArrayScroller(int size1, int size2) {
	Scroller[][] newArray = new Scroller[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Scroller[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Scroller(); }
	return newArray; }

/* Three dimension array */
public static Scroller[][][] InstArrayScroller(int size1, int size2, int size3) {
	Scroller[][][] newArray = new Scroller[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Scroller[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Scroller[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Scroller(); } }
	return newArray; }



}

