package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class SoundManager {

public  SoundManager () {
mMasterVolume = (255);
mImplementor = new AndroidSoundManagerImp();


	mScaledMasterVolume = CalculateScaledMasterVolume();






FrameworkGlobals.GetInstance().soundManager = this;



mChannels = SoundPlayer.InstArraySoundPlayer(4);









}


public static SoundManager Get () {

	if(FrameworkGlobals.GetInstance().soundManager == null)
	{
		FrameworkGlobals.GetInstance().soundManager = new SoundManager();
	}
	return (FrameworkGlobals.GetInstance().soundManager);

}


public void destruct() {

	mChannels = null;

}


public SoundPlayer GetChannelSoundPlayer (int channelIndex) {


	return  mChannels[channelIndex];

}


public void SetMuted (boolean isMuted) {


	mImplementor.SetMuted(isMuted);





}


public boolean IsMuted () {


	return  mImplementor.IsMuted();







}


public void SetPauseSoundsOnInterrupt () {

	mIsPauseSoundsOnInterrupt = true;
	


}


public boolean IsPauseSoundsOnInterrupt() {
 return  mIsPauseSoundsOnInterrupt; 
}


public void PauseAllSoundPlayers () {






{
		
			for(int i = 0;i < 4;i ++)
			{
				mChannels[i].Pause();	
			}
			
			
		

















}





}


public void ResumeAllSoundPlayers () {

	





{
		for(int i = 0;i < 4;i ++)
		{
			if(mChannels[i].IsPaused())
			{
				













mChannels[i].Play();
			}
		}
	}





}


public void StopAllSoundPlayers () {






{
		for(int i = 0;i < 4;i ++)
		{
			mChannels[i].Stop();
		}
	}





}


public void SetMasterVolume (short volume) {

	if(volume > 255) {volume = 255;}
	if(volume < 0)   {volume = 0;}
	
	mMasterVolume = volume;
	mScaledMasterVolume = CalculateScaledMasterVolume();

	for(int i = 0;i < 4;i ++)
	{	
		
		mChannels[i].SetNativeVolume();
	}

	

	FrameworkGlobals.GetInstance().application.OnMasterVolumeChange(volume);

}


public short GetMasterVolume () {

	return  mMasterVolume;

}


public short GetScaledMasterVolume () {

	return  mScaledMasterVolume;

}


public static void IncMasterVolume() {
  SoundManager aSM = FrameworkGlobals.GetInstance().soundManager; aSM.SetMasterVolume((short)(aSM.mMasterVolume + (255/ 5))); 
}


public static void DecMasterVolume() {
  SoundManager aSM = FrameworkGlobals.GetInstance().soundManager; aSM.SetMasterVolume((short)(aSM.mMasterVolume - (255/ 5))); 
}


public static int CalculateNativePlayerVolume(short aPlayerVolume, int aMaxVolume)  {
 return  (aMaxVolume * aPlayerVolume * FrameworkGlobals.GetInstance().soundManager.GetScaledMasterVolume() >> 16); 
}


public AndroidSoundManagerImp mImplementor;
public short CalculateScaledMasterVolume () {

	if(SpecConstants.MasterVolumeScaleFactor > 0)
	{
		return  (short)(mMasterVolume << (short)SpecConstants.MasterVolumeScaleFactor);
	}
	else if(SpecConstants.MasterVolumeScaleFactor < 0)
	{
		return  (short)(mMasterVolume >> (short)(-SpecConstants.MasterVolumeScaleFactor));
	}
	else
	{
		return  mMasterVolume;
	}

}


public SoundPlayer[] mChannels = null;
public short mMasterVolume;
public short mScaledMasterVolume;
public boolean mIsMuted;
public boolean mIsPauseSoundsOnInterrupt;
public static int CalculateNativePlayerVolume(short aPlayerVolume)
{
	return CalculateNativePlayerVolume(aPlayerVolume, (int)100);
}

/* One dimension array */
public static SoundManager[] InstArraySoundManager(int size) {
	SoundManager[] newArray = new SoundManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new SoundManager();
	return newArray; }

/* Two dimension array */
public static SoundManager[][] InstArraySoundManager(int size1, int size2) {
	SoundManager[][] newArray = new SoundManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SoundManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new SoundManager(); }
	return newArray; }

/* Three dimension array */
public static SoundManager[][][] InstArraySoundManager(int size1, int size2, int size3) {
	SoundManager[][][] newArray = new SoundManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new SoundManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new SoundManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new SoundManager(); } }
	return newArray; }



}

