package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Sprite extends Component {

public static Sprite Cast(Object o, Sprite _) {
 return  (Sprite)o; 
}


 final public static byte typeNumber = TypeIDOfType_Sprite.v;
 final public static byte typeID = TypeIDOfType_Sprite.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public final static byte SPRITE_TILE_X = 0;
public final static byte SPRITE_TILE_Y = 1;
public final static byte SPRITE_FLIP_X = 2;
public final static byte SPRITE_FLIP_Y = 3;

public  Sprite () {
super();
mOpacity = (255);



}


public void destruct() {

	mBitmap = null;

}


public void SetBitmap (Bitmap bitmap) {

	mBitmap = bitmap;

	if(mBitmap != null)
	{


		if(!mTileInX && !mTileInY)
{
			SetSize(mBitmap.GetWidth(), mBitmap.GetHeight());
		}
	}

}


public Bitmap GetBitmap () {

	return  mBitmap;

}


public void SizeToBitmap () {


	SetSize(mBitmap.GetWidth(), mBitmap.GetHeight());

}


public void MoveBy (short inDeltaX, short inDeltaY) {

	if(inDeltaX != (short)0|| inDeltaY != (short)0)
	{		
		SetTopLeft((short)(GetRectLeft() + inDeltaX), (short)(GetRectTop() + inDeltaY));
	}

}


public void SetTileableXY (boolean tileable) {

	SetTileableX(tileable);
	SetTileableY(tileable);

}


public void SetTileableX (boolean tileable) {

	mTileInX = tileable;

}


public void SetTileableY (boolean tileable) {

	mTileInY = tileable;

}


public boolean GetTileInX() {
 return  mTileInX; 
}


public boolean GetTileInY() {
 return  mTileInY; 
}


public void SetOpacity (short opacity) {

		if(mOpacity != opacity)
		{
			mOpacity = opacity;
			Invalidate();
		}
	
}


public short GetOpacity() {
 return  mOpacity; 
}


public void OnDraw (DisplayContext displayContext) {



 Bitmap bitmap = mBitmap;

	if(bitmap == null || mOpacity == 0)
	{
		return ;
	}


	if(mTileInX || mTileInY)
	{
		 short sourceRect_left = 0;
  short sourceRect_top = 0;
  short sourceRect_width = bitmap.GetWidth();
  short sourceRect_height = bitmap.GetHeight();

		displayContext.DrawTiledBitmapSection(bitmap, bitmap.GetWidth(), bitmap.GetHeight(), (short)0, (short)0, sourceRect_left, sourceRect_top, sourceRect_width, sourceRect_height, mRect_left, mRect_top, mRect_width, mRect_height, mOpacity);	
		return ;
	}
displayContext.DrawBitmapSection(bitmap, GetRectLeft(), GetRectTop(), (short)0, (short)0, GetRectWidth(), GetRectHeight(), mOpacity);
  



}


public void OnSerialize (Package p) {

	super.OnSerialize(p);

	(mBitmap)= mBitmap.Cast((p).SerializePointer((mBitmap).typeNumber, (mBitmap).supportsDynamicSerialization, false), null);

	 byte flags = 0;













{
		
			(flags)= (p).SerializeIntrinsic(flags);

			
				mTileInX = ((flags & (1<< SPRITE_TILE_X)) != 0);
				mTileInY = ((flags & (1<< SPRITE_TILE_Y)) != 0);
			}










 byte opacityByte = 0;

	(opacityByte)= (p).SerializeIntrinsic(opacityByte);
	mOpacity = (short)Memory.MakeUnsignedByte(opacityByte);

}


public void ControlValue (int valueControlCode, boolean setValue, Controller controller) {

	if(valueControlCode == componentOpacity)
	{
		if(setValue)
		{
			SetOpacity((short)controller.GetLongValue());
		}
		else
		{
			controller.SetValue((int)GetOpacity());
		}
	}
	else
	{
		super.ControlValue(valueControlCode, setValue, controller);
	}

}


public Bitmap mBitmap;
public boolean mTileInX;
public boolean mTileInY;
public short mOpacity;

/* One dimension array */
public static Sprite[] InstArraySprite(int size) {
	Sprite[] newArray = new Sprite[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Sprite();
	return newArray; }

/* Two dimension array */
public static Sprite[][] InstArraySprite(int size1, int size2) {
	Sprite[][] newArray = new Sprite[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Sprite[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Sprite(); }
	return newArray; }

/* Three dimension array */
public static Sprite[][][] InstArraySprite(int size1, int size2, int size3) {
	Sprite[][][] newArray = new Sprite[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Sprite[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Sprite[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Sprite(); } }
	return newArray; }



}

