package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Text extends Component {

public static Text Cast(Object o, Text _) {
 return  (Text)o; 
}


 final public static byte typeNumber = TypeIDOfType_Text.v;
 final public static byte typeID = TypeIDOfType_Text.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  Text () {
mAlignment = (Alignment.LEFT);
mpCaption = new String();
mLineCount = (1);
mOpacity = (255);



}


public  Text (Viewport viewport) {
super();
mAlignment = (Alignment.LEFT);
mpCaption = new String();
mLineCount = (1);
mOpacity = (255);


	SetViewport(viewport);

}


public  Text (Viewport viewport, Font inFont, String caption, short inRect_left, short inRect_top, short inRect_width, short inRect_height, byte align) {
super();
mLineCount = (1);
mOpacity = (255);


	SetViewport(viewport);
	

	SetRect(inRect_left, inRect_top, inRect_width, inRect_height);
	SetFont(inFont);

	SetCaption(caption);

	SetAlignment(align);

}


public void destruct() {

	mpCaption = null;
	mLines = null;
	mLinesWidth = null;




























}


public void OnRectChange () {

	if(IsMultiline() && (mPreviousWidth != GetRectWidth()))
	{
		WrapText();
	}

}


public void SetOpacity (short opacity) {

	if(mOpacity != opacity)
	{
		mOpacity = opacity;
		Invalidate();
	}

}


public short GetOpacity() {
 return  mOpacity; 
}


public void SetCaption (String caption, boolean createSegment) {



	mpCaption = caption;;
	SetCaptionLength(mpCaption.GetLength());








WrapText();
	SetCurrentLine(0);

}


public void KeepTrailingWhiteSpaces(boolean keepWhiteSpaces) {
 mKeepTrailingWhiteSpaces = keepWhiteSpaces; 
}


public String GetCaption () {

	return mpCaption;

}


public String GetLineString (int inLineIndex) {


	 String caption = mpCaption;

	if(!IsMultiline())
	{
		return  caption;
	}

	 int lineStart = GetLineStartIndex(inLineIndex);

	 int lineEnd = GetLineEndIndex(inLineIndex);

	 int aLen = lineEnd - lineStart + 1;





	 String res = new String(caption, lineStart, aLen);























return  res;

}


public int GetLineStartIndex (int inLineIndex) {

	return  ((mLines[inLineIndex])& 0xFFFF);

}


public int GetLineEndIndex (int inLineIndex) {

	if(mKeepTrailingWhiteSpaces)
	{
		return  ((mLines[inLineIndex+1])& 0xFFFF) - 1;
	}
	return  ((int)(mLines[inLineIndex]) >> 16);

}


public void SetAlignment (byte alignment) {

	if(mAlignment != alignment)
	{
		mAlignment = alignment;
		Invalidate();
	}

}


public byte GetAlignment() {
 return  mAlignment; 
}


public boolean IsMultiline () {

	return  mIsMultiline;

}


public void SetMultiline (boolean multiline) {

	if(multiline != mIsMultiline)
	{
		mIsMultiline = multiline;

		if(mIsMultiline)
		{
			WrapText();
		}
		Invalidate();
	}

}


public void SetFont ( Font font) {

	
	if(mFont != font)
	{
        mFont = font;

		if(font == null)
		{
			return ;
		}

		WrapText();
		Invalidate();












}

}


public Font GetFont() {
 return mFont; 
}


public void OnDraw (DisplayContext displayContext) {



 String caption = mpCaption;
	 Font font = mFont;

	if(caption.IsEmpty() || font == null)
	{


return ;
	}

	if(mIsMultiline && mLineCount > 1)
	{






{
			displayContext.DrawMultilineString(caption, mLines, mLineCount, mRect_left, mRect_top, mRect_width, mRect_height, mCurrentLine, font, mAlignment, mLinesWidth, mOpacity);
		}
	}
	else
	{




{
			displayContext.DrawString(caption, mRect_left, mRect_top, mRect_width, mRect_height, font, mAlignment, 0, mCaptionLength, mLinesWidth[0], mOpacity);
		}
	}




}


public void NextPage () {

	if(mCurrentLine + GetLinesPerPage() < mLineCount)
	{
		SetCurrentLine(mCurrentLine + GetLinesPerPage());
	}

}


public void PreviousPage () {

	SetCurrentLine(mCurrentLine - GetLinesPerPage());

}


public boolean IsFirstPage () {

	return  (mCurrentLine < GetLinesPerPage());

}


public boolean IsLastPage () {

	return  (mCurrentLine + GetLinesPerPage() >= mLineCount);

}


public void NextLine () {

	SetCurrentLine(mCurrentLine + 1);

}


public void PreviousLine () {

	SetCurrentLine(mCurrentLine - 1);

}


public void SetCurrentLine (int lineIndex) {

	short currentLine;


	if(lineIndex < 0)
		currentLine = 0;
	else if(lineIndex >= mLineCount && mLineCount > 0)
		currentLine = (short)(mLineCount - 1);
	else
		currentLine = (short)lineIndex;

	mCurrentLine = currentLine;

	Invalidate();

}


public int GetCurrentLine () {

	return  mCurrentLine;

}


public short GetLineHeight () {

	return  (short)mFont.GetLineHeight();

}


public boolean IsFirstLine () {

	return  (mCurrentLine == 0);

}


public boolean IsLastLine () {

	return  (mLineCount == (mCurrentLine + 1));

}


public int GetNbPages () {

	if(GetLinesPerPage() != 0)
	{
		return  (mLineCount / GetLinesPerPage()) + ((mLineCount % GetLinesPerPage() != 0) ? 1 : 0);
	}
	else
	{
		return  1;
	}

}


public int GetNbLines () {

	return  mLineCount;

}


public int GetLinesPerPage () {

	return  GetRectHeight() / GetLineHeight();

}


public void OnVisibilityChange () {

	if(IsVisible() && mIsMultiline)
	{
		Invalidate();
	}
	super.OnVisibilityChange();

}


public void OnSerialize (Package p) {

    super.OnSerialize(p);



{
		mpCaption = null;
	}

    (mpCaption)= mpCaption.Cast((p).SerializePointer((mpCaption).typeNumber, (mpCaption).supportsDynamicSerialization, false), null);
	SetCaptionLength(mpCaption.GetLength());
	(mFont)= mFont.Cast((p).SerializePointer((mFont).typeNumber, (mFont).supportsDynamicSerialization, false), null);
	 byte alignment = (byte)mAlignment;

	(alignment)= (p).SerializeIntrinsic(alignment);
	mAlignment = (byte)alignment;



























(mOpacity)= (p).SerializeIntrinsic(mOpacity);
    (mIsMultiline)= (p).SerializeIntrinsic(mIsMultiline);

	WrapText();

}


public Vector2_short GetCharIndex2DPosition (int charIndex) {



	if(!IsMultiline())
	{
		return  new Vector2_short((short)charIndex, (short)0);
	}

	 short lineIndex = 0;

	while(lineIndex < mLineCount && (charIndex > ((mLines[lineIndex])& 0xFFFF)))
	{
		lineIndex++;
	}

	if(lineIndex == mLineCount)
	{
		lineIndex--;
	}

	return  new Vector2_short((short)(charIndex - ((mLines[lineIndex])& 0xFFFF)), lineIndex);

}


public short GetLineWidth (int lineIndex) {




	return  mLinesWidth[lineIndex];

}


public void ControlValue (int valueControlCode, boolean setValue, Controller controller) {

	if(valueControlCode == componentOpacity)
	{
		if(setValue)
		{
			SetOpacity((short)controller.GetLongValue());
		}
		else
		{
			controller.SetValue((int)GetOpacity());
		}
	}
	else
	{
		super.ControlValue(valueControlCode, setValue, controller);
	}

}


public void ComputeLineWidth (boolean removeLastAdvance) {



	 String caption = mpCaption;
	 int length = mCaptionLength;


	if(caption == null || mFont == null)
	{
		if(caption == null)
		{
			SetCaptionLength(0);
		}
		return ;
	}

	if(!mKeepTrailingWhiteSpaces)
	{
		while(length > 0 && (caption.GetCharAt(length - 1) == (byte)' '

			|| caption.GetCharAt(length - 1) == (byte)'\u001D'
))
		{
			--length;
		}
		SetCaptionLength(length);
	}

	 short[] linesWidth = new short[1];






{
		linesWidth[0] = (short)mFont.GetLineWidth(caption, 0, length, removeLastAdvance);
	}
	mLinesWidth = linesWidth;;

}


public final static byte wrapDataFieldLineStartIndex = 0;
public final static byte wrapDataFieldLineEndIndex = 1;
public final static byte wrapDataFieldLineWidth = 2;
public final static byte wrapDataFieldCount = 3;

public final static byte breakTypeLineBreakChar = 0;
public final static byte breakTypeWordBreakChar = 1;
public final static byte breakTypeWrapAfterChar = 2;
public final static byte breakTypeOptWordBreakChar = 3;
public final static byte breakTypeLastChar = 4;

public void WrapText () {

	if(!mIsMultiline)
	{
		mLineCount = 1;
		ComputeLineWidth();
		return ;
	}

	 short width = GetRectWidth();

	 Font font = mFont;






if(width != 0&& font != null)
	{
		 int arrayGrowthIncrement = wrapDataFieldCount * 64;

		 Array_int wrapData = new Array_int(arrayGrowthIncrement, arrayGrowthIncrement);


		 int lineCount = WrapString(font, width, wrapData);


		
		 int[] lines = new int[lineCount + 1]; 
		int i;

		for(i = 0;i <= lineCount;i ++)
		{
			lines[i] = (((lines[i])& 0xFFFF0000) | ((short)WrapDataLineStart(wrapData, i)));
			lines[i] = ((lines[i])= ((lines[i])& 0xFFFF) | ((WrapDataLineEnd(wrapData, i)) << 16));
		}
		 short[] linesWidth = new short[lineCount];
		for(i = 0;i < lineCount;i ++)
		{
			linesWidth[i] = (short)WrapDataLineWidth(wrapData, i);
		}

		
		mLines = lines;;
		mLinesWidth = linesWidth;;

		mPreviousWidth = width; 
		mLineCount = (short)lineCount;

		 int height = lineCount * GetLineHeight() - GetLeading();



SetSize(width, (short)height);
	}














}


public static void WrapDataEnsureSize (Array_int wrapData, int size) {

	 int wrapDataCapacity = wrapData.GetCapacity();

	 int wrapDataNeededSize = size * wrapDataFieldCount;


	
	wrapData.SetSize((wrapDataCapacity > wrapDataNeededSize) ? wrapDataCapacity : wrapDataNeededSize);

}


public static int WrapDataArrayPosition (int entryi, byte field) {

	return  entryi * wrapDataFieldCount + field;

}


public static int WrapDataLineStart ( Array_int wrapData, int entryi) {

	return  wrapData.GetAt(WrapDataArrayPosition(entryi, wrapDataFieldLineStartIndex));

}


public static void WrapDataSetLineStart (Array_int wrapData, int entryi, int value) {

	wrapData.SetAt(value, WrapDataArrayPosition(entryi, wrapDataFieldLineStartIndex));

}


public static int WrapDataLineEnd ( Array_int wrapData, int entryi) {

	return  wrapData.GetAt(WrapDataArrayPosition(entryi, wrapDataFieldLineEndIndex));

}


public static void WrapDataSetLineEnd (Array_int wrapData, int entryi, int value) {

	wrapData.SetAt(value, WrapDataArrayPosition(entryi, wrapDataFieldLineEndIndex));

}


public static int WrapDataLineWidth ( Array_int wrapData, int entryi) {

	return  wrapData.GetAt(WrapDataArrayPosition(entryi, wrapDataFieldLineWidth));

}


public static void WrapDataSetLineWidth (Array_int wrapData, int entryi, int value) {

	wrapData.SetAt(value, WrapDataArrayPosition(entryi, wrapDataFieldLineWidth));

}


public int WrapString ( Font font, int width, Array_int wrapData) {

	 String str = mpCaption;
	 short lineCount = 1;


	 byte curBreakType = breakTypeLastChar;


	 short wordEndIndex = -1;

	 int currentLineWidth = 0;

	 int currentFitLineWidth = 0;

	 boolean wordSeparatorInTwoCaracters = false;
	
	 short wordEndIndexDistanceFromLastChar = 0;
	

	WrapDataEnsureSize(wrapData, 2);
	WrapDataSetLineStart(wrapData, 0, 0);



 short currentCharIndex = 0;

	byte currentChar;

	 Font currentFont = font;
	int currentCharInfo;


	 byte nextChar = str.GetCharAt(0);

	


 int nextCharInfo = Characters.GetCharType(nextChar);
	

	if(nextChar == 0) 
	{
		WrapDataSetLineEnd(wrapData, 0, 0);
		WrapDataSetLineStart(wrapData, lineCount, 1);
		lineCount++;
	}

	for(;nextChar != 0;currentCharIndex ++)
	{
		currentChar = nextChar;
		currentCharInfo = nextCharInfo;
		nextChar = str.GetCharAt(currentCharIndex + 1);
		nextCharInfo = Characters.GetCharType(nextChar);		




 boolean currentCharFitInTextWidth = true;


		{		
			
			 int characterWidth = currentFont.GetCharWidth(currentChar, currentLineWidth == 0, true);

			 int resultingWidth = currentLineWidth + characterWidth;


			if(resultingWidth > width)
			{
				currentCharFitInTextWidth = false;
			}
			else if(resultingWidth == width)
			{
				
				
				currentCharFitInTextWidth = Characters.IsWordSeparator(nextCharInfo);
			}

			
			 int currentCharWidth = currentFont.GetCharWidth(currentChar, currentLineWidth == 0, false);

			currentLineWidth += currentCharWidth;
		}

        
		 boolean wordBreakUpdated = false;


		if(currentChar == Characters.carriageReturn && nextChar == Characters.lineFeed)
		{
			
			wordSeparatorInTwoCaracters = true;
			continue;
		}
		else if(Characters.IsLineSeparator(currentCharInfo))
		{			
			 short distanceFromLastChar = (short)(1+ (wordSeparatorInTwoCaracters ? 1 : 0));


			if((curBreakType == breakTypeWordBreakChar) && (wordEndIndex == (currentCharIndex - distanceFromLastChar)))
			{
				wordEndIndexDistanceFromLastChar = (short)(wordEndIndexDistanceFromLastChar + distanceFromLastChar);
			}
			else
			{
				wordEndIndexDistanceFromLastChar = distanceFromLastChar;
			}

			curBreakType = breakTypeLineBreakChar;
			wordBreakUpdated = true;
		}		
		else if(curBreakType >= breakTypeWordBreakChar && Characters.IsWordSeparator(currentCharInfo))
		{

			
			if(currentChar != Characters.softHyphenChar || currentCharFitInTextWidth)
{
				 short distanceFromLastChar = 1;



				if(currentChar == Characters.softHyphenChar)
				{
					
					
					distanceFromLastChar = 0;
				}
if(curBreakType == breakTypeWordBreakChar && (wordEndIndex == (currentCharIndex - 1)))
				{
					
					
					wordEndIndexDistanceFromLastChar = (short)(wordEndIndexDistanceFromLastChar + distanceFromLastChar);
				}
				else
				{
					wordEndIndexDistanceFromLastChar = distanceFromLastChar;
				}

				curBreakType = breakTypeWordBreakChar;			
				wordBreakUpdated = true;
			}
		}


		else if(curBreakType >= breakTypeOptWordBreakChar && Characters.IsOptionalWordBreak(currentCharInfo))
		{
			curBreakType = breakTypeOptWordBreakChar;
			wordEndIndexDistanceFromLastChar = 1;
			wordBreakUpdated = true;
		}
if(currentCharFitInTextWidth)
		{				
			
			
			if (curBreakType >= breakTypeWrapAfterChar &&
				Characters.CanWrapAfter(currentCharInfo) &&
				Characters.CanWrapBefore(nextCharInfo))
			{
				curBreakType = breakTypeWrapAfterChar;				
				wordEndIndexDistanceFromLastChar = 0;
				wordBreakUpdated = true;
			}
			
			if((curBreakType != breakTypeLineBreakChar) && (nextChar == 0))
			{
				
				curBreakType = breakTypeLineBreakChar;

				
				if(!wordBreakUpdated)
				{					
					wordEndIndexDistanceFromLastChar = 0;
				}				

				wordBreakUpdated = true;
			}
		}
		else if(curBreakType == breakTypeLastChar)
		{
			













wordEndIndex = (short)(currentCharIndex - 1);
			
			
			currentFitLineWidth = currentLineWidth - currentFont.GetCharWidth(currentChar, currentLineWidth == 0, false);
		}

		if(wordBreakUpdated)
		{
			wordEndIndex = currentCharIndex;
			currentFitLineWidth = currentLineWidth;
		}
		
		if(curBreakType == breakTypeLineBreakChar || !currentCharFitInTextWidth)
		{
			
			currentCharIndex = wordEndIndex;

			
			
			 byte charWordEndIndex = str.GetCharAt(wordEndIndex);

			 Font fontWordEndIndex = font;


while(currentCharIndex - wordEndIndexDistanceFromLastChar < wordEndIndex)
			{					
				
				
				currentFitLineWidth -= fontWordEndIndex.GetCharWidth(charWordEndIndex, currentFitLineWidth == 0, false);
				wordEndIndex--;
				
				if(wordEndIndex >= 0)
				{
					charWordEndIndex = str.GetCharAt(wordEndIndex);


}
			}

			if(wordEndIndex > WrapDataLineStart(wrapData, lineCount - 1))
			{				
				currentFitLineWidth -= fontWordEndIndex.GetCharWidth(charWordEndIndex, currentFitLineWidth == 0, false);
				currentFitLineWidth += fontWordEndIndex.GetCharWidth(charWordEndIndex, currentFitLineWidth == 0, true);
			}





			WrapDataEnsureSize(wrapData, lineCount + 1);
			WrapDataSetLineWidth(wrapData, lineCount - 1, currentFitLineWidth);
			WrapDataSetLineEnd(wrapData, lineCount - 1, wordEndIndex);
			WrapDataSetLineStart(wrapData, lineCount, currentCharIndex + 1);
			lineCount++;

			nextChar = str.GetCharAt(currentCharIndex + 1);



nextCharInfo = Characters.GetCharType(nextChar);
			wordEndIndex = -1;
			currentLineWidth = 0;
			wordSeparatorInTwoCaracters = false;
			curBreakType = breakTypeLastChar;
			wordEndIndexDistanceFromLastChar = 0;
		}
	}

    
	
	WrapDataEnsureSize(wrapData, lineCount + 1);
	WrapDataSetLineStart(wrapData, lineCount, currentCharIndex);
	WrapDataSetLineEnd(wrapData, lineCount, -1);

	return  lineCount - 1;

}


public byte GetLeading () {






return  mFont.GetLeading();

}


public void SetCaptionLength(int newLength) {
 mCaptionLength = newLength; 
}


public Font mFont;
public byte mAlignment;
public String mpCaption;
public int mCaptionLength;
public boolean mKeepTrailingWhiteSpaces;
public short mLineCount;
public boolean mIsMultiline;
public short mCurrentLine;
public int [] mLines;
public short [] mLinesWidth;
public short mPreviousWidth;
public short mOpacity;
public void SetCaption(String caption)
{
	SetCaption(caption, true);
}
public short GetLineWidth()
{
	return GetLineWidth((int)0);
}
public void ComputeLineWidth()
{
	ComputeLineWidth(true);
}

/* One dimension array */
public static Text[] InstArrayText(int size) {
	Text[] newArray = new Text[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new Text();
	return newArray; }

/* Two dimension array */
public static Text[][] InstArrayText(int size1, int size2) {
	Text[][] newArray = new Text[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Text[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new Text(); }
	return newArray; }

/* Three dimension array */
public static Text[][][] InstArrayText(int size1, int size2, int size3) {
	Text[][][] newArray = new Text[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new Text[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new Text[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new Text(); } }
	return newArray; }



}

