package ca.jamdat.flight;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TimeSystem extends TimeControlled {

public static TimeSystem Cast(Object o, TimeSystem _) {
 return  (TimeSystem)o; 
}


 final public static byte typeNumber = TypeIDOfType_TimeSystem.v;
 final public static byte typeID = TypeIDOfType_TimeSystem.w;
 public static final boolean supportsDynamicSerialization = true; public byte GetTypeID() {
 return  typeID; 
}


public static Class AsClass() {
 return  null; 
}


public  TimeSystem () {
mTimeFlowSpeed = new F32(F32.One(16));
mDeltaError = new F32(F32.Zero(16));
mTimeControlleds = new PtrArray_TimeControlled();



}


public void destruct() {


}


public void OnTime (int timeMs, int deltaTimeMs) {




	
	if(!IsPaused())
	{
		if(!mTimeFlowSpeed.Equals(F32.One(16)))
		{
			 F32 deltaFP = new F32(F32.FromInt(deltaTimeMs, 16).Mul(mTimeFlowSpeed, 16).Add(mDeltaError));

			deltaTimeMs = deltaFP.ToInt(16);
			mDeltaError = deltaFP.Sub(F32.FromInt(deltaTimeMs, 16));
		}
		mTotalTime += deltaTimeMs;

		SendOnTime(mTotalTime, deltaTimeMs);
	}

	CleanUpTimeTable();



}


public void Start () {

	mPaused = false;

}


public void StartRecursively () {

	Start();

	for(int i = mTimeControlleds.Start();i < mTimeControlleds.End();i ++)
	{
		 TimeControlled tc = mTimeControlleds.GetAt(i);
		if (tc != null&& (tc instanceof TimeSystem))
		{
			((TimeSystem)tc).StartRecursively();
		}
	}

}


public void Stop () {

	mTotalTime = 0;
	mPaused = true;

}


public void StopRecursively () {

	Stop();

	for(int i = mTimeControlleds.Start();i < mTimeControlleds.End();i ++)
	{
		 TimeControlled tc = mTimeControlleds.GetAt(i);
		if (tc != null&& (tc instanceof TimeSystem))
		{
			((TimeSystem)tc).StopRecursively();
		}
	}

}


public void Pause () {

	mPaused = true;

}


public void AdvanceBy (int deltaTimeMs) {

	mTotalTime += deltaTimeMs;
	SendOnTime(mTotalTime, deltaTimeMs);

}


public void Register ( TimeControlled timeable) {



	if(!IsRegistered(timeable))
	{
		mTimeControlleds.Insert(timeable);
	}

}


public void UnRegister ( TimeControlled timeable) {



	 int index = mTimeControlleds.Find(timeable);


	if(index >= 0)
	{
		mTimeControlleds.SetAt(null, index);
		mDirty = true;
	}

}


public void UnRegisterAll () {

	 PtrArray_TimeControlled timeControlleds = mTimeControlleds;

	for(int i = 0;i < timeControlleds.End();i ++)
	{
		if(timeControlleds.GetAt(i) != null)
		{
			UnRegister(timeControlleds.GetAt(i));
		}
	}

}


public boolean IsRegistered ( TimeControlled timeable) {

	return  mTimeControlleds.Find(timeable) >= 0;

}


public F32 GetTimeFlowSpeed () {

	return  mTimeFlowSpeed.IncreasePrecision(16- 16);

}


public void SetTimeFlowSpeed ( F32 val) {

	mTimeFlowSpeed = val.DecreasePrecision(16- 16);

}


public int GetTotalTime() {
 return  mTotalTime; 
}


public void SetTotalTime (int val) {

	mTotalTime = val;

}


public void SetTotalTimeRecursively (int val) {

	SetTotalTime(val);

	for(int i = mTimeControlleds.Start();i < mTimeControlleds.End();i ++)
	{
		 TimeControlled tc = mTimeControlleds.GetAt(i);
		if (tc != null&& (tc instanceof TimeSystem))
		{
			((TimeSystem)tc).SetTotalTimeRecursively(val);
		}
	}

}


public void OnSerialize (Package p) {

	(mTotalTime)= (p).SerializeIntrinsic(mTotalTime);
	(mPaused)= (p).SerializeIntrinsic(mPaused);
	(mTimeFlowSpeed)= (p).SerializeIntrinsic(mTimeFlowSpeed);
	


(mTimeControlleds).OnSerialize(p);
	mDirty = false;

}


public boolean IsPaused () {

	return  mPaused || mTimeFlowSpeed.Equals(F32.Zero(16));

}


public void RefreshAllControllersIncluded () {

	for(int i = mTimeControlleds.Start();i < mTimeControlleds.End();i ++)
	{
		 TimeControlled tc = mTimeControlleds.GetAt(i);
		if(tc == null)
		{
			continue;
		}
		if ((tc instanceof Controller))
		{
			((Controller)tc).Refresh();
		}
		else if ((tc instanceof TimeSystem))
		{
			((TimeSystem)tc).RefreshAllControllersIncluded();
		}
	}

}


public int GetNbChildren () {

	return  mTimeControlleds.End();

}


public TimeControlled GetChild (int i) {

	return  mTimeControlleds.GetAt(i);

}


public void CleanUpTimeTable () {

	if(mDirty)
	{
		 PtrArray_TimeControlled pTimeControlleds = mTimeControlleds;
		int index;

		
		while((index = pTimeControlleds.Find(null)) != -1)
		{
			
			
			pTimeControlleds.SetAt(pTimeControlleds.GetAt(pTimeControlleds.End() -1), index);
			pTimeControlleds.RemoveAt(pTimeControlleds.End() -1);
		}

		mDirty = false;
	}

}


public void SendOnTime (int timeMs, int deltaTimeMs) {

	 int nbTimeControlled = mTimeControlleds.End();

	for(int i = 0;i < mTimeControlleds.End();i ++)
	{
		 TimeControlled curTimeControlled = mTimeControlleds.GetAt(i);
		if(curTimeControlled != null)
		{
			
			if(i >= nbTimeControlled)
			{
				deltaTimeMs = 0;
			}
				



curTimeControlled.OnTime(timeMs, deltaTimeMs);


}
	}

}


public F32 mTimeFlowSpeed;
public int mTotalTime;
public PtrArray_TimeControlled mTimeControlleds;
public boolean mPaused;
public boolean mDirty;
public F32 mDeltaError;

/* One dimension array */
public static TimeSystem[] InstArrayTimeSystem(int size) {
	TimeSystem[] newArray = new TimeSystem[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TimeSystem();
	return newArray; }

/* Two dimension array */
public static TimeSystem[][] InstArrayTimeSystem(int size1, int size2) {
	TimeSystem[][] newArray = new TimeSystem[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimeSystem[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TimeSystem(); }
	return newArray; }

/* Three dimension array */
public static TimeSystem[][][] InstArrayTimeSystem(int size1, int size2, int size3) {
	TimeSystem[][][] newArray = new TimeSystem[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TimeSystem[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TimeSystem[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TimeSystem(); } }
	return newArray; }



}

