package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class DelayLoadingScene extends BaseScene {

public  DelayLoadingScene (byte packageID) {
super(packageID);
mRemWaitingTime = ((((int)ConstantsEnglishPortrait.delayLoadingSingleGameTimeMs == (int)ConstantsEnglishLandscape.delayLoadingSingleGameTimeMs) ? Constants.delayLoadingSingleGameTimeMs : ConstantsGetter.GetConstants().delayLoadingSingleGameTimeMsFct()));



}


public void destruct() {
	

}


public void OnTime (int totalTimeMs, int deltaTimeMs) {

	if(IsLoaded() && IsEntranceAnimationOver())
	{
		if(mRemWaitingTime > 0&& !IsAppPausedWithFocus())
		{
			mRemWaitingTime -= deltaTimeMs; 

			if(mRemWaitingTime <= 0)
			{


HandleCommand((((int)ConstantsEnglishPortrait.startGameCommand == (int)ConstantsEnglishLandscape.startGameCommand) ? Constants.startGameCommand : ConstantsGetter.GetConstants().startGameCommandFct()));
				

			}
		}
	}

	super.OnTime(totalTimeMs, deltaTimeMs);

}


public boolean OnKey (int key, boolean up) {

	 boolean handled = false;



	
	

	if((up && key >= Key.DIGIT0 && key <= Key.DIGIT9) ||  (up && key >= Key.A && key <= Key.Z) ||  (up && key >= Key.UP_A && key <= Key.UP_Z))


{


HandleCommand((((int)ConstantsEnglishPortrait.goToGameSetupMenuSinglePlayerCommand == (int)ConstantsEnglishLandscape.goToGameSetupMenuSinglePlayerCommand) ? Constants.goToGameSetupMenuSinglePlayerCommand : ConstantsGetter.GetConstants().goToGameSetupMenuSinglePlayerCommandFct()));
handled = true;
	}
return  handled == true ? handled : super.OnKey(key, up);

}


public void OnIncomingCall () {

	if(!GetApp().IsInTransition())
	{
		mRemWaitingTime = -1; 
		HandleCommand((((int)ConstantsEnglishPortrait.backCommand == (int)ConstantsEnglishLandscape.backCommand) ? Constants.backCommand : ConstantsGetter.GetConstants().backCommandFct()));
	}

}


public boolean OnMsg (Component source, int msg, int intParam) {

	 Vector2_short tempCoord2 = new Vector2_short(FlPenManager.Get().GetPenPosition(intParam));


	if(msg == Component.penDownMsg)
	{
		OnPenDown(tempCoord2);
		return  true;
	}
	else if(msg == Component.penUpMsg)
	{
		OnPenUp(tempCoord2);
		return  true;
	}

	return  super.OnMsg(source, msg, intParam);

}


public void OnPenDown ( Vector2_short ptIn) {



}


public void OnPenUp ( Vector2_short ptIn) {

	 Scroller delayScroller = null;


	(delayScroller)= (delayScroller).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenScroller_ID), null);

	
	if(isPenOnComponent(delayScroller, ptIn))
	{
		OnKey(Key.DIGIT1, false);
		OnKey(Key.DIGIT1, true);
	}
	else
	{	
		super.OnPenUp(ptIn);
	}

}


public boolean isPenOnComponent (Component componentToVerify, Vector2_short inPoint) {

	return  isPenOnComponent(componentToVerify, inPoint, 0, 0, 0, 0);

}


public boolean isPenOnComponentDoubleSize (Component componentToVerify, Vector2_short inPoint) {

	return  isPenOnComponent(componentToVerify, inPoint, componentToVerify.GetRectHeight(), componentToVerify.GetRectHeight(), componentToVerify.GetRectWidth(), componentToVerify.GetRectWidth());

}


public boolean isPenOnComponent (Component componentToVerify, Vector2_short inPoint, int expandValUp, int expandValDown, int expandValLeft, int expandValRight) {

	if(componentToVerify != null)
	{	
		 FlRect rectCurrentSelection = new FlRect(componentToVerify.GetRect());
	

		 short myRect_left = (short)(componentToVerify.GetAbsoluteLeft() - expandValLeft);
  short myRect_top = (short)(componentToVerify.GetAbsoluteTop() - expandValUp);
  short myRect_width = (short)(rectCurrentSelection.GetWidth() + expandValLeft + expandValRight);
  short myRect_height = (short)(rectCurrentSelection.GetHeight() + expandValUp + expandValDown);
				
if(FlRect.Contains(myRect_left, myRect_top, myRect_width, myRect_height, (short)inPoint.GetX(), (short)inPoint.GetY()))
		{
			return  true;	
		}
	}
	return  false;

}


public void Init () {
	

	{ 
		 String tempString = null;
		 Text tempText = null;

		 int gameMode = GetTetrisState().GetLocalGameMode();

	
		 int gameModeLoadingStr = GetGameModeLoadingEntryPoint(gameMode);

		(tempText)= (tempText).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenText_ID), null);	
		(tempString)= (tempString).Cast((mpPackage).GetEntryPoint(gameModeLoadingStr), null);
		tempText.SetCaption(new String(tempString));		
	}

	InitSuspensionMark();


	
	
	{ 
		 Text delayLoadingScreenTickerText = null;
		(delayLoadingScreenTickerText)= (delayLoadingScreenTickerText).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenTickerText_ID), null);
		

		

		delayLoadingScreenTickerText.SetSize(delayLoadingScreenTickerText.GetLineWidth(0), delayLoadingScreenTickerText.GetRectHeight());
	}
{ 
		 Viewport pMTUTickerViewport = null;

		(pMTUTickerViewport)= (pMTUTickerViewport).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenTickerViewport_ID), null);

		
		if(mpTicker != null)
		{
			mpTicker.SetTickerViewport(null);
			mpTicker = null;
		}
		mpTicker = new Ticker((((int)ConstantsEnglishPortrait.tickerActivationTime == (int)ConstantsEnglishLandscape.tickerActivationTime) ? Constants.tickerActivationTime : ConstantsGetter.GetConstants().tickerActivationTimeFct()));
		mpTicker.SetTickerViewport(pMTUTickerViewport);
	}


	super.Init();

}


public void UnloadResources () {


	if(mpSuspensionMarkTimeSystem != null)
	{
		mpSuspensionMarkTimeSystem.UnRegisterInGlobalTime();
	}

	if(mpTicker != null)
	{
		mpTicker.SetTickerViewport(null);
		mpTicker = null;
	}

	super.UnloadResources();

}


public void InitSuspensionMark () {

	{ 
		Text text = null;

		(text)= (text).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenText_ID), null);

		 Viewport pSuspensionMarkViewport = null;
		(pSuspensionMarkViewport)= (pSuspensionMarkViewport).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenSuspensionMarkViewport_ID), null);

		pSuspensionMarkViewport.SetTopLeft((short)(pSuspensionMarkViewport.GetRectLeft()), (short)(pSuspensionMarkViewport.GetRectTop() + text.GetRectHeight()));
	}

	(mpSuspensionMarkTimeSystem)= (mpSuspensionMarkTimeSystem).Cast((mpPackage).GetEntryPoint(RSRC_delayLoadingMenuScenePackage.delayLoadingScreenSuspensionMarkTimeSystem_ID), null);
	mpSuspensionMarkTimeSystem.RegisterInGlobalTime();

}


public static int GetGameModeLoadingEntryPoint (int gameMode) {

	 int gameModeTileStrId = -1;


	switch(gameMode)
	{
	case TetrisState.kModeMarathon : 
		gameModeTileStrId = RSRC_delayLoadingMenuScenePackage.delayLoadingContentMarathonString_ID; 
		break;
	case TetrisState.kModeUltra : 
		gameModeTileStrId = RSRC_delayLoadingMenuScenePackage.delayLoadingContentUltraString_ID; 
		break;
	case TetrisState.kMode40Lines : 
		gameModeTileStrId = RSRC_delayLoadingMenuScenePackage.delayLoadingContent40LinesString_ID; 
		break;




default :

	}



	return  gameModeTileStrId;

}


public TimeSystem mpSuspensionMarkTimeSystem;
public int mRemWaitingTime;
public Ticker mpTicker;



}

