package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class GameResult {

public final static int none = 0;
public final static int win = 1;
public final static int loss = 2;
public final static int tie = 3;
public final static int localForfeit = 4;
public final static int remoteForfeit = 5;
public final static int multipleForfeit = 6;
public final static int multipleLoss = 7;
public final static int disconnect = 9;

public final static int forfeitInGracePeriod = 0x10;

public static int Compute (int resultPlayer1, int resultPlayer2, boolean forfeitInGrace) {

	int result;


	if(resultPlayer1 == TetrisGame.kResultForfeit && resultPlayer2 == TetrisGame.kResultForfeit)
	{
		
		result = multipleForfeit;
	}
	else if(resultPlayer1 == TetrisGame.kResultTie && resultPlayer2 == TetrisGame.kResultTie)
	{
		
		result = tie;
	}
	else if(resultPlayer1 != TetrisGame.kResultWin && resultPlayer2 != TetrisGame.kResultWin)
	{
		
		result = multipleLoss;
	}
	else if(resultPlayer1 == TetrisGame.kResultForfeit)
	{
		
		result = localForfeit;
	}
	else if(resultPlayer2 == TetrisGame.kResultForfeit)
	{
		
		result = remoteForfeit;
	}
	else if(resultPlayer1 == TetrisGame.kResultLose)
	{
		
		result = loss;
	}
	else 
	{
		
		result = win;
	}

	if(forfeitInGrace && (result == localForfeit || result == remoteForfeit))
	{
		result = SetForfeitInGrace(result, true);
	}

	return  result;

}


public static int BaseResult (int result) {

	if(IsForfeitInGrace(result))
	{
		return  (int)(result ^ forfeitInGracePeriod);
	}
	else
	{
		return  result;
	}

}


public static int SetForfeitInGrace (int result, boolean forfeitInGrace) {

	if(forfeitInGrace)
	{
		return  (int)(result | GameResult.forfeitInGracePeriod);
	}
	else
	{
		return  BaseResult(result);
	}

}


public static boolean IsForfeitInGrace (int result) {

	return  (result & forfeitInGracePeriod) != 0;

}



/* One dimension array */
public static GameResult[] InstArrayGameResult(int size) {
	GameResult[] newArray = new GameResult[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new GameResult();
	return newArray; }

/* Two dimension array */
public static GameResult[][] InstArrayGameResult(int size1, int size2) {
	GameResult[][] newArray = new GameResult[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new GameResult[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new GameResult(); }
	return newArray; }

/* Three dimension array */
public static GameResult[][][] InstArrayGameResult(int size1, int size2, int size3) {
	GameResult[][][] newArray = new GameResult[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new GameResult[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new GameResult[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new GameResult(); } }
	return newArray; }

public GameResult () { 
}




}

