package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class HumanPlayer extends TetrisPlayer {

public  HumanPlayer (TetrisState state, byte playerId) {
super(state, playerId);


	

}


public void destruct() {

	if((mpGhostTetrimino)!= null) { (mpGhostTetrimino).Destruct(); (mpGhostTetrimino)= null; ; };

}


public boolean OnActionPressed (int action, int keyPressCount) {

	


	 int gamePhase = mpTetrisGame.GetGamePhase();

	if (	gamePhase != TetrisGame.kPhaseFalling &&
			gamePhase != TetrisGame.kPhaseLock)
	{
		return  false;
	}

	 boolean handled = true;

	switch(action)
	{
	case TetrisGameAction.kActionMoveLeft :
	case TetrisGameAction.kActionMoveRight :
		DoTetriminoMoveHorizontal(action);		
		break;

	case TetrisGameAction.kActionHardDrop :
		mpTetrisGame.HardDrop();
		break;

	case TetrisGameAction.kActionHold :
		if(true)
		{
			mpTetrisGame.HoldTetrimino();
		}
		break;

	case TetrisGameAction.kActionRotateClockwise :
	case TetrisGameAction.kActionRotateCounterClockwise :
		DoTetriminoRotation(action);
		break;

	case TetrisGameAction.kActionSoftDrop :
		mpTetrisGame.SetSoftDropActive(true);
		break;

	default :
		handled = false;
	}

	return  handled;

}


public boolean OnActionRepeat (int action, int nthRepeatInThisOnTime) {

	

	 int gamePhase = mpTetrisGame.GetGamePhase();

	if (	gamePhase != TetrisGame.kPhaseFalling &&
			gamePhase != TetrisGame.kPhaseLock)
	{
		return  false;
	}


 boolean handled = true;

	switch(action)
	{
	case TetrisGameAction.kActionMoveLeft :
	case TetrisGameAction.kActionMoveRight :
		if(nthRepeatInThisOnTime <= 1)
		{
			DoTetriminoMoveHorizontal(action);
		}
		break;

	default :
		handled = false;
	}

	return  handled;

}


public boolean OnActionReleased (int action, int keyPressCount) {

	

	 int gamePhase = mpTetrisGame.GetGamePhase();

	if (	gamePhase != TetrisGame.kPhaseFalling &&
			gamePhase != TetrisGame.kPhaseLock)
	{
		return  false;
	}

	 boolean handled = true;

	switch(action)
	{
	case TetrisGameAction.kActionSoftDrop :
		if(keyPressCount == 0)
		{
			mpTetrisGame.SetSoftDropActive(false);
		}
		break;

	default :
		handled = false;
	}

	return  handled;

}


public void OnGameEvent (int gameEvent, int eventOccurTimeMs, int param) {

	

	if(gameEvent == kEventTetriminoStartsFalling)
	{
		InitializeGhost();
	}

	super.OnGameEvent(gameEvent, eventOccurTimeMs, param);

}


public Tetrimino GetGhostTetrimino() {
 return  mpGhostTetrimino; 
}


public boolean IsPlayer1 () {

	
	 boolean isPlayer1 = true;



	return  isPlayer1;

}


public void DoTetriminoMoveHorizontal (int leftRight) {


 boolean moveLeft = leftRight == TetrisGameAction.kActionMoveLeft;

	 int action = moveLeft ? TetrisGame.kMovePieceLeft : TetrisGame.kMovePieceRight;


	mpTetrisGame.DoPieceAction(action);
	UpdateGhostPostion();

}


public void DoTetriminoRotation (int clockwiseCounterClockwise) {


 boolean clockwise = clockwiseCounterClockwise == TetrisGameAction.kActionRotateClockwise;

	 int action = clockwise ? TetrisGame.kRotatePieceClockWise : TetrisGame.kRotatePieceCounterClockWise;




mpTetrisGame.DoPieceAction(action);
	UpdateGhostOrientation();
	InvalidateState(kInvalidateFacing);

}


public Tetrimino mpGhostTetrimino;
public void InitializeGhost () {

	

	
	
	 Tetrimino pFallingTetrimino = (Tetrimino)mpTetrisGame.GetFallingTetrimino();



	mpGhostTetrimino = mpTetrisGame.CopyTetrimino(mpGhostTetrimino, pFallingTetrimino);

	UpdateGhostPostion();

}


public void UpdateGhostPostion () {

	



	 short startPosY = mpTetrisGame.GetFallingTetrimino().GetMatrixPosY();

	 short posX = mpTetrisGame.GetFallingTetrimino().GetMatrixPosX();


	mpGhostTetrimino.SetMatrixPos(posX, startPosY);

	while(mpGhostTetrimino.Fall())
	{
		
	}


}


public void UpdateGhostOrientation () {

	

	mpGhostTetrimino.SetFacingDir(mpTetrisGame.GetFallingTetrimino().GetFacingDir());
	UpdateGhostPostion();

}


public void OnGameEvent(int gameEvent, int eventOccurTimeMs)
{
	OnGameEvent(gameEvent, eventOccurTimeMs, (int)-1);
}



}

