package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public abstract class InputMapping extends Serializable {

public final static int kActionKeyDownCounter = 0;
public final static int kActionRepeatInitialDelay = 1;
public final static int kActionRepeatStepDelay = 2;
public final static int kActionRepeatIn = 3;
public final static int kActionElementCount = 4;

public final static int kMappingAction = 0;
public final static int kMappingKeyRepeatInitialDelay = 1;
public final static int kMappingKeyRepeatStepDelay = 2;
public final static int kMappingKeyRepeatIn = 3;
public final static int kMappingElementCount = 4;

public final static int kKeyCount = Key.COUNT	;

public abstract void Reset();



public  InputMapping (int actionsCount) {
mActionsData = new int[kActionElementCount * actionsCount];
mActionsCount = (actionsCount);


	for(int i = 0;i < actionsCount;i ++)
	{
		ClearAction(i);
	}

}


public void destruct() {

	mActionsData = null;

}


public void Write (FileSegmentStream a11) {

	





}


public void Read (FileSegmentStream a12) {

	





}


public int GetMappingCount() {
 return  kKeyCount; 
}


public int GetMappingField(int mappingIndex, int field) {
 return  GetMappingFieldForKey(GetKeyForMappingIndex(mappingIndex), field); 
}


public int GetMappingFieldForKey (int key, int field) {

	 int mappingIndex = GetMappingIndex(key, field);

	 int[] mappingArray = GetCurrentMappingData();
	return  mappingArray[mappingIndex];

}


public void SetMappingField(int mappingi, int field, int value) {
 SetMappingFieldForKey(GetKeyForMappingIndex(mappingi), field, value); 
}


public void SetMappingFieldForKey (int key, int field, int value) {

	 int mappingIndex = GetMappingIndex(key, field);

	 int[] mappingArray = GetCurrentMappingData();
	mappingArray[mappingIndex] = value;

}


public void SetMapping (int key, int actionId, int repeatInitialDelay, int repeatStepDelay, int repeatIn) {


	SetMappingFieldForKey(key, kMappingAction, actionId);
	SetMappingFieldForKey(key, kMappingKeyRepeatInitialDelay, repeatInitialDelay);
	SetMappingFieldForKey(key, kMappingKeyRepeatStepDelay, repeatStepDelay);
	SetMappingFieldForKey(key, kMappingKeyRepeatIn, repeatIn);

}


public void ClearMapping (int key) {

	for(int i = 0;i < kMappingElementCount;i ++)
	{
		SetMappingFieldForKey(key, (int)i, 0);
	}

}


public void ClearMapppingsForAction (int actionId) {

	for(int i = 0;i < GetMappingCount();i ++)
	{
		 int key = GetKeyForMappingIndex(i);

		if(GetMappingFieldForKey(key, kMappingAction) == actionId)
		{
			ClearMapping(key);
		}
	}

}


public int GetKeyForAction (int actionId, int ithBinding) {

	
	for(int i = 0;i < GetMappingCount();i ++)
	{
		 int key = GetKeyForMappingIndex(i);

		 int curKeyActionId = GetMappingFieldForKey(key, kMappingAction);

		if(actionId == curKeyActionId)
		{
			if(ithBinding == 0)
			{
				return  key;
			}
			else
			{
				ithBinding--;
			}
		}
	}

	return  Key.UNDEFINED;

}


public int GetActionCount() {
 return  mActionsCount; 
}


public int GetActionField (int actionId, int field) {

	 int actionIndex = GetActionIndex(actionId, field);

	return  mActionsData[actionIndex];

}


public void SetActionField (int actionId, int field, int value) {

	 int actionIndex = GetActionIndex(actionId, field);

	mActionsData[actionIndex] = value;

}


public void SetAction (int actionId, int actionRepeatInitialDelay, int actionRepeatStepDelay, int keyDownCounter, int keyRepeatIn) {


	SetActionField(actionId, kActionKeyDownCounter, keyDownCounter);
	SetActionField(actionId, kActionRepeatInitialDelay, actionRepeatInitialDelay);
	SetActionField(actionId, kActionRepeatStepDelay, actionRepeatStepDelay);
	SetActionField(actionId, kActionRepeatIn, keyRepeatIn);

}


public void ClearAction (int actionId) {

	for(int i = 0;i < kActionElementCount;i ++)
	{
		SetActionField(actionId, (int)i, 0);
	}

}


public int GetKeyForMappingIndex(int mappingIndex) {
 return  (int)mappingIndex; 
}


public abstract void SetDefault(int a12);



public int GetAllMappingElementCount() {
 return  kMappingElementCount * GetMappingCount(); 
}


public abstract int[] GetCurrentMappingData();



public int KeyCodeToMappingIndex(int key) {
 return  key; 
}


public int GetMappingIndex(int key, int field) {
 return  (key * kMappingElementCount) + field; 
}


public int GetActionIndex(int actionId, int field) {
 return  (actionId * kActionElementCount) + field; 
}


public int[] mActionsData = null;
public int mActionsCount;
public void SetMapping(int key, int actionId, int repeatInitialDelay, int repeatStepDelay)
{
	SetMapping(key, actionId, repeatInitialDelay, repeatStepDelay, (int)0);
}
public void SetAction(int actionId, int actionRepeatInitialDelay, int actionRepeatStepDelay)
{
	SetAction(actionId, actionRepeatInitialDelay, actionRepeatStepDelay, (int)0);
}
public void SetAction(int actionId, int actionRepeatInitialDelay, int actionRepeatStepDelay, int keyDownCounter)
{
	SetAction(actionId, actionRepeatInitialDelay, actionRepeatStepDelay, keyDownCounter, (int)0);
}
public void SetDefault()
{
	SetDefault((int)0);
}



}

