package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class InputMultipleMapping extends InputMapping {

public  InputMultipleMapping (int actionsCount, int mappingLayoutCount) {
super(actionsCount);
mMappingLayoutCount = (mappingLayoutCount);


	mMultipleLayoutMappingData = new int[mappingLayoutCount][GetAllMappingElementCount()];
	Reset();

}


public void destruct() {

	mMultipleLayoutMappingData = null;;

}


public void Write (FileSegmentStream stream) {

	int arraySize;

	arraySize = GetAllMappingElementCount();

	for(int i = 0;i < mMappingLayoutCount;i ++)
	{
		for(int j = 0;j < arraySize;j ++)
		{
			stream.WriteInt(mMultipleLayoutMappingData[i][j]);
		}
	}

	super.Write(stream);

}


public void Read (FileSegmentStream stream) {

	int arraySize;

	arraySize = GetAllMappingElementCount();

	for(int i = 0;i < mMappingLayoutCount;i ++)
	{	
		for(int j = 0;j < arraySize;j ++)
		{
			mMultipleLayoutMappingData[i][j] = (int)stream.ReadInt();
		}
	}

	super.Read(stream);

}


public void Reset () {

	 int currentLayoutMappingIndex = mCurrentMappingDataIndex;

	
	for(int i = 0;i < mMappingLayoutCount;i ++)
	{
		mCurrentMappingDataIndex = i;
		SetDefault(i);
	}
	mCurrentMappingDataIndex = currentLayoutMappingIndex;

}


public void SetCurrentLayoutMappingDataIndex(int layoutIndex) {
 mCurrentMappingDataIndex = layoutIndex; 
}


public void ClearInputMapping (int layoutIndex) {

	 int currentLayoutMappingIndex = mCurrentMappingDataIndex;

	
	mCurrentMappingDataIndex = layoutIndex;

	for(int i = 0;i < GetMappingCount();i ++)
	{
		ClearMapping((int)i);
	}

	mCurrentMappingDataIndex = currentLayoutMappingIndex;

}


public void SetDefault(int layoutIndex)  {

}


public int[] GetCurrentMappingData() {
 return  mMultipleLayoutMappingData[mCurrentMappingDataIndex]; 
}


public int[][] mMultipleLayoutMappingData = null;
public int mMappingLayoutCount;
public int mCurrentMappingDataIndex;
public void ClearInputMapping()
{
	ClearInputMapping((int)0);
}
public void SetDefault()
{
	SetDefault((int)0);
}



}

