package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class LanguageManager {

public final static byte languageCount = (
				(01) +
				(00) +
				(00) +
				(01) + 
				(00) +
				(01) + 
				(01) +
				(01) +
				(00) +
				(00) +
				(00) +
				(00) +
				(00) +
				(00));
public final static byte defaultLanguage = FlLang.En	;

public static LanguageManager Get () {

	return  TetrisApp.Get().GetLanguageManager();

}


public static int LanguageToIndex (short language) {




for(int i = 0;i < languageCount;i ++)
	{
		if(language == IndexToLanguage(i))
		{
			return  i;
		}
	}
	return  -1;

}


public static short IndexToLanguage (int index) {

	
	
	
	 int currentLang = -1;



	if(index == currentLang ++) return  FlLang.uninitialized;;


if(index == currentLang ++) return  FlLang.De;;
if(index == currentLang ++) return  FlLang.En;;
if(index == currentLang ++) return  FlLang.Es;;
if(index == currentLang ++) return  FlLang.Fr;;
if(index == currentLang ++) return  FlLang.It;;

	return  FlLang.undefined;



}


public static short GetDefaultLanguage() {
 return  (short)defaultLanguage; 
}


public static boolean IsLanguageSupported (short language) {

	return  LanguageToIndex(language) >= 0;

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public static short QueryLanguage () {

	 short language = FlLang.undefined;



	language = FlLang.GetBestLang();


if(false || language == FlLang.menu || language == FlLang.uninitialized || language == FlLang.undefined)
	{
		language = GetDefaultLanguage();
	}

	return  language;

}


public LanguageManager () {

	Init(FlLang.uninitialized);

}


public void Init (short lang) {



	if(lang == FlLang.uninitialized)
	{
		lang = QueryLanguage();
	}

	mLanguage = lang;
	mCurrentlyUsedLanguage = lang;



}


public void Read (FileSegmentStream s) {


	 short lang = IndexToLanguage((byte)s.ReadByte());

	if(lang != FlLang.uninitialized)
	{
		Init(lang);
		RessourcesManager.Get().RefreshConstants();
	}




}


public void Write (FileSegmentStream s) {



s.WriteByte((byte)LanguageToIndex(GetLanguage()));

}


public boolean SetLanguage (short language) {

	
	
	 boolean supported = IsLanguageSupported(language);

	if(!supported)
	{
		language = FlLang.undefined;
	}


	mLanguage = language;

	
	
	
	if(!IsLanguageSupported(mCurrentlyUsedLanguage))
	{
		ApplyLanguageChange();
	}
return  supported;

}


public void SetLanguageFromIndex (int index) {

	SetLanguage(IndexToLanguage(index));

}


public short GetLanguage () {


	return  mLanguage;



}


public int GetLanguageAsIndex () {

	return  LanguageToIndex(GetLanguage());

}


public void ApplyLanguageChange () {


	mCurrentlyUsedLanguage = GetLanguage();
	TetrisApp.Get().SetMustSave();
	RessourcesManager.Get().RefreshConstants();

}


public boolean IslanguageChanged () {


	return	mCurrentlyUsedLanguage != FlLang.uninitialized &&
			mCurrentlyUsedLanguage != GetLanguage();



}


public short mLanguage;
public short mCurrentlyUsedLanguage;

/* One dimension array */
public static LanguageManager[] InstArrayLanguageManager(int size) {
	LanguageManager[] newArray = new LanguageManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new LanguageManager();
	return newArray; }

/* Two dimension array */
public static LanguageManager[][] InstArrayLanguageManager(int size1, int size2) {
	LanguageManager[][] newArray = new LanguageManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new LanguageManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new LanguageManager(); }
	return newArray; }

/* Three dimension array */
public static LanguageManager[][][] InstArrayLanguageManager(int size1, int size2, int size3) {
	LanguageManager[][][] newArray = new LanguageManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new LanguageManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new LanguageManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new LanguageManager(); } }
	return newArray; }



}

