package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class MultiDisplayComponent extends Component {

public  MultiDisplayComponent (int maxPositionCount) {
mMaxPositionCount = (maxPositionCount);


	mPositions = Vector2_short.InstArrayVector2_short(mMaxPositionCount);

}


public void destruct() {

	mPositions = null;

}


public void OnDraw (DisplayContext displayContext) {

	for(int i = 0;i < mPositionCount;i ++)
	{




 short offsetX = (short)(GetRectLeft() + mPositions[i].GetX());

		 short offsetY = (short)(GetRectTop() + mPositions[i].GetY());


		displayContext.OffsetBy(offsetX, offsetY);

		mpChild.OnDraw(displayContext);

		displayContext.OffsetBy((short)-offsetX, (short)-offsetY);
	}

}


public void SetChild (Component child) {

	if(mpChild != null)
	{
		
		TetrisApp.ReplaceComponent(this, mpChild);
	}

	if(child != null)
	{
		
		TetrisApp.ReplaceComponent(child, this);
	}

	mpChild = child;

}


public Component GetChild() {
 return  mpChild; 
}


public void AddPosition (Vector2_short position) {



	mPositions[mPositionCount].Assign(position);
	mPositionCount++;

}


public void ClearAllPositions () {

	mPositionCount = 0;

}


public Component mpChild;
public int mMaxPositionCount;
public int mPositionCount;
public Vector2_short[] mPositions = null;
public MultiDisplayComponent()
{
	this((int)4);
}

/* One dimension array */
public static MultiDisplayComponent[] InstArrayMultiDisplayComponent(int size) {
	MultiDisplayComponent[] newArray = new MultiDisplayComponent[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new MultiDisplayComponent();
	return newArray; }

/* Two dimension array */
public static MultiDisplayComponent[][] InstArrayMultiDisplayComponent(int size1, int size2) {
	MultiDisplayComponent[][] newArray = new MultiDisplayComponent[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MultiDisplayComponent[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new MultiDisplayComponent(); }
	return newArray; }

/* Three dimension array */
public static MultiDisplayComponent[][][] InstArrayMultiDisplayComponent(int size1, int size2, int size3) {
	MultiDisplayComponent[][][] newArray = new MultiDisplayComponent[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new MultiDisplayComponent[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new MultiDisplayComponent[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new MultiDisplayComponent(); } }
	return newArray; }



}

