package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class OptionSettings extends Serializable {

public  OptionSettings () {
super();


	Initialize();

}


public void destruct() {
 
}


public void Read (FileSegmentStream inputStream) {





	mSoundEnabled = inputStream.ReadBoolean();





mVolumeLevel = inputStream.ReadShort();
	mMusicMode = ((byte)inputStream.ReadByte());
	mVibrationEnabled = inputStream.ReadBoolean();
	mGhostEnabled = inputStream.ReadBoolean();
	








	SetMediaPlayerSettings();

}


public void Write (FileSegmentStream outputStream) {





	outputStream.WriteBoolean(mSoundEnabled);
	outputStream.WriteShort(mVolumeLevel);
	outputStream.WriteByte((byte)mMusicMode);
	outputStream.WriteBoolean(mVibrationEnabled);
	outputStream.WriteBoolean(mGhostEnabled);


}


public void Reset () {

	Initialize();
	SetMediaPlayerSettings();

}


public void SetSoundEnabled (boolean enabled) {


	mSoundEnabled = enabled;
	GetApp().GetPlayer().SetSoundEnabled(enabled);



}


public boolean IsSoundEnabled () {


	return  mSoundEnabled;



}


public void SetSoundVolume (short volume) {


	
	if(volume > (((int)ConstantsEnglishPortrait.audioMaxValue == (int)ConstantsEnglishLandscape.audioMaxValue) ? Constants.audioMaxValue : -123))
	{
		volume = (((int)ConstantsEnglishPortrait.audioMaxValue == (int)ConstantsEnglishLandscape.audioMaxValue) ? Constants.audioMaxValue : -123);
	}
	else if(volume < (((int)ConstantsEnglishPortrait.audioMinValue == (int)ConstantsEnglishLandscape.audioMinValue) ? Constants.audioMinValue : -123))
	{
		volume = (((int)ConstantsEnglishPortrait.audioMinValue == (int)ConstantsEnglishLandscape.audioMinValue) ? Constants.audioMinValue : -123);
	}

	mVolumeLevel = volume;
	GetApp().GetPlayer().SetVolumeLevel(volume);



}


public short GetSoundVolume () {


	return  mVolumeLevel;



}


public boolean IsMusicEnabled () {


	return  mMusicMode != InGameMusicMode.kInGameMusicOff;



}


public void SetMusicMode (byte mode) {


	GetApp().GetPlayer().SetInGameMusicMode(mode);
	mMusicMode = mode;



}


public byte GetMusicMode () {


	return  mMusicMode;



}


public void SetVibrationEnabled (boolean enabled) {


	mVibrationEnabled = enabled;
	GetApp().GetPlayer().SetVibrationEnabled(enabled);



}


public boolean IsVibrationEnabled () {


	return  mVibrationEnabled;



}


public void SetGhostEnabled (boolean enabled) {

	mGhostEnabled = enabled;

}


public boolean IsGhostEnabled () {

	return  mGhostEnabled;

}


public void ApplySettings() {
 SetMediaPlayerSettings(); 
}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public void Initialize () {

	


mSoundEnabled = true;
mVibrationEnabled = true;
	mGhostEnabled = true;



mVolumeLevel = (short)(((int)ConstantsEnglishPortrait.defaultVolume == (int)ConstantsEnglishLandscape.defaultVolume) ? Constants.defaultVolume : ConstantsGetter.GetConstants().defaultVolumeFct());
	mMusicMode = InGameMusicMode.kInGameMusic1;
	

}


public void SetMediaPlayerSettings () {

	 TetrisMediaPlayer mediaPlayer = GetApp().GetPlayer();
	mediaPlayer.SetSoundEnabled(mSoundEnabled);
	mediaPlayer.SetVibrationEnabled(mVibrationEnabled);
	mediaPlayer.SetVolumeLevel(mVolumeLevel);
	mediaPlayer.SetInGameMusicMode(mMusicMode);

}


public boolean mSoundEnabled;
public boolean mVibrationEnabled;
public boolean mGhostEnabled;
public short mVolumeLevel;
public byte mMusicMode;

/* One dimension array */
public static OptionSettings[] InstArrayOptionSettings(int size) {
	OptionSettings[] newArray = new OptionSettings[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new OptionSettings();
	return newArray; }

/* Two dimension array */
public static OptionSettings[][] InstArrayOptionSettings(int size1, int size2) {
	OptionSettings[][] newArray = new OptionSettings[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new OptionSettings[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new OptionSettings(); }
	return newArray; }

/* Three dimension array */
public static OptionSettings[][][] InstArrayOptionSettings(int size1, int size2, int size3) {
	OptionSettings[][][] newArray = new OptionSettings[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new OptionSettings[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new OptionSettings[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new OptionSettings(); } }
	return newArray; }



}

