package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Particle extends IndexedSprite {

public  Particle (BitmapMap particleBitmapMap) {
mVelocityX = new F32((int)0, 16);
mVelocityY = new F32((int)0, 16);
mStartPositionX = new F32((int)0, 16);
mStartPositionY = new F32((int)0, 16);


	SetParticleBitmapMap(particleBitmapMap);
	SetVisible(false);	

}


public void destruct() {
 
	SetBitmapGroup(null); 

}


public void UpdatePosition (F32 accelerationFactor, int particleLifeTimeMs) {
	
	
	 F32 posX = new F32(mStartPositionX.Add(mVelocityX.Mul(particleLifeTimeMs)));

	 F32 posY = new F32(mStartPositionY.Add(mVelocityY.Mul(particleLifeTimeMs)).Add(accelerationFactor));


	
	SetTopLeft((short)posX.ToInt(16), (short)posY.ToInt(16));

}


public void InitPropulsion (short startPosX, short startPosY, F32 initVelocityX, F32 initVelocityY) {
	
	
	SetTopLeft(startPosX, startPosY);

	mStartPositionX = F32.FromInt(startPosX, 16);
	mStartPositionY = F32.FromInt(startPosY, 16);

	
	mVelocityX = initVelocityX.DivPower2(10);
	mVelocityY = initVelocityY.DivPower2(10);	

}


public void SetParticleBitmapMap (BitmapMap pBitmapMap) {

	SetBitmapGroup((BitmapGroup)pBitmapMap);

	if(pBitmapMap != null)
	{
		
		SetCurrentFrame(FlMath.Random((short)0, (short)(pBitmapMap.GetBitmapCount() - 1)));
	}

}


public F32 mVelocityX;
public F32 mVelocityY;
public F32 mStartPositionX;
public F32 mStartPositionY;



}

