package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class RessourcesManager {

public static RessourcesManager Get () {

	return  GetApp().GetRessourcesManager();

}


public static Constants InstantiateConstants (short lang, byte screenOri) {



	


if(screenOri == ScreenManager.screenOrientationPortrait) { if(FlLang.German == lang) return  new ConstantsGermanPortrait(); } else { if(FlLang.German == lang) return  new ConstantsGermanLandscape(); }
if(screenOri == ScreenManager.screenOrientationPortrait) { if(FlLang.English == lang) return  new ConstantsEnglishPortrait(); } else { if(FlLang.English == lang) return  new ConstantsEnglishLandscape(); }
if(screenOri == ScreenManager.screenOrientationPortrait) { if(FlLang.Spanish == lang) return  new ConstantsSpanishPortrait(); } else { if(FlLang.Spanish == lang) return  new ConstantsSpanishLandscape(); }
if(screenOri == ScreenManager.screenOrientationPortrait) { if(FlLang.French == lang) return  new ConstantsFrenchPortrait(); } else { if(FlLang.French == lang) return  new ConstantsFrenchLandscape(); }
if(screenOri == ScreenManager.screenOrientationPortrait) { if(FlLang.Italian == lang) return  new ConstantsItalianPortrait(); } else { if(FlLang.Italian == lang) return  new ConstantsItalianLandscape(); }

	return  null;

}


public static void CheckUniqueFConsts () {


	












































}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public RessourcesManager () {

	mBackgroundPalettePackageID = PackageID.blueBackground;



mpMainLibrary = new Library(Application.GetDir().Add(StringUtils.CreateString("Tetris")));
CheckUniqueFConsts();
	mCurrentConstants = new Constants();
InitMultiTargetPackageInformations();

}


public void Destruct () {

	int i;


	
	RessourcesManager.Get().RemovePackageFromCache(PackageID.globalBackground);


{
		RessourcesManager.Get().RemovePackageFromCache(mBackgroundPalettePackageID);
	}

	
	
	for(i = PackageID.baseLibraryStartID - 1;i >= 0;i --)
	{
		RessourcesManager.Get().ForceRemovePackage((byte)i);
	}
	for(i = PackageID.count - 1;i >= PackageID.baseLibraryStartID;i --)
	{
		RessourcesManager.Get().ForceRemovePackage((byte)i);
	}

	if(mpMainLibrary != null)
	{
		mpMainLibrary.Close();
		mpMainLibrary = null;
	}




mCurrentConstants = null;

}


public void RefreshConstants () {


	 short lang = LanguageManager.Get().GetLanguage();

	 byte screenOrientation = ScreenManager.Get().GetScreenOrientation();


	 Constants oldConstants = mCurrentConstants;
  	mCurrentConstants = RessourcesManager.InstantiateConstants(lang, screenOrientation);
 	oldConstants = null;

}


public Constants GetConstants () {


	return RessourcesManager.Get().mCurrentConstants;

}


public void AddPackageRef(byte packageID) {
 mPackageRefCounts[packageID]++; 
}


public void RemovePackageRef(byte packageID) {
 ; mPackageRefCounts[packageID]--; 
}


public boolean IsPackageReferenced(byte packageID) {
 return  mPackageRefCounts[packageID] > 0; 
}


public void RemoveBackgroundPalette () {

	

	
	if(GetApp().GetBackgroundViewport() != null)
	{
		GetApp().GetBackgroundViewport().SetViewport(null);
		GetApp().SetBackgroundViewport(null);





}


	if(mBackgroundPalettePackageID != PackageID.invalid)
{	
		
		RemovePackageFromCache(PackageID.globalBackground);
		RemovePackageFromCache(mBackgroundPalettePackageID);
	}
	
	mBackgroundPalettePackageID = PackageID.invalid;
	

}


public void SetBackgroundPalette (byte newPalette) {

	

	
	if(newPalette != mBackgroundPalettePackageID)
	{
		RemoveBackgroundPalette();
	}

	mBackgroundPalettePackageID = newPalette;


{
		
		RessourcesManager.Get().GetPackage(PackageID.globalBackground);
	}

}


public byte GetBackgroundPackageIdForScene (byte nextScenePackageID) {

	switch(nextScenePackageID)
	{








case PackageID.gameScene :
			return  GetApp().GetGameModeSpecificPalette();

	default : 	return  PackageID.blueBackground;
	}


}


public void RefreshBackgroundPackage (byte nextScenePackageID) {

	 byte nextSceneBackgroundPalettePackageID = GetBackgroundPackageIdForScene(nextScenePackageID);

	SetBackgroundPalette(nextSceneBackgroundPalettePackageID);

}


public Package GetGlobalBackground () {


	return  RessourcesManager.Get().GetPackage(PackageID.globalBackground, false);

}


public byte GetBackgroundPalettePackageID() {
 return  mBackgroundPalettePackageID; 
}


public Package GetPackage (byte packageID, boolean asynchrone) {

	

	 Package pkgToGet = mpPackageCache[packageID];
	 boolean pkgCached = pkgToGet != null;




	int[] dependencies = new int[(8)];
	 int dependenciesCount = ListDependenciesForPackage(packageID, dependencies, (8));

	 byte fuserPackageID = ResolveFuserPackageId(packageID);


	if(!pkgCached)
	{
		pkgToGet = GetNewPackage(fuserPackageID);

		pkgToGet.SetNumDependencies(dependenciesCount);
		for(int i = 0;i < dependenciesCount;i ++)
		{
			pkgToGet.SetDependency(i, GetPackage((byte)dependencies[i], asynchrone));
		}
	}

	if(!pkgToGet.IsLoading() && !pkgToGet.IsLoaded())
	{


pkgToGet.Load(asynchrone);
	}

	pkgToGet.SetNextEntryPointIndex(0); 

	if(!pkgCached)
	{

		mpPackageCache[packageID] = pkgToGet;
	}

	return  pkgToGet;

}


public void RemovePackageFromCache (byte packageID) {

	


	if(IsPersistentPackage(packageID))
	{
		
		return ;
	}
ForceRemovePackage(packageID);

}


public boolean IsPackageLoaded (byte packageID) {

	

	 Package _package = mpPackageCache[packageID];

	return  _package != null && _package.IsLoaded();

}


public void ForceRemovePackage (byte packageID) {

	


	 Package packageToUnload = mpPackageCache[packageID];
	if(packageToUnload != null)
	{
		
		if(packageToUnload.IsLoaded() || packageToUnload.IsLoading())
		{
			
			packageToUnload.Unload();
		}
		
		packageToUnload = null;
	}
	mpPackageCache[packageID] = null;

}


public void ReloadMultiTargetPackages () {

	




	
	 byte paletteBefore = mBackgroundPalettePackageID;


	int i;

	for(i = PackageID.baseLibraryStartID - 1;i >= 0;i --)
	{
		 byte pid = (byte)i;

		if(CanBeUnloaded(pid))
		{




{
				if(pid == PackageID.globalBackground)
				{
					RemoveBackgroundPalette();
				}
				else
				{
					ForceRemovePackage(pid);
				}
			}
		}	
	}

	for(i = PackageID.count - 1;i >= PackageID.baseLibraryStartID;i --)
	{ 
		 byte pid = (byte)i;

		if(CanBeUnloaded(pid))
		{




{
				if(pid == PackageID.globalBackground)
				{
					RemoveBackgroundPalette(); 
				}
				else
				{
					ForceRemovePackage(pid);
				}
			}
		}
	}












	mBackgroundPalettePackageID = paletteBefore;
	GetApp().LoadBackgroundResources();

	for(i = 0;i < PackageID.count;i ++)
	{
		 byte pid = (byte)i;

		if(MustAlwaysBeLoaded(pid))
		{
			RessourcesManager.Get().GetPackage(pid, false);
		}
	}




}


public Package GetNewPackage (byte packageID) {

	 Library l = mpMainLibrary;







return  l.NewPackage(packageID);

}


public int ListDependenciesForPackage (byte packageID, int[] dependencies, int maxDependencies) {



 int dependenciesCount = 0;


	switch(packageID)
	{

	case PackageID.common :
		{
			dependencies[dependenciesCount++] = (PackageID.loadingHourGlass); ;
			dependencies[dependenciesCount++] = (PackageID.font); ;

			dependencies[dependenciesCount++] = (PackageID.commonStrings); ;
}
		break;

	case PackageID.aboutMenuScene :
	case PackageID.helpMenuScene :

	case PackageID.tutorialMenuScene :
case PackageID.statisticsMenuScene :
case PackageID.moreGamesMenuScene :
	case PackageID.gameSetupMenuScene :
	case PackageID.singlePlayerModesMenuScene :

	case PackageID.displayOrientationMenuScene :
case PackageID.pauseMenuScene :
	case PackageID.promptMenuScene :


case PackageID.delayLoadingMenuScene :





{
			dependencies[dependenciesCount++] = (PackageID.common); ;
			dependencies[dependenciesCount++] = (PackageID.commonMenu); ;

			dependencies[dependenciesCount++] = (PackageID.menuStrings); ;
}
		break;













case PackageID.marathonScoreMenuScene :
	case PackageID.ultraScoreMenuScene :
	case PackageID.fortyLinesScoreMenuScene :


{
			dependencies[dependenciesCount++] = (PackageID.common); ;
			dependencies[dependenciesCount++] = (PackageID.commonMenu); ;

			dependencies[dependenciesCount++] = (PackageID.menuStrings); ;
}
		break;

	case PackageID.optionsMenuScene :
		{
			dependencies[dependenciesCount++] = (PackageID.common); ;
			dependencies[dependenciesCount++] = (PackageID.commonMenu); ;

			dependencies[dependenciesCount++] = (PackageID.menuStrings); ;
dependencies[dependenciesCount++] = (PackageID.gameSound); ;
}
		break;








case PackageID.mainMenuScene :
		{
			dependencies[dependenciesCount++] = (PackageID.common); ;
			dependencies[dependenciesCount++] = (PackageID.commonMenu); ;

			dependencies[dependenciesCount++] = (PackageID.menuStrings); ;
}
		break;

	case PackageID.gameScene :
		{
			dependencies[dependenciesCount++] = (PackageID.common); ;
			dependencies[dependenciesCount++] = (mBackgroundPalettePackageID); ;
			dependencies[dependenciesCount++] = (PackageID.globalBackground); ;
			dependencies[dependenciesCount++] = (PackageID.playerMino); ;


dependencies[dependenciesCount++] = (PackageID.highlightMino); ;
dependencies[dependenciesCount++] = (PackageID.darkMino); ;
dependencies[dependenciesCount++] = (PackageID.gameStrings); ;
}
		break;

	case PackageID.splashMenuScene :
		{
			dependencies[dependenciesCount++] = (PackageID.common); ;
			dependencies[dependenciesCount++] = (PackageID.commonMenu); ;

			dependencies[dependenciesCount++] = (PackageID.menuStrings); ;
}
		break;







case PackageID.gameSound :
		{

			dependencies[dependenciesCount++] = (GetApp().GetInGameMusicPackageID()); ;
}
		break;
case PackageID.playerMino :

	case PackageID.darkMino :
{
			dependencies[dependenciesCount++] = (PackageID.minoParts); ;
		}
		break;


	case PackageID.globalBackground :
		{


{
				dependencies[dependenciesCount++] = (mBackgroundPalettePackageID); ;;
			}					
		}
		break;

	default :

	}

	return  dependenciesCount;


}


public boolean CanBeUnloaded (byte pid) {

	
		return  true && pid != PackageID.emptyScene && pid != PackageID.introSound && pid != PackageID.loadingHourGlass && pid != PackageID.tetriminoMarks;

}


public boolean MustAlwaysBeLoaded (byte pid) {

	

	return 	   pid == PackageID.font || pid == PackageID.common;

}


public boolean IsPersistentPackage (byte _package) {

	
	return  false || _package == PackageID.loadingHourGlass || _package == PackageID.introSound || _package == PackageID.font || _package == PackageID.common || _package == PackageID.commonMenu;

}


public byte ResolveFuserPackageId (byte p) {

	 int langi = LanguageManager.Get().GetLanguageAsIndex();

	 byte screenOri = ScreenManager.Get().GetScreenOrientation();

	 int resi = ScreenManager.ScreenOrientationToIndex(screenOri);


	 byte result = ResolveFuserPackageId(p, langi, resi);

	return  result;

}


public byte ResolveFuserPackageId (byte pid, int langi, int resi) {

	
	
	

	 int languageCount = LanguageManager.languageCount;

	 int resolutionCount = ScreenManager.screenOrientationCount;


	 int firstMultiTargetPkgID = GetFirstMultiTargetPackageId();


	 int langDepFirstInstPkgID = firstMultiTargetPkgID;

	 int langDepPkgInstCount = MultiTargetTypesCount.language * languageCount;

	 int langDepLangStep = MultiTargetTypesCount.language;


	 int resDepFirstInstPkgID = langDepFirstInstPkgID + langDepPkgInstCount;

	 int resDepPkgInstCount = MultiTargetTypesCount.resolution * resolutionCount;

	 int resDepResStep = MultiTargetTypesCount.resolution;


	 int resLangDepFirstInstPkgID = resDepFirstInstPkgID + resDepPkgInstCount;

	 int resLangDepPkgInstCount = MultiTargetTypesCount.languageResolution * languageCount * resolutionCount;

	 int resLangDepLangStep = languageCount;

	 int resLangDepResStep = resLangDepLangStep * resolutionCount;


	 int lastMultiTargetPkgID = resLangDepFirstInstPkgID + resLangDepPkgInstCount - 1;

	 int realPackageCount = lastMultiTargetPkgID + 1;




	
	
	

	if(IsMultiTargetTypeNone(pid))
	{
		
		return  (byte)pid;
	}

	 int multiResSubtypeIndex = GetMultiTargetIndex(pid);

	 int returnedPackage = multiResSubtypeIndex;


	if(IsMultiTargetTypeLanguage(pid))
	{
		returnedPackage += langDepFirstInstPkgID;
		returnedPackage += langDepLangStep * langi;

	}
	else if(IsMultiTargetTypeResolution(pid))
	{
		returnedPackage += resDepFirstInstPkgID;
		returnedPackage += resDepResStep * resi;
	}
	else
	{

		returnedPackage += resLangDepFirstInstPkgID;
		returnedPackage += resLangDepResStep * resi;
		returnedPackage += resLangDepLangStep * langi;
	}

	return  (byte)returnedPackage;

}


public static byte GetFirstMultiTargetPackageId () {



return  PackageID.count;

}


public void UnloadPackageDependencies (byte packageID) {

	



	switch(packageID)
	{

		case PackageID.optionsMenuScene :
			{
				 TetrisMediaPlayer mp = GetApp().GetPlayerPtr();
				if(mp != null)
				{
					mp.UnloadGameSounds();
				}
			}
			break;
case PackageID.gameScene :
			{
				RemovePackageFromCache(PackageID.playerMino);


				RemovePackageFromCache(PackageID.darkMino);
RemovePackageFromCache(PackageID.minoParts);



RemovePackageFromCache(PackageID.highlightMino);
RemovePackageFromCache(PackageID.gameStrings);
 TetrisMediaPlayer mp = GetApp().GetPlayerPtr();
				if(mp != null)
				{
					mp.UnloadGameSounds();
				}
			}
			break;







default :
			break;
	}

}


public void InitMultiTargetPackageInformations () {



int[] packageCounter = new int[MultiTargetTypes.count];
	int i;

	for(i = 0;i < MultiTargetTypes.count;i ++) packageCounter[i] = 0;

	for(i = 0;i < PackageID.count;i ++)
	{
		 byte packageID = (byte)i;


		 byte mtt = CalculateMultiTargetType(packageID);

		mPackagesMultiTargetType[packageID] = mtt;
		mPackageMultiTargetIndex[packageID] = packageCounter[mtt] ++;
	}

	




















}


public byte CalculateMultiTargetType (byte packageID) {

	 byte typeDefault = MultiTargetTypes.none;

	 byte typeLang = MultiTargetTypes.language;

	 byte typeRes = MultiTargetTypes.resolution;

	 byte typeLangRes = MultiTargetTypes.languageResolution;

	; ;
	; ; 

	byte typeTryMultiLang;

	typeTryMultiLang = typeLang;


	byte typeTryMultiRes;

	typeTryMultiRes = typeRes;


	byte typeTryMultiResLang;

	typeTryMultiResLang = typeLangRes;



	switch(packageID)
	{

	case PackageID.commonStrings :
	case PackageID.menuStrings :
	case PackageID.gameStrings :
		return  typeTryMultiLang;
case PackageID.common :
	case PackageID.font :

	case PackageID.splashMenuScene :
	case PackageID.commonMenu :
	case PackageID.aboutMenuScene :
	case PackageID.helpMenuScene :
	case PackageID.marathonScoreMenuScene :
	case PackageID.ultraScoreMenuScene :
	case PackageID.fortyLinesScoreMenuScene :


case PackageID.delayLoadingMenuScene :


case PackageID.moreGamesMenuScene :
	case PackageID.gameScene :
	case PackageID.gameSetupMenuScene :
	case PackageID.singlePlayerModesMenuScene :

	case PackageID.displayOrientationMenuScene :
case PackageID.mainMenuScene :
	case PackageID.statisticsMenuScene :

	case PackageID.tutorialMenuScene :
case PackageID.optionsMenuScene :
	case PackageID.pauseMenuScene :
	case PackageID.promptMenuScene :








case PackageID.minoParts :
	case PackageID.playerMino :


case PackageID.highlightMino :
case PackageID.darkMino :
case PackageID.loadingHourGlass :
	case PackageID.blueBackground :


case PackageID.globalBackground :
		return  typeTryMultiRes;

	default :
		return  typeDefault;
	}

}


public byte GetMultiTargetType (byte packageID) {





return  mPackagesMultiTargetType[packageID];

}


public int GetMultiTargetIndex (byte packageID) {





return  mPackageMultiTargetIndex[packageID];

}


public boolean IsMultiTargetTypeNone (byte packageID) {

	return  GetMultiTargetType(packageID) == MultiTargetTypes.none;

}


public boolean IsMultiTargetTypeLanguage (byte packageID) {

	return  GetMultiTargetType(packageID) == MultiTargetTypes.language;

}


public boolean IsMultiTargetTypeResolution (byte packageID) {

	return  GetMultiTargetType(packageID) == MultiTargetTypes.resolution;

}


public boolean IsMultiTargetTypeLanguageResolution (byte packageID) {

	return  GetMultiTargetType(packageID) == MultiTargetTypes.languageResolution;

}


public Library mpMainLibrary;
public Package[] mpPackageCache = new Package[PackageID.count];

public byte[] mPackagesMultiTargetType = new byte[PackageID.count];

public int[] mPackageMultiTargetIndex = new int[PackageID.count];

public Constants mCurrentConstants;
public byte[] mPackageRefCounts = new byte[PackageID.count];

public byte mBackgroundPalettePackageID;
public Package GetPackage(byte packageID)
{
	return GetPackage(packageID, true);
}

/* One dimension array */
public static RessourcesManager[] InstArrayRessourcesManager(int size) {
	RessourcesManager[] newArray = new RessourcesManager[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new RessourcesManager();
	return newArray; }

/* Two dimension array */
public static RessourcesManager[][] InstArrayRessourcesManager(int size1, int size2) {
	RessourcesManager[][] newArray = new RessourcesManager[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RessourcesManager[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new RessourcesManager(); }
	return newArray; }

/* Three dimension array */
public static RessourcesManager[][][] InstArrayRessourcesManager(int size1, int size2, int size3) {
	RessourcesManager[][][] newArray = new RessourcesManager[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new RessourcesManager[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new RessourcesManager[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new RessourcesManager(); } }
	return newArray; }



}

