package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class StringToolbox {

public StringToolbox () {

	Init();

}


public static void Init () {

	DoInit();

}


public static void Destruct () {

	DoDestruct();

}


public static int FindStringILastNLines ( String s, int nbLines, int stringLength) {

	


	if(nbLines <= 0)
	{
		return  stringLength;
	}

	for(int i = stringLength - 1;i >= 0;i --)
	{
		if(s.GetCharAt(i) != (byte)'\r')
		{
			continue;
		}

		nbLines--;
		if(nbLines <= 0)
		{
			return  i + 1;
		}
	}

	return  0;

}


public static void CropStringToNLines (String s, int nbLines) {

	 int sLen = s.GetLength();

	 int iNLines = FindStringILastNLines(s, nbLines, sLen);

	if(iNLines != 0)
	{
		s.Assign(s.Substring(iNLines, sLen));
	}

}


public static boolean IsAlphaNum ( String s) {

	 int len = s.GetLength();

	for(int i = 0;i < len;i ++)
	{
		if(!IsAlphaNum(s.GetCharAt(i)))
		{
			return  false;
		}
	}

	return  true;

}


public static boolean IsAlphaNum (byte c) {

	return	(byte)'A' <= c && c <= (byte)'Z' ||
			(byte)'a' <= c && c <= (byte)'z' ||
			(byte)'0' <= c && c <= (byte)'9';

}


public static boolean IsWithinLengths ( String s, int minLen, int maxLen) {

	 int len = s.GetLength();

	return  minLen <= len && len <= maxLen;

}


public static void AssignToUpper (String lowerCase) {

	 int lowerCaseLength = lowerCase.GetLength();


	for(int i =0;i < lowerCaseLength;i ++)
	{
		 byte temp = lowerCase.GetCharAt(i);

		if(temp >='a' && temp <='z')
		{
			lowerCase.ReplaceCharAt(i, (byte)(temp - ('a'-'A')) );
		}
	}

}


public static void AssignToTrunc (String str, int textWidth, Font textFont) {


	 int stringWidth = textFont.GetLineWidth(str);


	if(stringWidth > textWidth)
	{
		AssignToRightTrim(str);

		if(str.IsEmpty())
		{
			str.AddAssign(StringToolbox.SpaceString());
			return ;
		}




str.AddAssign(StringUtils.CreateString("."));
		 int indexLastCharOffset = 2;

stringWidth = textFont.GetLineWidth(str);

		while(stringWidth > textWidth)
		{
			str.RemoveCharAt(str.GetLength() - indexLastCharOffset);
			stringWidth = textFont.GetLineWidth(str);
		}
	}

}


public static void AssignToReplace (String str, String strToFind, String strToUse) {

	 int index = str.FindSubstring(strToFind);


	String result = new String();

	result.AddAssign(str.Substring(0, index));
	result.AddAssign(strToUse);
	result.AddAssign(str.Substring(index + strToFind.GetLength(), str.GetLength() - 1));
	str.Assign(result);

}


public static void AssignToRightTrim (String str) {

	 int len = str.GetLength();


	while(len > 0&& str.GetCharAt(len - 1) == (byte)' ')
	{
		str.RemoveCharAt(len - 1);
		len--;
	}

}


public static void EnsureStringEndsWithLineFeed (String s) {

	boolean addNL;

	if(s.IsEmpty())
	{
		addNL = true;
	}
	else
	{
		 byte lastChar = s.GetCharAt(s.GetLength() - 1);

		addNL = lastChar != (byte)'\r';
	}

	if(addNL)
	{
		s.AddAssign(CarriageReturnString());
	}

}


public static byte InverseAlignment (byte a) {

	if(a == Alignment.LEFT) return  Alignment.RIGHT;
	if(a == Alignment.RIGHT) return  Alignment.LEFT;
	return  Alignment.CENTER;

}


public static String FormatTime (int millisecond) {

	 int tempMilli = millisecond;

	 int minute = 0;

	 int second = 0;


	minute = tempMilli / 60000;

	tempMilli -= minute * 60000;

	second = tempMilli / 1000;

	String time = new String();


	if(minute < 10)
	{
		time.AddAssign(new String(0));
	}

	time.AddAssign(new String(minute));
	time.AddAssign(StringUtils.CreateString(":"));

	if(second < 10)
	{
		time.AddAssign(new String(0));
	}

	time.AddAssign(new String(second));

	return  time;

}


public static String EmptyString () {

	return  DoEmptyString();

}


public static String CarriageReturnString () {

	return  DoCarriageReturnString();

}


public static String PercentSString () {

	return  DoPercentSString();

}


public static String SpaceString () {

	return  DoSpaceString();

}


public static String ZeroString () {

	return  DoZeroString();

}


public static void DoInit () {

	mEmptyString = new String();
	mCarriageReturnString = StringUtils.CreateStringPtr("\r");
	mPercentSString = StringUtils.CreateStringPtr("%S");
	mSpaceString = StringUtils.CreateStringPtr(" ");
	mZeroString = StringUtils.CreateStringPtr("0");

}


public static void DoDestruct () {

	mEmptyString = null;
	mCarriageReturnString = null;
	mPercentSString = null;
	mSpaceString = null;
	mZeroString = null;

}


public static String DoEmptyString () {

	return mEmptyString;

}


public static String DoCarriageReturnString () {

	return mCarriageReturnString;

}


public static String DoPercentSString () {

	return mPercentSString;

}


public static String DoSpaceString () {

	return mSpaceString;

}


public static String DoZeroString () {

	return mZeroString;

}


public static String mEmptyString;
public static String mCarriageReturnString;
public static String mPercentSString;
public static String mSpaceString;
public static String mZeroString;

/* One dimension array */
public static StringToolbox[] InstArrayStringToolbox(int size) {
	StringToolbox[] newArray = new StringToolbox[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new StringToolbox();
	return newArray; }

/* Two dimension array */
public static StringToolbox[][] InstArrayStringToolbox(int size1, int size2) {
	StringToolbox[][] newArray = new StringToolbox[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new StringToolbox[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new StringToolbox(); }
	return newArray; }

/* Three dimension array */
public static StringToolbox[][][] InstArrayStringToolbox(int size1, int size2, int size3) {
	StringToolbox[][][] newArray = new StringToolbox[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new StringToolbox[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new StringToolbox[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new StringToolbox(); } }
	return newArray; }



}

