package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisGame {

public  TetrisGame (TetrisPlayer player, Well pWell) {
mpTetrisPlayer = player;
mLevel = (1);
mGoal = ((((int)ConstantsEnglishPortrait.goalNbLineStart == (int)ConstantsEnglishLandscape.goalNbLineStart) ? Constants.goalNbLineStart : ConstantsGetter.GetConstants().goalNbLineStartFct()));
mCanHold = (true);
mGamePhase = (kPhaseWaitingForStart);
mGameOverType = (kGameNotOver);
mLastFeltRow = ((((int)ConstantsEnglishPortrait.pieceStartY == (int)ConstantsEnglishLandscape.pieceStartY) ? Constants.pieceStartY : ConstantsGetter.GetConstants().pieceStartYFct()));
mGameSpecialStatus = (kNone);


	








{
		mpWell = new Well();		
	}	

	 int i = 0;

	for(i = 0;i < (((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct());i ++)
	{
		mpNextPiecesQueue[i] = null;
	}

	for(i = 0;i < Tetrimino.kTetriminoCount;i ++)
	{
		mpTetriminoPool[i] = null;
	}

	SetIsCurrentTetriminoTSpin(false);

}


public void destruct() {



{
		mpWell = null;
	}
	mpWell = null;
	
	if((mpFallingTetrimino)!= null) { (mpFallingTetrimino).Destruct(); (mpFallingTetrimino)= null; ; };
	if((mpHoldedTetrimino)!= null) { (mpHoldedTetrimino).Destruct(); (mpHoldedTetrimino)= null; ; };
	if((mpPlaybackTetrimino)!= null) { (mpPlaybackTetrimino).Destruct(); (mpPlaybackTetrimino)= null; ; };

	int i;

	for(i = 0;i < (((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct());i ++)
	{
		if((mpNextPiecesQueue[i])!= null) { (mpNextPiecesQueue[i]).Destruct(); (mpNextPiecesQueue[i])= null; ; };
	}

	for(i = 0;i < Tetrimino.kTetriminoCount;i ++)
	{
		if((mpTetriminoPool[i])!= null) { (mpTetriminoPool[i]).Destruct(); (mpTetriminoPool[i])= null; ; };
	}

}


public final static int kPhaseWaitingForStart = 0;
public final static int kPhaseWaitForFall = 1;
public final static int kPhaseFalling = 2;
public final static int kPhaseHardDropped = 3;
public final static int kPhaseLock = 4;
public final static int kPhaseLocked = 5;
public final static int kPhaseLinesCleared = 6;
public final static int kPhaseLinesAdded = 7;
public final static int kPhaseEnd = 8;

public final static int kMovePieceLeft = 0;
public final static int kMovePieceRight = 1;
public final static int kRotatePieceClockWise = 2;
public final static int kRotatePieceCounterClockWise = 3;
public final static int kNoAction = 4;

public final static int kMatrixX = 0;
public final static int kMatrixY = 1;
public final static int kFacingDir = 2;
public final static int kLinesAccepted = 3;
public final static int kParamsCount = 4;

public final static int kLockdownBoolParamOpponentHolded = 0;
public final static int kLockdownBoolParamIsTSpin = 1;

public final static int kGameNotOver = 0;
public final static int kGameOverLockOut = 1;
public final static int kGameOverTopOut = 2;
public final static int kGameOverBlockOut = 3;
public final static int kGameOverNoLinesLeft = 4;
public final static int kGameOverNoTetriminoLeft = 5;
public final static int kGameOverNoTimeLeft = 6;
public final static int kGameOverForfeit = 7;

public final static int kResultNotSet = 0;
public final static int kResultLose = 1;
public final static int kResultWin = 2;
public final static int kResultTie = 3;
public final static int kResultForfeit = 4;

public final static int kNone = -1;
public final static int kTSpin = 0;
public final static int kTSpinSingle = 1;
public final static int kTSpinDouble = 2;
public final static int kTetris = 3;
public final static int kTSpinSingleBackToBack = 4;
public final static int kTSpinDoubleBackToBack = 5;
public final static int kTetrisBackToBack = 6;

public void OnTime (int elapsedMs) {

	

	
	if(elapsedMs > (((int)ConstantsEnglishPortrait.maxFrameTimeMs == (int)ConstantsEnglishLandscape.maxFrameTimeMs) ? Constants.maxFrameTimeMs : ConstantsGetter.GetConstants().maxFrameTimeMsFct()))
	{
		elapsedMs = (((int)ConstantsEnglishPortrait.maxFrameTimeMs == (int)ConstantsEnglishLandscape.maxFrameTimeMs) ? Constants.maxFrameTimeMs : ConstantsGetter.GetConstants().maxFrameTimeMsFct());
	}












 TetrisState tetrisState = GetTetrisState();

	if(tetrisState.IsGameModeUsingTimeLimit())
	{
		if(!mGameTimeExpired && GetPlayTimeMs() >= tetrisState.GetTimeLimit())
		{
			if((GetGamePhase() <= kPhaseFalling || mGamePhase > kPhaseLinesCleared))
			{
				OnGameOver(kGameOverNoTimeLeft);

				
				mGamePhase = kPhaseEnd;
				mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventGameOverResult, mPlayTimeMs);
			}
			else
			{
				mGameTimeExpired = true;
			}
		}
	}










switch(mGamePhase)
	{
	case kPhaseWaitingForStart :



break;
	case kPhaseWaitForFall :
		
		
		InitPhaseFalling();
		break;
	case kPhaseFalling :
		RunPhaseFalling(elapsedMs);
		break;

	case kPhaseHardDropped :
		RunPhaseHardDropped(elapsedMs);
		break;
case kPhaseLock :
		RunPhaseLock(elapsedMs);
		break;





case kPhaseLocked :
	case kPhaseLinesCleared :
	case kPhaseLinesAdded :
		if(!mpWell.IsDoingAnimation())
		{
			NextGamePhase();
		}
		break;
	case kPhaseEnd :
		break;



default :

	}

}


public void Start () {

	

	 TetrisState tetrisState = GetTetrisState();















RefillNextPiecesBag();
	for(int i = 0;i < (((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct());i ++)
	{
		mpNextPiecesQueue[i] = CreateTetrimino(mNextPiecesBag[i]);
	}
	RefillNextPiecesBag(); 







{
		mGamePhase = kPhaseWaitForFall;
	}






}


public Tetrimino GetFallingTetrimino() {
 return  mpFallingTetrimino; 
}


public void DoPieceAction (int action) {

	

	 boolean actionValid = false;


	switch(action)
	{
	case kMovePieceLeft :
	case kMovePieceRight :
		actionValid = mpFallingTetrimino.Move(action == kMovePieceLeft);
		break;
	case kRotatePieceClockWise :
	case kRotatePieceCounterClockWise :
		{
			
			 short posXBeforeRotation = mpFallingTetrimino.GetMatrixPosX();

			 short posYBeforeRotation = mpFallingTetrimino.GetMatrixPosY();


			actionValid = mpFallingTetrimino.Rotate(action == kRotatePieceClockWise);

			
			
			
			 boolean superRotation = mpFallingTetrimino.GetMatrixPosX() != posXBeforeRotation || 
								 mpFallingTetrimino.GetMatrixPosY() != posYBeforeRotation;


			
			if(actionValid && !superRotation && CheckForTSpin())
			{
				SetIsCurrentTetriminoTSpin(true);
			}
		}
		break;
	default :

	}
	
	
	if(actionValid)
	{
		if(GetTetrisState().IsGameModeUsingExtendedLockDown())
		{
			if(--mExtendedLockDownRemainingMoves > 0)
			{
				ResetLockDownDelay();
			}			
		}
		else
		{
			ResetLockDownDelay();
		}
	}

}


public Well GetWell() {
 return  mpWell; 
}


public void SetSoftDropActive (boolean active) {

	

	if(mpFallingTetrimino == null)
	{
		
		
		
		return ;
	}

	if(active)
	{
		mNextDropTimeMs = ValidateFallSpeed(mPieceFallRate / (((int)ConstantsEnglishPortrait.softDropMultFactor == (int)ConstantsEnglishLandscape.softDropMultFactor) ? Constants.softDropMultFactor : ConstantsGetter.GetConstants().softDropMultFactorFct()));	
	}
	else if(mpFallingTetrimino.IsSoftDropping())
	{
		
		
		if(mpFallingTetrimino.Fall())
		{
			SoftDroppedLine();
			mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventSoftDrop, mPlayTimeMs); 
			mNextDropTimeMs = mPieceFallRate;
		}		
	}

	mpFallingTetrimino.SetSoftDropping(active);

}


public void HardDrop () {

	

	
	mHardDropping = true;

	while(mpFallingTetrimino.Fall())
	{
		
		LineDropedScore((((int)ConstantsEnglishPortrait.hardDropScore == (int)ConstantsEnglishLandscape.hardDropScore) ? Constants.hardDropScore : ConstantsGetter.GetConstants().hardDropScoreFct()));
	}


	
	mGamePhase = kPhaseHardDropped;
	ResetHardDropDelay();

	
	mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventTetriminoHardDrop, mPlayTimeMs);




}


public Tetrimino GetPieceAt (int index) {
 
	













return  mpNextPiecesQueue[(mNextTetriminoIndex+index)%(((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct())]; 

}


public void HoldTetrimino () {

	

	if(mCanHold)
	{





if(mpHoldedTetrimino == null)
		{
			mpHoldedTetrimino = mpFallingTetrimino;
			mpFallingTetrimino = PopNextPiece();
		}
		else
		{
			 Tetrimino tempTetrimino = mpHoldedTetrimino;
			mpHoldedTetrimino = mpFallingTetrimino;
			mpFallingTetrimino = tempTetrimino;
		}

		mpHoldedTetrimino.MoveAtStartPosition();
		mpHoldedTetrimino.ForceDefaultOrientationFacing();
		mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventTetriminoHold, mPlayTimeMs);
		mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventTetriminoStartsFalling, mPlayTimeMs);
		ResetLockDownDelay();
		mCanHold = false;
	}

}


public Tetrimino GetHoldedTetrimino() {
 return  mpHoldedTetrimino; 
}


public Tetrimino GetPlaybackTetrimino() {
 return  mpPlaybackTetrimino; 
}


public int GetLevel() {
 return  mLevel; 
}


public int GetGoal() {
 return  mGoal; 
}


public int GetLineCount() {
 return  mLineCount; 
}


public boolean IsCurrentTetriminoTSpin() {
 return  mTSpinDone; 
}


public void SetIsCurrentTetriminoTSpin(boolean isTSpin) {
 mTSpinDone = isTSpin; 
}


public int GetScore() {
 return  mScore; 
}


public void SetScore (int score) {

	

	mScore = score;






}


public void SetLineCount(int lineCount) {
 mLineCount = lineCount; 
}


public boolean IsWon40Lines() {
 return  mLineCount >= 0; 
}


public void LineDropedScore (int points) {

	

	SetScore(GetScore() + points);


if(GetScore() < 0)
	{


SetScore(0);
	}

}


public int GetLockCount() {
 return  mLockCount; 
}


public int GetClearedLineCount() {
 return  mClearedLineCount; 
}


public int GetGamePhase() {
 return  mGamePhase; 
}


public void NextGamePhase () {

	

	switch(mGamePhase)
	{
	case kPhaseLocked :
		ClearLines();
		break;
	case kPhaseLinesCleared :
		AddLines();
		break;
	case kPhaseLinesAdded :
		if(mGameOverType == kGameNotOver)
		{
			mGamePhase = kPhaseWaitForFall;
		}
		else
		{
			mGamePhase = kPhaseEnd;
			mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventGameOverResult, mPlayTimeMs);
		}
		break;
	default :

	}

}


public int GetGameOverType() {
 return  mGameOverType; 
}


public void SendGameEventToOpponent (int gameEvent) {















}


public void OnSingleplayerGameOver () {







}


public void OnMultiplayerGameOver () {







}


public void OnGameOver (int gameOverType) {
	
	

	mGameOverType = gameOverType;
	mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventGameOver, mPlayTimeMs, mGameOverType);

}


public static int MakeLockParams (byte lockParams[] ) {

	



	 int outLockParams = 0;

	for(int i = 0;i < kParamsCount;i ++)
	{
		outLockParams |= lockParams[i] << (i * 8);
	}
	return  outLockParams;

}


public static void ExtractLockParams (int lockParams, byte outLockParams[] ) {

	



	for(int i = 0;i < kParamsCount;i ++)
	{
		outLockParams[i] = (byte)((lockParams >> (i * 8)) & 0xff);
	}

}


public int GetTetriminoSeed() {
 return  mTetriminoSeed; 
}


public void SetTetriminoSeed (int seed) {

	

	mGenerators[TetrisState.kSeedTetrimino].ReInitialize(seed);
	mTetriminoSeed = seed;

}


public void ResetTetriminoGenerator() {
 mGenerators[(((int)ConstantsEnglishPortrait.seedTetriminoOrder == (int)ConstantsEnglishLandscape.seedTetriminoOrder) ? Constants.seedTetriminoOrder : ConstantsGetter.GetConstants().seedTetriminoOrderFct())].ReInitialize(mTetriminoSeed); 
}


public void SetSeed(int seedType, int seed) {
 mGenerators[seedType].ReInitialize(seed); 
}


public void InitLevel (int level) {
 
	

	mLevel = level;
	mGoal = level * (((int)ConstantsEnglishPortrait.goalNbLineStart == (int)ConstantsEnglishLandscape.goalNbLineStart) ? Constants.goalNbLineStart : ConstantsGetter.GetConstants().goalNbLineStartFct());
	mPieceFallRate = GetFallRateForLevel(mLevel); 

}


public void Reset () {

	

	mLevel = 1;
	mGoal = 10;
	SetScore(0);
	mLineCount = 0;	
	mPieceFallRate = 0;
	mClearedLineCount = 0;
	mBackToBackPossible = false;
	mPlayTimeMs = 0;
	mGameTimeExpired = false;
	mCanHold = true;
	mGamePhase = kPhaseWaitingForStart;
	mGameOverType = kGameNotOver;	
	if((mpFallingTetrimino)!= null) { (mpFallingTetrimino).Destruct(); (mpFallingTetrimino)= null; ; };
	if((mpHoldedTetrimino)!= null) { (mpHoldedTetrimino).Destruct(); (mpHoldedTetrimino)= null; ; };
	if((mpPlaybackTetrimino)!= null) { (mpPlaybackTetrimino).Destruct(); (mpPlaybackTetrimino)= null; ; };
	mNextTetriminoIndex = 0;
	mNextDropTimeMs = 0;
	mNextPlaybackTimeMs = 0;
	mLockDownDelayMs = 0;

	mHardDropDelayMs = 0;
mLockCount = 0;	

	 mGameSpecialStatus = kNone;
int i;

	for(i = 0;i < (((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct());i ++)
	{
		if((mpNextPiecesQueue[i])!= null) { (mpNextPiecesQueue[i]).Destruct(); (mpNextPiecesQueue[i])= null; ; };
	}
	for(i = 0;i < Tetrimino.kTetriminoCount;i ++)
	{
		if((mpTetriminoPool[i])!= null) { (mpTetriminoPool[i]).Destruct(); (mpTetriminoPool[i])= null; ; };
	}

	mpWell.Clear();

	Start();

}


public void SetPlayTimeMs (int playTimeMs) {

	

	mPlayTimeMs = playTimeMs; 






}


public int GetPlayTimeMs() {
 return  mPlayTimeMs; 
}


public boolean IsHardDropping() {
 return  mHardDropping; 
}


public int GetGameSpecialStatus() {
 return  mGameSpecialStatus; 
}


public Tetrimino CopyTetrimino (Tetrimino dest, Tetrimino source, Well pDestWell) {

	

	ReleaseTetrimino(dest);
	dest = CreateTetrimino(source.GetType());
	Tetrimino.CopyTetrimino(dest, source, pDestWell);

	return  dest;

}


public void InitPhaseFalling () {

	



	
	
	mPieceFallRate = GetFallRateForLevel(mLevel);	

	ReleaseTetrimino(mpFallingTetrimino);

	mpFallingTetrimino = PopNextPiece();






mCanHold = (GetPieceAt(0) == null && mpHoldedTetrimino == null ? false : true);

	
	mHardDropping = false;

	
	
	mLastFeltRow = (((int)ConstantsEnglishPortrait.pieceStartY == (int)ConstantsEnglishLandscape.pieceStartY) ? Constants.pieceStartY : ConstantsGetter.GetConstants().pieceStartYFct());

	SetIsCurrentTetriminoTSpin(false);
	


	
	if(mpFallingTetrimino.IsFree(0, 0, mpFallingTetrimino.GetFacingDir()))
	{
		mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventTetriminoStartsFalling, mPlayTimeMs);
		mGamePhase = kPhaseFalling;
	}
	else
	{
		
		OnGameOver(kGameOverBlockOut);
	}

}


public Tetrimino PopNextPiece () {

	

	 Tetrimino firstTetrimino = null; 










{
		firstTetrimino = mpNextPiecesQueue[mNextTetriminoIndex];
		mpNextPiecesQueue[mNextTetriminoIndex] = CreateTetrimino(mNextPiecesBag[mNextTetriminoIndex]);

		mNextTetriminoIndex++;

		
		if(mNextTetriminoIndex == (((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct()))
		{
			RefillNextPiecesBag();
			mNextTetriminoIndex = 0;
		}
	}







return  firstTetrimino;

}


public Tetrimino PeekNextPiece () {

	

	 Tetrimino firstTetrimino = null; 







{
		firstTetrimino = mpNextPiecesQueue[mNextTetriminoIndex];
	}

	return  firstTetrimino;

}


public void RefillNextPiecesBag () {

	

	int i;
	

	
	for(i = 0;i < (((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : ConstantsGetter.GetConstants().nextPieceQueueSizeFct());i ++)
	{
		mNextPiecesBag[i] = (int)(i %Tetrimino.kTetriminoCount);
	}

	 int setOffset = 0;


	
	for(i = 0;i < (((int)ConstantsEnglishPortrait.tetriminoSetsInQueue == (int)ConstantsEnglishLandscape.tetriminoSetsInQueue) ? Constants.tetriminoSetsInQueue : ConstantsGetter.GetConstants().tetriminoSetsInQueueFct());i ++)
	{
		for(int j = 0;j < Tetrimino.kTetriminoCount;j ++)
		{
			
			 int swapPos = setOffset + RandomSequencePos();


			 int tetriminoBuffer = mNextPiecesBag[setOffset + j];

			mNextPiecesBag[setOffset + j] = mNextPiecesBag[swapPos];
			mNextPiecesBag[swapPos] = tetriminoBuffer;
		}

		setOffset += Tetrimino.kTetriminoCount; 
	}

}


public int RandomSequencePos() {
 return  (int)mGenerators[(((int)ConstantsEnglishPortrait.seedTetriminoOrder == (int)ConstantsEnglishLandscape.seedTetriminoOrder) ? Constants.seedTetriminoOrder : ConstantsGetter.GetConstants().seedTetriminoOrderFct())].GetUniformShort((short)0, (short)(Tetrimino.kTetriminoCount - 1)); 
}


public short GetNextBrokenLine (int holeCount) {

	

	
	
	 int holeStepCount = 3;


	 int brokenLine = (((int)ConstantsEnglishPortrait.lineComplete == (int)ConstantsEnglishLandscape.lineComplete) ? Constants.lineComplete : ConstantsGetter.GetConstants().lineCompleteFct());
	

	for(int i = 0;i < holeCount;i ++)
	{
		
		 int holeFlag = (1<< mGenerators[TetrisState.kSeedBrokenLines].GetUniformShort((short)0, (short)((((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1)));


		
		while((brokenLine & holeFlag) == 0)
		{			


			
			if(holeFlag < (1<<holeStepCount))
			{
				holeFlag <<= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());
			}

			holeFlag >>= holeStepCount;
		}

		brokenLine &= ~holeFlag;
	}

	return  (short)brokenLine;

}


public void RunPhaseFalling (int elapsedMs) {

	

	mNextDropTimeMs -= elapsedMs;




while(mNextDropTimeMs <= 0)
{
		
        if(mpFallingTetrimino.Fall())
		{
			
			if(mpFallingTetrimino.IsSoftDropping())
			{
                SoftDroppedLine();

				
				mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventSoftDrop, mPlayTimeMs);
			}
		}
		
		if(!mpFallingTetrimino.CanFall())
		{
			mGamePhase = kPhaseLock;

			
			
			if(mLastFeltRow < mpFallingTetrimino.GetMatrixPosY())
			{
				mLastFeltRow = mpFallingTetrimino.GetMatrixPosY();

				
				mExtendedLockDownRemainingMoves = (((int)ConstantsEnglishPortrait.extendedLockDownMoveCount == (int)ConstantsEnglishLandscape.extendedLockDownMoveCount) ? Constants.extendedLockDownMoveCount : ConstantsGetter.GetConstants().extendedLockDownMoveCountFct());
				ResetLockDownDelay();
			}
			else if(mExtendedLockDownRemainingMoves == 0)
			{
				
				LockTetrimino();
			}
		}

		mNextDropTimeMs += ValidateFallSpeed(mpFallingTetrimino.IsSoftDropping() ? mPieceFallRate / (((int)ConstantsEnglishPortrait.softDropMultFactor == (int)ConstantsEnglishLandscape.softDropMultFactor) ? Constants.softDropMultFactor : ConstantsGetter.GetConstants().softDropMultFactorFct()) : mPieceFallRate);
	}	

}


public void RunPhaseHardDropped (int elapsedMs) {

	


	
	
	mHardDropDelayMs -= elapsedMs;

	if(mHardDropDelayMs <= 0&& !mpWell.IsDoingAnimation())
	{
		LockTetrimino();
	}

}


public void RunPhaseLock (int elapsedMs) {

	



	mLockDownDelayMs -= elapsedMs;

	
	
	if(mpFallingTetrimino.CanFall())
	{
		mGamePhase = kPhaseFalling;
	}
	else if(mLockDownDelayMs <= 0)
	{






{
			LockTetrimino();
		}
	}

}


public void LockTetrimino () {

	

	
	mLockOut = mpFallingTetrimino.Lock();

	mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventTetriminoLock, mPlayTimeMs);

	
	mClearedLineCount = Well.GetClearedLineCountFromFlags(mpWell.ComputeClearedLines(false));





mGamePhase = kPhaseLocked;

}


public void ClearLines () {

	


	
	if(IsCurrentTetriminoTSpin())
	{
		
		if(CheckForTSpin())
		{
			mpWell.SetLastShotTSpinPos(mpFallingTetrimino.GetMatrixPosX(), mpFallingTetrimino.GetMatrixPosY());
		}
		else
		{
			
            SetIsCurrentTetriminoTSpin(false);			
		}		
	}
	else
	{
		mpWell.ResetLastShotTSpinPos();
	}

	
	 int clearedLinesFlags = mpWell.ComputeClearedLines(true);



LockResult(mClearedLineCount, IsCurrentTetriminoTSpin());
mGamePhase = kPhaseLinesCleared;






}


public void AddLines () {

	



	
	mLockCount++;

	 TetrisState tetrisState = GetTetrisState();










 int gameOver = kGameNotOver;


	
	if(mLockOut)
	{		
		gameOver = kGameOverLockOut;
	}

	if(gameOver == kGameNotOver)
	{
		 Tetrimino pNextTetrimino = PeekNextPiece();

		
		if(!pNextTetrimino.IsFree(0, 0, pNextTetrimino.GetFacingDir()))
		{
			
			gameOver = kGameOverBlockOut;
		}
	}

	
	if(gameOver == kGameNotOver)
	{		
		if(tetrisState.GetGameMode() == TetrisState.kModeMarathon)
		{
			
			if(GetLineCount() >= (((int)ConstantsEnglishPortrait.marathonLineLimit == (int)ConstantsEnglishLandscape.marathonLineLimit) ? Constants.marathonLineLimit : ConstantsGetter.GetConstants().marathonLineLimitFct()))
			{
				gameOver = kGameOverNoLinesLeft;
			}
		}
		else if(tetrisState.IsGameModeDecLine())
		{
			
			if(GetLineCount() >= 0)
			{
				
				SetLineCount(0);

				gameOver = kGameOverNoLinesLeft;
			}
		}		
	}










if(gameOver == kGameNotOver && mGameTimeExpired && tetrisState.IsGameModeUsingTimeLimit())
	{
		gameOver = kGameOverNoTimeLeft;
	}






if(gameOver != kGameNotOver)
	{		
		OnGameOver(gameOver);		
	}

	
	mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventEndTurn, mPlayTimeMs);

	mGamePhase = kPhaseLinesAdded;

}


public int CalcScore (int multFactor, int level) {

	

	return  multFactor * level;

}


public void CheckLevelUp () {
	
	


while(mGoal <= 0&& mLevel < (((int)ConstantsEnglishPortrait.maxLevel == (int)ConstantsEnglishLandscape.maxLevel) ? Constants.maxLevel : ConstantsGetter.GetConstants().maxLevelFct()))
	{
		LevelUp();
	}

}


public void LevelUp () {
	
	


mLevel++;	
	mGoal += (((int)ConstantsEnglishPortrait.goalNbLineStart == (int)ConstantsEnglishLandscape.goalNbLineStart) ? Constants.goalNbLineStart : ConstantsGetter.GetConstants().goalNbLineStartFct()) + mLevel * (((int)ConstantsEnglishPortrait.goalLevelMultiplicationFactor == (int)ConstantsEnglishLandscape.goalLevelMultiplicationFactor) ? Constants.goalLevelMultiplicationFactor : ConstantsGetter.GetConstants().goalLevelMultiplicationFactorFct());

	mpTetrisPlayer.OnGameEvent(TetrisPlayer.kEventLevelUp, mPlayTimeMs);







}


public int LockResult (int nbLines, boolean lockTSpin) {

	

	 int multFactor = 0;

	 int nbLineAttack = 0;


	mGameSpecialStatus = kNone;
switch(nbLines) 
	{
		case 0 :
			
			if(lockTSpin)
			{
				multFactor = (((int)ConstantsEnglishPortrait.tSpinNoLineLockScore == (int)ConstantsEnglishLandscape.tSpinNoLineLockScore) ? Constants.tSpinNoLineLockScore : ConstantsGetter.GetConstants().tSpinNoLineLockScoreFct());

				mGameSpecialStatus = kTSpin;
}
			break;
		case 1 :
			if(lockTSpin)
			{
				multFactor = (((int)ConstantsEnglishPortrait.tSpinSingleLineLockScore == (int)ConstantsEnglishLandscape.tSpinSingleLineLockScore) ? Constants.tSpinSingleLineLockScore : ConstantsGetter.GetConstants().tSpinSingleLineLockScoreFct());
				nbLineAttack = (((int)ConstantsEnglishPortrait.tSpinSingleLineAttack == (int)ConstantsEnglishLandscape.tSpinSingleLineAttack) ? Constants.tSpinSingleLineAttack : ConstantsGetter.GetConstants().tSpinSingleLineAttackFct());

				mGameSpecialStatus = kTSpinSingle;
}
			else
			{
				multFactor = (((int)ConstantsEnglishPortrait.singleLineLockScore == (int)ConstantsEnglishLandscape.singleLineLockScore) ? Constants.singleLineLockScore : ConstantsGetter.GetConstants().singleLineLockScoreFct());				
			}
			break;
		case 2 :
			if(lockTSpin)
			{
				multFactor = (((int)ConstantsEnglishPortrait.tSpinDoubleLineLockScore == (int)ConstantsEnglishLandscape.tSpinDoubleLineLockScore) ? Constants.tSpinDoubleLineLockScore : ConstantsGetter.GetConstants().tSpinDoubleLineLockScoreFct());
				nbLineAttack = (((int)ConstantsEnglishPortrait.tSpinDoubleLineAttack == (int)ConstantsEnglishLandscape.tSpinDoubleLineAttack) ? Constants.tSpinDoubleLineAttack : ConstantsGetter.GetConstants().tSpinDoubleLineAttackFct());

				mGameSpecialStatus = kTSpinDouble;
}
			else
			{
				multFactor = (((int)ConstantsEnglishPortrait.doubleLineLockScore == (int)ConstantsEnglishLandscape.doubleLineLockScore) ? Constants.doubleLineLockScore : ConstantsGetter.GetConstants().doubleLineLockScoreFct());
				nbLineAttack = (((int)ConstantsEnglishPortrait.doubleLineAttack == (int)ConstantsEnglishLandscape.doubleLineAttack) ? Constants.doubleLineAttack : ConstantsGetter.GetConstants().doubleLineAttackFct());
			}			
			break;
		case 3 :
			multFactor = (((int)ConstantsEnglishPortrait.tripleLineLockScore == (int)ConstantsEnglishLandscape.tripleLineLockScore) ? Constants.tripleLineLockScore : ConstantsGetter.GetConstants().tripleLineLockScoreFct());
			nbLineAttack = (((int)ConstantsEnglishPortrait.tripleLineAttack == (int)ConstantsEnglishLandscape.tripleLineAttack) ? Constants.tripleLineAttack : ConstantsGetter.GetConstants().tripleLineAttackFct());
			break;
		case 4 :
			multFactor = (((int)ConstantsEnglishPortrait.tetrisLineLockScore == (int)ConstantsEnglishLandscape.tetrisLineLockScore) ? Constants.tetrisLineLockScore : ConstantsGetter.GetConstants().tetrisLineLockScoreFct());
			nbLineAttack = (((int)ConstantsEnglishPortrait.tetrisLineAttack == (int)ConstantsEnglishLandscape.tetrisLineAttack) ? Constants.tetrisLineAttack : ConstantsGetter.GetConstants().tetrisLineAttackFct());

			mGameSpecialStatus = kTetris;
break;
	}

	 boolean backToBackDone = false;


	
	if(nbLines == 4|| (lockTSpin && nbLines > 0))
	{
		if(mBackToBackPossible)
		{


			
			multFactor += (multFactor * (((int)ConstantsEnglishPortrait.backToBackBonus == (int)ConstantsEnglishLandscape.backToBackBonus) ? Constants.backToBackBonus : ConstantsGetter.GetConstants().backToBackBonusFct())) / (((int)ConstantsEnglishPortrait.toFP16 == (int)ConstantsEnglishLandscape.toFP16) ? Constants.toFP16 : ConstantsGetter.GetConstants().toFP16Fct());
			nbLineAttack += (((int)ConstantsEnglishPortrait.backToBackLineAttack == (int)ConstantsEnglishLandscape.backToBackLineAttack) ? Constants.backToBackLineAttack : ConstantsGetter.GetConstants().backToBackLineAttackFct());

			backToBackDone = true;

			mGameSpecialStatus = (int)(mGameSpecialStatus + (((int)ConstantsEnglishPortrait.backToBackStatusOffset == (int)ConstantsEnglishLandscape.backToBackStatusOffset) ? Constants.backToBackStatusOffset : ConstantsGetter.GetConstants().backToBackStatusOffsetFct()));
}
		
		mBackToBackPossible = true;
	}
	else if(nbLines != 0) 
	{
		mBackToBackPossible = false;
	}






mpWell.SetLastShotBackToBack(backToBackDone);

	mLineCount += nbLines;
	{
		 int scoreVariation = CalcScore(multFactor, mLevel);

		if(scoreVariation != 0)
		{
			SetScore(GetScore() + scoreVariation);
		}
	}
	

	mGoal -= nbLines;

	
	if(GetTetrisState().IsGameModeLevelingUp())
	{		
		CheckLevelUp();
	}	

	return  nbLineAttack;

}


public TetrisState GetTetrisState () {

	return  GetApp().GetTetrisState();

}


public static TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public Tetrimino CreateTetrimino (int newPieceType) {
	
	

	 Tetrimino createdTetrimino = null;
	 Tetrimino poolRoot = mpTetriminoPool[newPieceType];
	
	
	if(poolRoot == null)
	{
		
		createdTetrimino = Tetrimino.CreateTetrimino(newPieceType, mpWell);
	}
	else
	{
		
		if(poolRoot.IsLastInPool())
		{
			mpTetriminoPool[newPieceType] = null;
		}

		
		mpTetriminoPool[newPieceType] = poolRoot.GetPooledTetrimino(mpWell);  
		createdTetrimino = poolRoot;
	}
	
	return  createdTetrimino; 

}


public void ReleaseTetrimino (Tetrimino tetrimino) {

	

	if(tetrimino != null)
	{
		if(mpTetriminoPool[tetrimino.GetType()] == null)
		{

			
			
			mpTetriminoPool[tetrimino.GetType()] = tetrimino;
		}
		else
		{			
			tetrimino.AddToTetriminoPool(mpTetriminoPool[tetrimino.GetType()]);
			mpTetriminoPool[tetrimino.GetType()] = tetrimino; 
		}		
	}

}


public int GetFallRateForLevel (int level) {

	

	switch(level)
	{
	case 1 : return  (((int)ConstantsEnglishPortrait.fallRateLevel01 == (int)ConstantsEnglishLandscape.fallRateLevel01) ? Constants.fallRateLevel01 : ConstantsGetter.GetConstants().fallRateLevel01Fct());
	case 2 : return  (((int)ConstantsEnglishPortrait.fallRateLevel02 == (int)ConstantsEnglishLandscape.fallRateLevel02) ? Constants.fallRateLevel02 : ConstantsGetter.GetConstants().fallRateLevel02Fct());
	case 3 : return  (((int)ConstantsEnglishPortrait.fallRateLevel03 == (int)ConstantsEnglishLandscape.fallRateLevel03) ? Constants.fallRateLevel03 : ConstantsGetter.GetConstants().fallRateLevel03Fct());
	case 4 : return  (((int)ConstantsEnglishPortrait.fallRateLevel04 == (int)ConstantsEnglishLandscape.fallRateLevel04) ? Constants.fallRateLevel04 : ConstantsGetter.GetConstants().fallRateLevel04Fct());
	case 5 : return  (((int)ConstantsEnglishPortrait.fallRateLevel05 == (int)ConstantsEnglishLandscape.fallRateLevel05) ? Constants.fallRateLevel05 : ConstantsGetter.GetConstants().fallRateLevel05Fct());
	case 6 : return  (((int)ConstantsEnglishPortrait.fallRateLevel06 == (int)ConstantsEnglishLandscape.fallRateLevel06) ? Constants.fallRateLevel06 : ConstantsGetter.GetConstants().fallRateLevel06Fct());
	case 7 : return  (((int)ConstantsEnglishPortrait.fallRateLevel07 == (int)ConstantsEnglishLandscape.fallRateLevel07) ? Constants.fallRateLevel07 : ConstantsGetter.GetConstants().fallRateLevel07Fct());
	case 8 : return  (((int)ConstantsEnglishPortrait.fallRateLevel08 == (int)ConstantsEnglishLandscape.fallRateLevel08) ? Constants.fallRateLevel08 : ConstantsGetter.GetConstants().fallRateLevel08Fct());
	case 9 : return  (((int)ConstantsEnglishPortrait.fallRateLevel09 == (int)ConstantsEnglishLandscape.fallRateLevel09) ? Constants.fallRateLevel09 : ConstantsGetter.GetConstants().fallRateLevel09Fct());
	case 10 : return  (((int)ConstantsEnglishPortrait.fallRateLevel10 == (int)ConstantsEnglishLandscape.fallRateLevel10) ? Constants.fallRateLevel10 : ConstantsGetter.GetConstants().fallRateLevel10Fct());
	case 11 : return  (((int)ConstantsEnglishPortrait.fallRateLevel11 == (int)ConstantsEnglishLandscape.fallRateLevel11) ? Constants.fallRateLevel11 : ConstantsGetter.GetConstants().fallRateLevel11Fct());
	case 12 : return  (((int)ConstantsEnglishPortrait.fallRateLevel12 == (int)ConstantsEnglishLandscape.fallRateLevel12) ? Constants.fallRateLevel12 : ConstantsGetter.GetConstants().fallRateLevel12Fct());
	case 13 : return  (((int)ConstantsEnglishPortrait.fallRateLevel13 == (int)ConstantsEnglishLandscape.fallRateLevel13) ? Constants.fallRateLevel13 : ConstantsGetter.GetConstants().fallRateLevel13Fct());
	case 14 : return  (((int)ConstantsEnglishPortrait.fallRateLevel14 == (int)ConstantsEnglishLandscape.fallRateLevel14) ? Constants.fallRateLevel14 : ConstantsGetter.GetConstants().fallRateLevel14Fct());
	case 15 : return  (((int)ConstantsEnglishPortrait.fallRateLevel15 == (int)ConstantsEnglishLandscape.fallRateLevel15) ? Constants.fallRateLevel15 : ConstantsGetter.GetConstants().fallRateLevel15Fct());
	default :

	}

	
	return  0;

}


public static int ValidateFallSpeed (int nextFallTimeMs) {

	

	
	if(nextFallTimeMs < (((int)ConstantsEnglishPortrait.maxfallRate == (int)ConstantsEnglishLandscape.maxfallRate) ? Constants.maxfallRate : ConstantsGetter.GetConstants().maxfallRateFct()))
	{
		nextFallTimeMs = (((int)ConstantsEnglishPortrait.maxfallRate == (int)ConstantsEnglishLandscape.maxfallRate) ? Constants.maxfallRate : ConstantsGetter.GetConstants().maxfallRateFct());
	}

	return  nextFallTimeMs;

}


public void ResetLockDownDelay() {
 mLockDownDelayMs = (((int)ConstantsEnglishPortrait.lockDownDelay == (int)ConstantsEnglishLandscape.lockDownDelay) ? Constants.lockDownDelay : ConstantsGetter.GetConstants().lockDownDelayFct()); 
}


public void ResetHardDropDelay() {
 mHardDropDelayMs = (((int)ConstantsEnglishPortrait.hardDropDelay == (int)ConstantsEnglishLandscape.hardDropDelay) ? Constants.hardDropDelay : ConstantsGetter.GetConstants().hardDropDelayFct()); 
}


public boolean CheckForTSpin () {

	

	
	if(mpFallingTetrimino.GetType() != Tetrimino.kTetriminoT)
	{	
		return  false;
	}

	 short lockDownX = mpFallingTetrimino.GetMatrixPosX();

	 short lockDownY = mpFallingTetrimino.GetMatrixPosY();


	
	if(lockDownX < 1|| lockDownX >= (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct()) - 1|| 
		lockDownY >= (((int)ConstantsEnglishPortrait.wellHeight == (int)ConstantsEnglishLandscape.wellHeight) ? Constants.wellHeight : ConstantsGetter.GetConstants().wellHeightFct()) - 1)
	{
		return  false;
	}

	
	 boolean cornerMinoSouthWest = mpWell.IsBlockUsed(lockDownX - 1, lockDownY + 1);

	 boolean cornerMinoSouthEast = mpWell.IsBlockUsed(lockDownX + 1, lockDownY + 1);

	 boolean cornerMinoNorthWest = mpWell.IsBlockUsed(lockDownX - 1, lockDownY - 1);

	 boolean cornerMinoNorthEast = mpWell.IsBlockUsed(lockDownX + 1, lockDownY - 1);


	 int cornerUsedCount = 0;

	if(cornerMinoSouthWest) { cornerUsedCount++; }
	if(cornerMinoSouthEast) { cornerUsedCount++; }
	if(cornerMinoNorthWest) { cornerUsedCount++; }
	if(cornerMinoNorthEast) { cornerUsedCount++; }

	
	return  cornerUsedCount >= 3;

}


public void SoftDroppedLine () {

	

	
	
	if(mLastFeltRow < mpFallingTetrimino.GetMatrixPosY())
	{
		LineDropedScore((((int)ConstantsEnglishPortrait.softDropScore == (int)ConstantsEnglishLandscape.softDropScore) ? Constants.softDropScore : ConstantsGetter.GetConstants().softDropScoreFct()));    
	}

}


public TetrisPlayer mpTetrisPlayer;
public int mLevel;
public int mGoal;
public int mScore;
public int mLineCount;
public int mPieceFallRate;
public int mClearedLineCount;
public boolean mBackToBackPossible;
public int mPlayTimeMs;
public boolean mGameTimeExpired;
public boolean mCanHold;
public boolean mHardDropping;
public int mGamePhase;
public int mGameOverType;
public Well mpWell;
public Tetrimino mpFallingTetrimino;
public Tetrimino mpHoldedTetrimino;
public Tetrimino mpPlaybackTetrimino;
public Tetrimino[] mpNextPiecesQueue = new Tetrimino[(((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : -123)];

public int[] mNextPiecesBag = new int[(((int)ConstantsEnglishPortrait.nextPieceQueueSize == (int)ConstantsEnglishLandscape.nextPieceQueueSize) ? Constants.nextPieceQueueSize : -123)];

public int mNextTetriminoIndex;
public int mNextDropTimeMs;
public int mNextPlaybackTimeMs;
public int mLockDownDelayMs;
public int mHardDropDelayMs;
public int mLockCount;
public RandomGenerator[] mGenerators = RandomGenerator.InstArrayRandomGenerator((((int)ConstantsEnglishPortrait.seedCount == (int)ConstantsEnglishLandscape.seedCount) ? Constants.seedCount : -123));

public int mTetriminoSeed;
public boolean mLockOut;
public int mExtendedLockDownRemainingMoves;
public int mLastFeltRow;
public int mGameSpecialStatus;
public boolean mTSpinDone;
public Tetrimino[] mpTetriminoPool = new Tetrimino[Tetrimino.kTetriminoCount];

public TetrisGame(TetrisPlayer player)
{
	this(player, null);
}
public Tetrimino CopyTetrimino(Tetrimino dest, Tetrimino source)
{
	return CopyTetrimino(dest, source, null);
}



}

