package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisGameAction {

public final static int kActionNone = 0;
public final static int kActionMoveLeft = 1;
public final static int kActionMoveRight = 2;
public final static int kActionRotateClockwise = 3;
public final static int kActionRotateCounterClockwise = 4;
public final static int kActionSoftDrop = 5;
public final static int kActionHardDrop = 6;
public final static int kActionHold = 7;
public final static int kActionCount = 8;

public static int Inverse (int action) {

	switch(action)
	{
	case TetrisGameAction.kActionHardDrop :
		return  TetrisGameAction.kActionSoftDrop;
	case TetrisGameAction.kActionHold :
		return  TetrisGameAction.kActionHold;
	case TetrisGameAction.kActionMoveLeft :
		return  TetrisGameAction.kActionMoveRight;
	case TetrisGameAction.kActionMoveRight :
		return  TetrisGameAction.kActionMoveLeft;
	case TetrisGameAction.kActionRotateClockwise :
		return  TetrisGameAction.kActionRotateCounterClockwise;
	case TetrisGameAction.kActionRotateCounterClockwise :
		return  TetrisGameAction.kActionRotateClockwise;
	case TetrisGameAction.kActionSoftDrop :
		return  TetrisGameAction.kActionHardDrop;
	default :

		return  TetrisGameAction.kActionNone;
	}

}



/* One dimension array */
public static TetrisGameAction[] InstArrayTetrisGameAction(int size) {
	TetrisGameAction[] newArray = new TetrisGameAction[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TetrisGameAction();
	return newArray; }

/* Two dimension array */
public static TetrisGameAction[][] InstArrayTetrisGameAction(int size1, int size2) {
	TetrisGameAction[][] newArray = new TetrisGameAction[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisGameAction[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TetrisGameAction(); }
	return newArray; }

/* Three dimension array */
public static TetrisGameAction[][][] InstArrayTetrisGameAction(int size1, int size2, int size3) {
	TetrisGameAction[][][] newArray = new TetrisGameAction[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisGameAction[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TetrisGameAction[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TetrisGameAction(); } }
	return newArray; }

public TetrisGameAction () { 
}




}

