package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class TetrisInputControler extends InputControler {

public TetrisInputControler() {
  
}


public InputMapping GetMapping() {
 ; return mMapping; 
}


public void SetMapping(TetrisInputMapping mapping) {
 mMapping = mapping; 
}


public void OnActionRepeat (int actionId, int nthRepeatInThisOnTime) {

	 int action = (int)actionId;


	TetrisPlayer player = null;

	if(action == TetrisGameAction.kActionNone || (player = GetPlayer()) == null)
	{
		return ;
	}

	if(MustInverseActions())
	{
		action = TetrisGameAction.Inverse(action);
	}

	if (action == TetrisGameAction.kActionMoveLeft ||
		action == TetrisGameAction.kActionMoveRight)
	{
		 int actionLeftPressCount = mMapping.GetActionField(TetrisGameAction.kActionMoveLeft, InputMapping.kActionKeyDownCounter);

		 int actionRightPressCount = mMapping.GetActionField(TetrisGameAction.kActionMoveRight, InputMapping.kActionKeyDownCounter);


		 boolean leftPressed = actionLeftPressCount > 0;

		 boolean rightPressed = actionRightPressCount > 0;

		if(leftPressed != rightPressed) 
		{
			player.OnActionRepeat(action, nthRepeatInThisOnTime);
		}
	}
	else
	{
		player.OnActionRepeat(action, nthRepeatInThisOnTime);
	}

}


public void OnActionPressed (int actionId, int pressCount) {

	 int action = (int)actionId;


	TetrisPlayer player = null;

	if(action == TetrisGameAction.kActionNone || (player = GetPlayer()) == null)
	{
		return ;
	}

	if(MustInverseActionsRefresh())
	{
		action = TetrisGameAction.Inverse(action);
	}

	if (action == TetrisGameAction.kActionMoveLeft ||
		action == TetrisGameAction.kActionMoveRight)
	{
		 int actionLeftPressCount = mMapping.GetActionField(TetrisGameAction.kActionMoveLeft, InputMapping.kActionKeyDownCounter);

		 int actionRightPressCount = mMapping.GetActionField(TetrisGameAction.kActionMoveRight, InputMapping.kActionKeyDownCounter);


		
		if(actionLeftPressCount + actionRightPressCount == 1)
		{
			player.OnActionPressed(action, pressCount);
		}
	}
	else
	{
		player.OnActionPressed(action, pressCount);
	}

}


public void OnActionReleased (int actionId, int pressCount) {

	 int action = (int)actionId;


	TetrisPlayer player = null;

	if(action == TetrisGameAction.kActionNone || (player = GetPlayer()) == null)
	{
		return ;
	}

	if(MustInverseActions())
	{
		action = TetrisGameAction.Inverse(action);
	}

	player.OnActionReleased(action, pressCount);

}


public void OnDisabled () {

	GetPlayer().GetGameState().SetSoftDropActive(false);
	super.OnDisabled();

}


public TetrisPlayer GetPlayer () {

	return  GetTetrisState().GetPlayer(TetrisState.kPlayer1);

}


public TetrisState GetTetrisState () {

	return  GetApp().GetTetrisState();

}


public TetrisApp GetApp () {

	return  TetrisApp.Get();

}


public boolean MustInverseActions () {

	return  false;

}


public boolean MustInverseActionsRefresh () {




return  false;

}


public TetrisInputMapping mMapping;

/* One dimension array */
public static TetrisInputControler[] InstArrayTetrisInputControler(int size) {
	TetrisInputControler[] newArray = new TetrisInputControler[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new TetrisInputControler();
	return newArray; }

/* Two dimension array */
public static TetrisInputControler[][] InstArrayTetrisInputControler(int size1, int size2) {
	TetrisInputControler[][] newArray = new TetrisInputControler[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisInputControler[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new TetrisInputControler(); }
	return newArray; }

/* Three dimension array */
public static TetrisInputControler[][][] InstArrayTetrisInputControler(int size1, int size2, int size3) {
	TetrisInputControler[][][] newArray = new TetrisInputControler[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new TetrisInputControler[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new TetrisInputControler[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new TetrisInputControler(); } }
	return newArray; }



}

