package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class Ticker extends TimeControlled {

public  Ticker (int activationTimeMs) {
mkActivatitionTimeMs = (activationTimeMs);



}


public void destruct() {


}


public void SetTickerViewport (Viewport newTickerViewport) {

	mActivated = false;
	mTrackingTime = 0;

	 boolean previousTickerIsNull = (mTicker == null);

	if(previousTickerIsNull)
	{
		if(newTickerViewport == null)
		{
			return ;
		}
	}
	else
	{
		
		if(newTickerViewport == mTicker)
		{
			return ;
		}

		

		for(int i = 0;i < mTicker.GetChildCount();i ++)
		{
			mTicker.GetChild(i).SetRect(mInitialChildPos[i]);
		}
		mInitialChildPos = null;
		mTicker = null;

		if(newTickerViewport == null)
		{
			UnRegisterInGlobalTime();
			return ;
		}
	}

	 int childCount = newTickerViewport.GetChildCount();

	mInitialChildPos = FlRect.InstArrayFlRect(childCount);

	 short minChildLeft = 0;

	for(int i = 0;i < childCount;i ++)
	{
		 FlRect childRect = newTickerViewport.GetChild(i).GetRect();

		mInitialChildPos[i].Assign(childRect);
		 short childLeft = childRect.GetLeft();

		if(i == 0|| childLeft < minChildLeft)
		{
			minChildLeft = childLeft;
		}
	}

	 short contentWidth = GetViewportContentWidth(newTickerViewport);

	 short rectWidth = newTickerViewport.GetRectWidth();

	if(contentWidth > rectWidth)
	{
		MoveViewportChildrensBy(newTickerViewport, (short)(-minChildLeft), (short)0);
		RegisterInGlobalTime();
	}
	else
	{
		UnRegisterInGlobalTime();
	}
	mTicker = newTickerViewport;

}


public void OnTime (int totalTime, int deltaTime) {




	mTrackingTime += deltaTime;
	if(!mActivated)
	{
		if(mTrackingTime >= mkActivatitionTimeMs)
		{
			mTrackingTime = 0;
			mActivated = true;
		}
	}
	else
	{
		 short tickerMovement = 0;

		while(mTrackingTime >= (((int)ConstantsEnglishPortrait.tickerSliceOfTimeDuration == (int)ConstantsEnglishLandscape.tickerSliceOfTimeDuration) ? Constants.tickerSliceOfTimeDuration : ConstantsGetter.GetConstants().tickerSliceOfTimeDurationFct()))
		{
			tickerMovement = (short)(tickerMovement - (((int)ConstantsEnglishPortrait.tickerMoveBySliceOfTime == (int)ConstantsEnglishLandscape.tickerMoveBySliceOfTime) ? Constants.tickerMoveBySliceOfTime : ConstantsGetter.GetConstants().tickerMoveBySliceOfTimeFct()));
			mTrackingTime = (short)(mTrackingTime - (((int)ConstantsEnglishPortrait.tickerSliceOfTimeDuration == (int)ConstantsEnglishLandscape.tickerSliceOfTimeDuration) ? Constants.tickerSliceOfTimeDuration : ConstantsGetter.GetConstants().tickerSliceOfTimeDurationFct()));
		}

		MoveViewportChildrensBy(mTicker, (short)tickerMovement, (short)0);
		 int maxChildRight = -1;

		for(int i = 0;i < mTicker.GetChildCount();i ++)
		{
			 Component tickerChild = mTicker.GetChild(i);
			 FlRect childRect = new FlRect(tickerChild.GetRect());

			 short childRight = childRect.GetRight();

			if(childRight > maxChildRight)
			{
				maxChildRight = childRight;
			}
		}


		 boolean tickerNeedReset = (maxChildRight < 0);

		if(tickerNeedReset)
		{
			 short tickerOffsetX = (short)(mTicker.GetRectWidth() + (((int)ConstantsEnglishPortrait.tickerRestartOffsetX == (int)ConstantsEnglishLandscape.tickerRestartOffsetX) ? Constants.tickerRestartOffsetX : ConstantsGetter.GetConstants().tickerRestartOffsetXFct()));

			 short contentWidth = GetViewportContentWidth(mTicker);

			MoveViewportChildrensBy(mTicker, (short)(contentWidth + tickerOffsetX), (short)0);
		}
	}

}


public static void MoveViewportChildrensBy (Viewport viewport, short dx, short dy) {

	 int childCount = viewport.GetChildCount();

	for(int i = 0;i < childCount;i ++)
	{
		 Component tickerChild = viewport.GetChild(i);
		 FlRect childRect = new FlRect(tickerChild.GetRect());

		childRect.MoveBy(dx, dy);
		tickerChild.SetRect(childRect);
	}

}


public static short GetViewportContentWidth (Viewport viewport) {

	 int childCount = viewport.GetChildCount();

	 short minChildLeft = 0;

	 short maxChildRight = 0;

	for(int i = 0;i < childCount;i ++)
	{
		 FlRect childRect = new FlRect(viewport.GetChild(i).GetRect());

		 short childLeft = childRect.GetLeft();

		 short childRight = childRect.GetRight();


		if(i == 0|| childLeft < minChildLeft)
		{
			minChildLeft = childLeft;
		}
		if(i == 0|| childRight > maxChildRight)
		{
			maxChildRight = childRight;
		}
	}

	 short contentWidth = (short)(maxChildRight - minChildLeft);

	return  contentWidth;

}


public Viewport mTicker;
public FlRect[] mInitialChildPos = null;
public boolean mActivated;
public int mTrackingTime;
public int mkActivatitionTimeMs;



}

