package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class WellLine {

public WellLine () {
	
	Clear();

}


public void destruct() {
	

}


public void Clear () {

	mBlockFlags = 0;
	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());i ++) 
	{
		mBlocks[i] = 0;

		mSticky[i] = 0;
}

}


public void Assign ( WellLine src) {

	mBlockFlags = src.mBlockFlags;
	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());i ++) 
	{
		mBlocks[i] = src.mBlocks[i];


		mSticky[i] = src.mSticky[i];
}

}


public boolean IsBlockUsed (int column) {



	return  (mBlockFlags & (1<< column)) != 0;

}


public boolean IsMaskUsed (int mask) {

	return  (mBlockFlags & mask) !=0;

}


public boolean IsComplete () {

	return  mBlockFlags == (((int)ConstantsEnglishPortrait.lineComplete == (int)ConstantsEnglishLandscape.lineComplete) ? Constants.lineComplete : ConstantsGetter.GetConstants().lineCompleteFct());

}


public void SetBlock (int column, byte type, byte stick) {



	mBlocks[column] = type;	
	mBlockFlags |= 1<<column;


	mSticky[column] = stick;

}


public void ClearBlock (int column) {



	mBlocks[column] = 0;
	mBlockFlags &= ~(1<<column);


	mSticky[column] = 0;

}


public void SetLineFromMask (short lineMask) {

	mBlockFlags = 0;

	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());i ++)
	{
		if((lineMask & (1<< i)) != 0)
		{			
			SetBlock(i, (byte)(((int)ConstantsEnglishPortrait.minoTypeSolid == (int)ConstantsEnglishLandscape.minoTypeSolid) ? Constants.minoTypeSolid : ConstantsGetter.GetConstants().minoTypeSolidFct()), (byte)0);
		} 		
	}








}


public byte GetBlock (int column) {



	return  mBlocks[column];

}


public boolean HasBlock () {

	return  mBlockFlags != 0;

}


public byte GetSticky (int column) {



	return  mSticky[column];

}


public void WipeSticky (byte stick) {

	stick = (byte)~stick;
	for(int i = 0;i < (((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : ConstantsGetter.GetConstants().wellWidthFct());i ++) 
	{
		mSticky[i] &= stick;
	}

}


public void SetBlockAI (int column) {



	mBlockFlags |= 1<<column;

}


public void ClearBlockAI (int column) {



	mBlockFlags &= ~(1<<column);

}


public short mBlockFlags;
public byte[] mBlocks = new byte[(((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : -123)];

public byte[] mSticky = new byte[(((int)ConstantsEnglishPortrait.wellWidth == (int)ConstantsEnglishLandscape.wellWidth) ? Constants.wellWidth : -123)];


/* One dimension array */
public static WellLine[] InstArrayWellLine(int size) {
	WellLine[] newArray = new WellLine[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new WellLine();
	return newArray; }

/* Two dimension array */
public static WellLine[][] InstArrayWellLine(int size1, int size2) {
	WellLine[][] newArray = new WellLine[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new WellLine[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new WellLine(); }
	return newArray; }

/* Three dimension array */
public static WellLine[][][] InstArrayWellLine(int size1, int size2, int size3) {
	WellLine[][][] newArray = new WellLine[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new WellLine[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new WellLine[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new WellLine(); } }
	return newArray; }



}

