package ca.jamdat.tetris;

import ca.jamdat.flight.*;
import ca.jamdat.fuser.*;
import ca.jamdat.flight.String;
import ca.jamdat.flight.Package;


public class WindowViewport extends Viewport {

public WindowViewport () {

	mOriginalRect_left = mOriginalRect_top = mOriginalRect_width = mOriginalRect_height = (short)0;;
	SetClipChildren(true);

}


public void destruct() {


}


public void ControlValue (int valueCode, boolean setValue, Controller controller) {

	if(valueCode == (((int)ConstantsEnglishPortrait.windowViewportRect == (int)ConstantsEnglishLandscape.windowViewportRect) ? Constants.windowViewportRect : ConstantsGetter.GetConstants().windowViewportRectFct()))
	{
		if(setValue)
		{
			 FlRect rect = controller.GetRectValue();
			 short topLeftOffsetX = rect.GetLeft();

			 short topLeftOffsetY = rect.GetTop();

			 short bottomRightOffsetX = rect.GetWidth();

			 short bottomRightOffsetY = rect.GetHeight();


			SetTopLeft((short)(mOriginalRect_left + topLeftOffsetX), (short)(mOriginalRect_top + topLeftOffsetY));
			SetSize((short)(mOriginalRect_width - topLeftOffsetX + bottomRightOffsetX), (short)(mOriginalRect_height - topLeftOffsetY + bottomRightOffsetY));
			OffsetTo(topLeftOffsetX, topLeftOffsetY);
		}
		else
		{
			controller.SetValue((short)0, (short)0, (short)0, (short)0);
			Reset();

		}
	}
	else
	{
		super.ControlValue(valueCode, setValue, controller);
	}

}


public void Reset () {

	
	mOriginalRect_left = mRect_left; mOriginalRect_top = mRect_top; mOriginalRect_width = mRect_width; mOriginalRect_height = mRect_height;;

}


public short mOriginalRect_left;
public short mOriginalRect_top;
public short mOriginalRect_width;
public short mOriginalRect_height;

/* One dimension array */
public static WindowViewport[] InstArrayWindowViewport(int size) {
	WindowViewport[] newArray = new WindowViewport[size];
	for(int i = 0 ; i < size ; i++) newArray[i] = new WindowViewport();
	return newArray; }

/* Two dimension array */
public static WindowViewport[][] InstArrayWindowViewport(int size1, int size2) {
	WindowViewport[][] newArray = new WindowViewport[size1][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new WindowViewport[size2];
		for(int j = 0 ; j < size2 ; j++) newArray[i][j] = new WindowViewport(); }
	return newArray; }

/* Three dimension array */
public static WindowViewport[][][] InstArrayWindowViewport(int size1, int size2, int size3) {
	WindowViewport[][][] newArray = new WindowViewport[size1][][];
	for(int i = 0 ; i < size1 ; i++) {
		newArray[i] = new WindowViewport[size2][];
		for(int j = 0 ; j < size2 ; j++) {
			newArray[i][j] = new WindowViewport[size3];
			for(int k = 0 ; k < size3 ; k++) newArray[i][j][k] = new WindowViewport(); } }
	return newArray; }



}

